package com.enus.myzik;

import android.content.BroadcastReceiver;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore.Video.Media;
import android.provider.MediaStore.Video.Thumbnails;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import java.io.File;
import java.text.Normalizer;
import java.text.Normalizer.Form;
import java.util.ArrayList;
import java.util.Arrays;
import org.teleal.cling.model.message.header.EXTHeader;

public class Add_Video_Activity extends MzActivity {
    static final int STATE_DONE = 0;
    static final int STATE_RUNNING = 1;
    static final int STATE_STOP = 2;
    private CustomVideoAdapter_Button Adapter;
    private ArrayList<CustomListItem> Items;
    private final BroadcastReceiver brMS = new C00411();
    Context mContext;
    ContentResolver mCr;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDoneClickListener = new C00422();
    final Handler mHandlerV = new C00433();
    ProgressThread m_Thread = null;
    ListView mlvList;
    TextView mtvText;
    private int nType = 0;
    private String strListName = EXTHeader.DEFAULT_VALUE;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    class C00411 extends BroadcastReceiver {
        C00411() {
        }

        public void onReceive(Context context, Intent intent) {
            if (intent.getAction().equals("android.intent.action.MEDIA_SCANNER_STARTED")) {
                ((MzServerApp) Add_Video_Activity.this.getApplicationContext()).ShowMsg(Add_Video_Activity.this.getApplicationContext().getString(C0181R.string.pl_msg5), 1);
                Intent intentA = new Intent(Add_Video_Activity.this, Edit_Video_Activity.class);
                intentA.putExtra("type", Add_Video_Activity.this.nType);
                intentA.putExtra("list_name", Add_Video_Activity.this.strListName);
                intentA.putExtra("table_name", Add_Video_Activity.this.strTableName);
                Add_Video_Activity.this.startActivity(intentA);
                Add_Video_Activity.this.finish();
                return;
            }
            intent.getAction().equals("android.intent.action.MEDIA_SCANNER_FINISHED");
        }
    }

    class C00422 implements OnClickListener {
        C00422() {
        }

        public void onClick(View v) {
            MzServerApp MzApp = (MzServerApp) Add_Video_Activity.this.getApplicationContext();
            if (MzApp != null) {
                MzApp.ShowMsg(Add_Video_Activity.this.getResources().getString(C0181R.string.pl_done), 1);
            }
            Intent intent = new Intent(Add_Video_Activity.this, Edit_Video_Activity.class);
            intent.putExtra("type", Add_Video_Activity.this.nType);
            intent.putExtra("list_name", Add_Video_Activity.this.strListName);
            intent.putExtra("table_name", Add_Video_Activity.this.strTableName);
            Add_Video_Activity.this.startActivity(intent);
            Add_Video_Activity.this.finish();
        }
    }

    class C00433 extends Handler {
        C00433() {
        }

        public void handleMessage(Message msg) {
            if (msg.what == 0) {
                Add_Video_Activity.this.Adapter.notifyDataSetChanged();
            } else if (msg.what == 1) {
                Add_Video_Activity.this.Adapter.notifyDataSetChanged();
            }
        }
    }

    class C00444 implements Runnable {
        C00444() {
        }

        public void run() {
            try {
                Add_Video_Activity.this.m_Thread.start();
            } catch (NullPointerException e) {
                e.printStackTrace();
            }
        }
    }

    private class ProgressThread extends Thread {
        static final int STATE_DONE = 0;
        static final int STATE_RUNNING = 1;
        static final int STATE_STOP = 2;
        Handler mHandler;
        int nState = 0;
        int nTotal = 0;

        ProgressThread(Handler h) {
            this.mHandler = h;
        }

        public void run() {
            this.nState = 1;
            this.nTotal = 0;
            this.nTotal = Add_Video_Activity.this.Items.size();
            int i = 0;
            while (i < this.nTotal) {
                if (i > 0) {
                    try {
                        if (i % 5 == 0) {
                            Thread.sleep(50);
                        }
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
                if (this.nState != 1 || Add_Video_Activity.this.m_Thread.isInterrupted()) {
                    break;
                }
                CustomListItem Item = (CustomListItem) Add_Video_Activity.this.Items.get(i);
                Bitmap bm = null;
                if (Item.getInfo4().compareTo("video/mp4") == 0) {
                    bm = Thumbnails.getThumbnail(Add_Video_Activity.this.mCr, Long.parseLong(Item.getInfo3()), 3, null);
                }
                if (bm != null) {
                    Item.setBitmap(bm);
                    Add_Video_Activity.this.Items.set(i, Item);
                }
                if (i > 0 && i % 2 == 0 && this.mHandler != null) {
                    this.mHandler.sendEmptyMessage(0);
                }
                i++;
            }
            if (this.mHandler != null) {
                this.mHandler.sendEmptyMessage(1);
            }
            this.nState = 0;
        }

        public void onInit() {
            this.nState = 0;
        }

        public void setStateType(int nState) {
            if (this.nState != 0) {
                this.nState = nState;
            }
        }

        public int getStateType() {
            return this.nState;
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.add_video);
        onInit(getApplicationContext());
        if (this.Adapter != null) {
            this.Adapter.clear();
        }
        this.Adapter = null;
        this.Adapter = new CustomVideoAdapter_Button(this.mContext, C0181R.layout.add_item, this.Items);
        this.Adapter.onInit(this.mDBManager, this.strTableName);
        this.mlvList.setEmptyView(this.mtvText);
        this.mlvList.setAdapter(this.Adapter);
        IntentFilter intentFilter4MS = new IntentFilter("android.intent.action.MEDIA_SCANNER_STARTED");
        intentFilter4MS.addAction("android.intent.action.MEDIA_SCANNER_FINISHED");
        intentFilter4MS.addDataScheme("file");
        registerReceiver(this.brMS, intentFilter4MS);
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        if (this.Adapter != null) {
            this.Adapter.recycle();
            this.Adapter.clear();
        }
        onRead();
        this.Adapter.notifyDataSetChanged();
    }

    protected void onDestroy() {
        if (this.brMS != null) {
            unregisterReceiver(this.brMS);
        }
        if (this.m_Thread != null) {
            boolean bDestroy = true;
            if (this.m_Thread.isAlive()) {
                bDestroy = false;
            }
            while (!bDestroy) {
                this.m_Thread.interrupt();
                this.m_Thread.setStateType(2);
                try {
                    this.m_Thread.join(1000);
                    bDestroy = true;
                } catch (InterruptedException e) {
                    e.printStackTrace();
                    this.m_Thread.stop();
                    this.m_Thread.destroy();
                }
            }
        }
        this.m_Thread = null;
        recursiveRecycle(getWindow().getDecorView());
        clearApplicationCache(null);
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        System.gc();
        super.onDestroy();
    }

    public void onBackPressed() {
        Intent intent = new Intent(this, Edit_Video_Activity.class);
        intent.putExtra("type", this.nType);
        intent.putExtra("list_name", this.strListName);
        intent.putExtra("table_name", this.strTableName);
        startActivity(intent);
        finish();
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mlvList = null;
        this.mtvText = null;
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        this.mlvList = (ListView) findViewById(C0181R.id.add_video_listView_Addlist);
        this.mtvText = (TextView) findViewById(C0181R.id.add_video_textView_EmptyView);
        ImageButton butDone = (ImageButton) findViewById(C0181R.id.add_video_imageButton_Done);
        if (this.mlvList == null || this.mtvText == null || butDone == null) {
            return false;
        }
        butDone.setOnClickListener(this.mDoneClickListener);
        this.Items = new ArrayList();
        this.mCr = getContentResolver();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 3) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER, " + "`thumb_path` TEXT" + ")";
        this.nType = nType;
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        this.strTableName = strTableName;
        return true;
    }

    public boolean onRead() {
        Cursor cursor;
        int nColumnIdx;
        String str;
        String[] strPaths = null;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        int i = 0;
        int nCount = this.mDBManager.onCount("(SELECT `path` FROM `" + this.strTableName + "` GROUP BY `path`) T1", EXTHeader.DEFAULT_VALUE);
        if (nCount > 0) {
            strPaths = new String[nCount];
            cursor = this.mDBManager.onSelect("SELECT `path` FROM '" + this.strTableName + "' GROUP BY `path`");
            if (cursor == null) {
                return false;
            } else if (cursor.moveToFirst()) {
                while (!cursor.isAfterLast()) {
                    nColumnIdx = cursor.getColumnIndex("path");
                    if (nColumnIdx < 0) {
                        if (strPaths != null) {
                            Arrays.fill(strPaths, null);
                        }
                        cursor.close();
                        str = strDisplayName;
                        return false;
                    }
                    strPaths[i] = cursor.getString(nColumnIdx);
                    cursor.moveToNext();
                    i++;
                }
                cursor.close();
            } else {
                str = strDisplayName;
                return false;
            }
        }
        cursor = this.mCr.query(Media.EXTERNAL_CONTENT_URI, null, null, null, null);
        if (cursor == null) {
            str = strDisplayName;
            return false;
        } else if (cursor.moveToFirst()) {
            CustomListItem Item;
            while (!cursor.isAfterLast()) {
                nColumnIdx = cursor.getColumnIndex("_display_name");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                str = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("artist");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strInfo1 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("album");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strInfo2 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("_id");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strInfo3 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("mime_type");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strInfo4 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("title");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strInfo5 = cursor.getString(nColumnIdx);
                if (strInfo5 == null) {
                    strInfo5 = str;
                } else if (strInfo5.length() <= 0) {
                    strInfo5 = str;
                }
                try {
                    if (!Normalizer.isNormalized(str, Form.NFC)) {
                        str = Normalizer.normalize(str, Form.NFC);
                    }
                    if (!Normalizer.isNormalized(strInfo5, Form.NFC)) {
                        strInfo5 = Normalizer.normalize(strInfo5, Form.NFC);
                    }
                } catch (NullPointerException e) {
                    e.printStackTrace();
                }
                nColumnIdx = cursor.getColumnIndex("_data");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strPath = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("_size");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                long nSize = cursor.getLong(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("_data");
                if (nColumnIdx < 0) {
                    if (strPaths != null) {
                        Arrays.fill(strPaths, null);
                    }
                    cursor.close();
                    return false;
                }
                strThumbPath = cursor.getString(nColumnIdx);
                Item = new CustomListItem(0, str, strInfo1, strInfo2, strInfo3, strInfo4, strInfo5, strPath, nSize, EXTHeader.DEFAULT_VALUE);
                if (strPaths != null) {
                    for (String equals : strPaths) {
                        if (equals.equals(strPath)) {
                            Item.setSelected(true);
                            break;
                        }
                    }
                }
                this.Items.add(Item);
                cursor.moveToNext();
            }
            cursor.close();
            if (strPaths != null) {
                Arrays.fill(strPaths, null);
            }
            cursor = this.mCr.query(Thumbnails.EXTERNAL_CONTENT_URI, null, null, null, null);
            if (cursor == null) {
                return false;
            }
            if (cursor.moveToFirst()) {
                while (!cursor.isAfterLast()) {
                    nColumnIdx = cursor.getColumnIndex("video_id");
                    if (nColumnIdx < 0) {
                        cursor.close();
                        return false;
                    }
                    strInfo3 = cursor.getString(nColumnIdx);
                    nColumnIdx = cursor.getColumnIndex("_data");
                    if (nColumnIdx < 0) {
                        cursor.close();
                        return false;
                    }
                    strThumbPath = cursor.getString(nColumnIdx);
                    Item = this.Adapter.getThumbItem(strInfo3);
                    if (Item != null) {
                        Item.setThumbPath(strThumbPath);
                    }
                    cursor.moveToNext();
                }
                cursor.close();
                if (this.m_Thread != null) {
                    boolean bDestroy = true;
                    if (this.m_Thread.isAlive()) {
                        bDestroy = false;
                    }
                    while (!bDestroy) {
                        this.m_Thread.interrupt();
                        this.m_Thread.setStateType(2);
                        try {
                            this.m_Thread.join(1000);
                            bDestroy = true;
                        } catch (InterruptedException e2) {
                            e2.printStackTrace();
                            this.m_Thread.stop();
                            this.m_Thread.destroy();
                        }
                    }
                }
                this.m_Thread = null;
                this.m_Thread = new ProgressThread(this.mHandlerV);
                this.m_Thread.onInit();
                this.m_Thread.setDaemon(true);
                new Handler().postDelayed(new C00444(), 500);
                return true;
            }
            cursor.close();
            return false;
        } else {
            if (strPaths != null) {
                Arrays.fill(strPaths, null);
            }
            cursor.close();
            str = strDisplayName;
            return false;
        }
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }
}
