package com.enus.myzik;

import android.content.Context;
import android.graphics.Color;
import android.net.wifi.WifiManager;
import android.os.Vibrator;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;
import java.util.ArrayList;

public class ApListInfoAdapter extends ArrayAdapter<String> {
    private ArrayList<String> items;
    private Context mContext;

    class C00491 implements OnClickListener {
        C00491() {
        }

        public void onClick(View v) {
            ((Vibrator) ApListInfoAdapter.this.mContext.getSystemService("vibrator")).vibrate(50);
            WifiManager mainWifi = (WifiManager) ApListInfoAdapter.this.mContext.getSystemService("wifi");
            ApListInfoAdapter.this.items.set(0, "00");
            ApListInfoAdapter.this.notifyDataSetChanged();
            if (mainWifi.isWifiEnabled()) {
                mainWifi.startScan();
            }
        }
    }

    class C00502 implements OnClickListener {
        C00502() {
        }

        public void onClick(View v) {
            ((Vibrator) ApListInfoAdapter.this.mContext.getSystemService("vibrator")).vibrate(50);
            WifiManager mainWifi = (WifiManager) ApListInfoAdapter.this.mContext.getSystemService("wifi");
            ApListInfoAdapter.this.items.set(0, "00");
            ApListInfoAdapter.this.notifyDataSetChanged();
            if (mainWifi.isWifiEnabled()) {
                mainWifi.startScan();
            }
        }
    }

    public ApListInfoAdapter(Context context, int textViewResourceId, ArrayList<String> items) {
        super(context, textViewResourceId, items);
        this.items = items;
        this.mContext = context;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.add_aplist_item, null);
        }
        String strItem = null;
        if (position >= 0) {
            strItem = (String) this.items.get(position);
        } else if (v != null) {
            v.setBackgroundDrawable(this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01));
        }
        if (strItem != null) {
            TextView tctext = (TextView) v.findViewById(C0181R.id.ssidtext);
            TextView tctext_tmp = (TextView) v.findViewById(C0181R.id.ssidtext_tmp);
            Button btnSearch = (Button) v.findViewById(C0181R.id.wifiesearch);
            ProgressBar pbSearch = (ProgressBar) v.findViewById(C0181R.id.wifiesearch_pb);
            tctext.setTextColor(Color.parseColor("#000000"));
            ImageView tcimg = (ImageView) v.findViewById(C0181R.id.LvIV);
            btnSearch.setOnClickListener(new C00491());
            if (position == 0) {
                tctext_tmp.setVisibility(0);
                pbSearch.setVisibility(8);
                btnSearch.setVisibility(8);
                btnSearch.setClickable(false);
                tctext.setVisibility(8);
                tcimg.setVisibility(8);
            } else {
                tctext_tmp.setVisibility(8);
                pbSearch.setVisibility(8);
                btnSearch.setVisibility(8);
                tctext.setVisibility(0);
                tcimg.setVisibility(0);
            }
            if (v != null) {
                if (position % 2 == 1) {
                    v.setBackgroundColor(Color.parseColor("#EEEEEE"));
                } else {
                    v.setBackgroundColor(Color.parseColor("#E5E5E5"));
                }
            }
            if (tctext != null) {
                tctext.setText(strItem.substring(1));
                tcimg.setImageResource(C0181R.drawable.sblank);
            }
        }
        return v;
    }

    public View getDropDownView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.add_aplist_item, null);
        }
        String strItem = null;
        if (position >= 0) {
            strItem = (String) this.items.get(position);
        } else if (v != null) {
            v.setBackgroundDrawable(this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01));
        }
        if (strItem != null) {
            TextView tctext = (TextView) v.findViewById(C0181R.id.ssidtext);
            TextView tctext_tmp = (TextView) v.findViewById(C0181R.id.ssidtext_tmp);
            tctext.setTextColor(Color.parseColor("#000000"));
            ImageView tcimg = (ImageView) v.findViewById(C0181R.id.LvIV);
            Button btnSearch = (Button) v.findViewById(C0181R.id.wifiesearch);
            ProgressBar pbSearch = (ProgressBar) v.findViewById(C0181R.id.wifiesearch_pb);
            btnSearch.setOnClickListener(new C00502());
            tctext_tmp.setVisibility(8);
            if (position == 0) {
                btnSearch.setVisibility(0);
                tctext.setVisibility(8);
                tcimg.setVisibility(8);
                if (tctext != null) {
                    switch (Integer.valueOf(strItem.substring(0, 1)).intValue()) {
                        case 0:
                            pbSearch.setVisibility(0);
                            break;
                        case 1:
                            pbSearch.setVisibility(4);
                            break;
                    }
                }
            }
            pbSearch.setVisibility(8);
            btnSearch.setVisibility(8);
            tctext.setVisibility(0);
            tcimg.setVisibility(0);
            if (v != null) {
                if (position == 0) {
                    v.setBackgroundColor(Color.parseColor("#7C7C7C"));
                } else if (position % 2 == 1) {
                    v.setBackgroundColor(Color.parseColor("#EEEEEE"));
                } else {
                    v.setBackgroundColor(Color.parseColor("#E5E5E5"));
                }
            }
            if (tctext != null) {
                tctext.setText(strItem.substring(1));
                switch (Integer.valueOf(strItem.substring(0, 1)).intValue()) {
                    case 0:
                        tcimg.setImageResource(C0181R.drawable.wifi_icon00);
                        break;
                    case 1:
                        tcimg.setImageResource(C0181R.drawable.wifi_icon01);
                        break;
                    case 2:
                        tcimg.setImageResource(C0181R.drawable.wifi_icon02);
                        break;
                    case 3:
                        tcimg.setImageResource(C0181R.drawable.wifi_icon03);
                        break;
                    case 4:
                        tcimg.setImageResource(C0181R.drawable.wifi_icon04);
                        break;
                    case 5:
                        tcimg.setImageResource(C0181R.drawable.pw_wifi_icon00);
                        break;
                    case 6:
                        tcimg.setImageResource(C0181R.drawable.pw_wifi_icon01);
                        break;
                    case 7:
                        tcimg.setImageResource(C0181R.drawable.pw_wifi_icon02);
                        break;
                    case 8:
                        tcimg.setImageResource(C0181R.drawable.pw_wifi_icon03);
                        break;
                    case 9:
                        tcimg.setImageResource(C0181R.drawable.pw_wifi_icon04);
                        break;
                }
            }
        }
        return v;
    }
}
