package com.enus.myzik;

import android.content.Context;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.ArrayList;

public class ApListSAdapter extends ArrayAdapter<String> {
    private ArrayList<String> items;
    private Context mContext;

    public ApListSAdapter(Context context, int textViewResourceId, ArrayList<String> items) {
        super(context, textViewResourceId, items);
        this.items = items;
        this.mContext = context;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        if (v == null) {
            try {
                v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.aplist_item, null);
            } catch (InflateException e) {
                e.printStackTrace();
            }
        }
        String strItem = null;
        if (position >= 0) {
            strItem = (String) this.items.get(position);
        } else if (v != null) {
            v.setBackgroundDrawable(this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01));
        }
        if (strItem != null) {
            TextView tctext = (TextView) v.findViewById(C0181R.id.ssidtext);
            ImageView tcimg = (ImageView) v.findViewById(C0181R.id.LvIV);
            if (v != null) {
                v.setBackgroundDrawable((position & 1) == 1 ? this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01) : this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02));
            }
            if (tctext != null) {
                tctext.setText(strItem.substring(1));
                switch (Integer.valueOf(strItem.substring(0, 1)).intValue()) {
                    case 0:
                        tcimg.setImageResource(C0181R.drawable.wifi00);
                        break;
                    case 1:
                        tcimg.setImageResource(C0181R.drawable.wifi01);
                        break;
                    case 2:
                        tcimg.setImageResource(C0181R.drawable.wifi02);
                        break;
                    case 3:
                        tcimg.setImageResource(C0181R.drawable.wifi03);
                        break;
                    case 4:
                        tcimg.setImageResource(C0181R.drawable.wifi04);
                        break;
                    case 5:
                        tcimg.setImageResource(C0181R.drawable.g_wifi00);
                        break;
                    case 6:
                        tcimg.setImageResource(C0181R.drawable.g_wifi01);
                        break;
                    case 7:
                        tcimg.setImageResource(C0181R.drawable.g_wifi02);
                        break;
                    case 8:
                        tcimg.setImageResource(C0181R.drawable.g_wifi03);
                        break;
                    case 9:
                        tcimg.setImageResource(C0181R.drawable.g_wifi04);
                        break;
                }
            }
        }
        return v;
    }
}
