package com.enus.myzik;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.Checkable;
import android.widget.RelativeLayout;

public class CheckableRelativeLayout extends RelativeLayout implements Checkable {
    final String ATTR = "checkable";
    final String NS = "http://schemas.android.com/apk/res/com.enus.myzik";
    Checkable checkable;
    int checkableId;

    public CheckableRelativeLayout(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.checkableId = attrs.getAttributeResourceValue("http://schemas.android.com/apk/res/com.enus.myzik", "checkable", 0);
    }

    public boolean isChecked() {
        this.checkable = (Checkable) findViewById(this.checkableId);
        if (this.checkable == null) {
            return false;
        }
        return this.checkable.isChecked();
    }

    public void setChecked(boolean checked) {
        this.checkable = (Checkable) findViewById(this.checkableId);
        if (this.checkable != null) {
            this.checkable.setChecked(checked);
        }
    }

    public void toggle() {
        this.checkable = (Checkable) findViewById(this.checkableId);
        if (this.checkable != null) {
            this.checkable.toggle();
        }
    }
}
