package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

@SuppressLint({"ViewConstructor"})
public class CustomEditFileAdapter2 extends CustomListAdapter {
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;
    TextView mtvCount = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    static class ViewHolder {
        ImageButton butMinus;
        ImageView ivDelete;
        TextView tvDisplayName;

        ViewHolder() {
        }
    }

    public CustomEditFileAdapter2(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public void onInit(DatabaseManager DBManager, String strTableName, TextView tvCount) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
        this.mtvCount = tvCount;
    }

    public void rmFile(String strPath) {
        File fNewFile = new File(strPath);
        if (fNewFile.exists() && fNewFile.isFile()) {
            fNewFile.delete();
        }
    }

    public void onDeleteItem(int pos) {
        if (((CustomListItem) this.Items.get(pos)).isSelected()) {
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            int nIdx = ((CustomListItem) this.Items.get(pos)).getIdx();
            int nNumber = ((CustomListItem) this.Items.get(pos)).getNumber();
            strDisplayName = ((CustomListItem) this.Items.get(pos)).getDisplayName();
            rmFile(((CustomListItem) this.Items.get(pos)).getPath());
            this.Items.remove(pos);
            int nCount = this.Items.size();
            if (this.mtvCount != null) {
                this.mtvCount.setText(new StringBuilder(String.valueOf(this.mContext.getResources().getString(C0181R.string.pl_total))).append(" ").append(nCount).append(" ").append(this.mContext.getResources().getString(C0181R.string.pl_files)).toString());
            }
        }
        notifyDataSetChanged();
    }

    public void onRefresh(int from, int to) {
        CustomListItem fItem = (CustomListItem) this.Items.get(from);
        this.Items.set(from, (CustomListItem) this.Items.get(to));
        this.Items.set(to, fItem);
    }

    public void onSort() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        int nSize = getCount();
        for (int i = 0; i < nSize; i++) {
            if (!this.mDBManager.execSQL("UPDATE `" + this.strTableName + "` SET `number` = " + i + " WHERE `idx` = " + ((CustomListItem) this.Items.get(i)).getIdx())) {
                MzServerApp MzApp = (MzServerApp) this.mContext.getApplicationContext();
                if (MzApp != null) {
                    MzApp.ShowMsg("Error", 1);
                }
            }
        }
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        final int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.edit_file_item, null);
            holder = new ViewHolder();
            holder.tvDisplayName = (TextView) v.findViewById(C0181R.id.edit_file_item_textView_DisplayName);
            holder.butMinus = (ImageButton) v.findViewById(C0181R.id.edit_file_item_button_Minus);
            holder.ivDelete = (ImageView) v.findViewById(C0181R.id.edit_file_item_imageView_Delete);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            if (v != null) {
                Drawable drawable;
                if ((position & 1) == 1) {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01);
                } else {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02);
                }
                v.setBackgroundDrawable(drawable);
            }
            holder.tvDisplayName.setText(item.getDisplayName());
            if (((CustomListItem) this.Items.get(pos)).isSelected()) {
                holder.butMinus.setBackgroundResource(C0181R.drawable.minus_spin);
                holder.ivDelete.setVisibility(0);
                holder.ivDelete.setImageResource(C0181R.drawable.edit_delete_selector);
            } else {
                holder.butMinus.setBackgroundResource(C0181R.drawable.minus);
                holder.ivDelete.setVisibility(8);
                holder.ivDelete.setImageResource(C0181R.drawable.icon_move);
            }
            holder.butMinus.setOnClickListener(new OnClickListener() {
                public void onClick(View v) {
                    String strArgs = EXTHeader.DEFAULT_VALUE;
                    String strDisplayName = EXTHeader.DEFAULT_VALUE;
                    String strInfo1 = EXTHeader.DEFAULT_VALUE;
                    String strInfo2 = EXTHeader.DEFAULT_VALUE;
                    String strPath = EXTHeader.DEFAULT_VALUE;
                    String strThumbPath = EXTHeader.DEFAULT_VALUE;
                    strDisplayName = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getDisplayName();
                    strInfo1 = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getInfo1();
                    strInfo2 = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getInfo2();
                    strPath = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getPath();
                    long nSize = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getSize();
                    strThumbPath = ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).getThumbPath();
                    int nCount = CustomEditFileAdapter2.this.getCount();
                    for (int i = 0; i < nCount; i++) {
                        if (i != pos) {
                            ((CustomListItem) CustomEditFileAdapter2.this.Items.get(i)).setSelected(false);
                        }
                    }
                    ((CustomListItem) CustomEditFileAdapter2.this.Items.get(pos)).setSelected();
                    CustomEditFileAdapter2.this.notifyDataSetChanged();
                }
            });
            holder.ivDelete.setOnClickListener(new OnClickListener() {
                public void onClick(View v) {
                    CustomEditFileAdapter2.this.onDeleteItem(pos);
                    CustomEditFileAdapter2.this.notifyDataSetChanged();
                }
            });
        }
        return v;
    }
}
