package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import com.nostra13.universalimageloader.cache.disc.impl.UnlimitedDiscCache;
import com.nostra13.universalimageloader.cache.disc.naming.HashCodeFileNameGenerator;
import com.nostra13.universalimageloader.cache.memory.impl.LruMemoryCache;
import com.nostra13.universalimageloader.core.DisplayImageOptions;
import com.nostra13.universalimageloader.core.DisplayImageOptions.Builder;
import com.nostra13.universalimageloader.core.ImageLoader;
import com.nostra13.universalimageloader.core.ImageLoaderConfiguration;
import com.nostra13.universalimageloader.core.assist.QueueProcessingType;
import com.nostra13.universalimageloader.core.decode.BaseImageDecoder;
import com.nostra13.universalimageloader.core.download.BaseImageDownloader;
import com.nostra13.universalimageloader.utils.StorageUtils;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

@SuppressLint({"ViewConstructor"})
public class CustomEditImageAdapter extends CustomListAdapter {
    static ImageLoaderConfiguration config;
    static ImageLoader imageLoader = ImageLoader.getInstance();
    static DisplayImageOptions imgDisplayOptions = new Builder().cacheInMemory().cacheOnDisc().build();
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;
    TextView mtvCount = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    class ViewHolder {
        ImageView ivImage;

        ViewHolder() {
        }
    }

    public CustomEditImageAdapter(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
        config = new ImageLoaderConfiguration.Builder(this.mContext).memoryCacheExtraOptions(96, 96).discCacheExtraOptions(96, 96, CompressFormat.JPEG, 80).threadPoolSize(5).threadPriority(4).tasksProcessingOrder(QueueProcessingType.FIFO).denyCacheImageMultipleSizesInMemory().memoryCache(new LruMemoryCache(DLNAFlags.CONNECTION_STALL)).memoryCacheSize(DLNAFlags.CONNECTION_STALL).discCache(new UnlimitedDiscCache(StorageUtils.getCacheDirectory(this.mContext))).discCacheSize(52428800).discCacheFileCount(100).discCacheFileNameGenerator(new HashCodeFileNameGenerator()).imageDownloader(new BaseImageDownloader(context)).imageDecoder(new BaseImageDecoder(true)).defaultDisplayImageOptions(DisplayImageOptions.createSimple()).build();
        imageLoader.init(config);
    }

    public void recycle() {
        int nCount = getCount();
        for (int i = 0; i < nCount; i++) {
            Bitmap bm = ((CustomListItem) this.Items.get(i)).getBitmap();
            if (bm != null) {
                bm.recycle();
            }
            ((CustomListItem) this.Items.get(i)).setBitmap(null);
        }
    }

    public void onInit(DatabaseManager DBManager, String strTableName, TextView tvCount) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
        this.mtvCount = tvCount;
    }

    public CustomListItem removeItemAt(int index) {
        return (CustomListItem) this.Items.remove(index);
    }

    public void onRefresh(int from, int to) {
        this.Items.add(to, (CustomListItem) this.Items.remove(from));
    }

    public void onSort() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        int nSize = getCount();
        for (int i = 0; i < nSize; i++) {
            if (!this.mDBManager.execSQL("UPDATE `" + this.strTableName + "` SET `number` = " + i + " WHERE `idx` = " + ((CustomListItem) this.Items.get(i)).getIdx())) {
                MzServerApp MzApp = (MzServerApp) this.mContext.getApplicationContext();
                if (MzApp != null) {
                    MzApp.ShowMsg("Error", 1);
                }
            }
        }
    }

    public void setSelected(int pos) {
        String strArgs = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        strDisplayName = ((CustomListItem) this.Items.get(pos)).getDisplayName();
        strInfo1 = ((CustomListItem) this.Items.get(pos)).getInfo1();
        strInfo2 = ((CustomListItem) this.Items.get(pos)).getInfo2();
        strInfo3 = ((CustomListItem) this.Items.get(pos)).getInfo3();
        strInfo4 = ((CustomListItem) this.Items.get(pos)).getInfo4();
        strInfo5 = ((CustomListItem) this.Items.get(pos)).getInfo5();
        strPath = ((CustomListItem) this.Items.get(pos)).getPath();
        long nSize = ((CustomListItem) this.Items.get(pos)).getSize();
        strThumbPath = ((CustomListItem) this.Items.get(pos)).getThumbPath();
        ((CustomListItem) this.Items.get(pos)).setSelected();
        notifyDataSetChanged();
    }

    public int FindPosition(int nIdx) {
        int nSize = getCount();
        for (int i = 0; i < nSize; i++) {
            if (((CustomListItem) getItem(i)).getIdx() == nIdx) {
                return i;
            }
        }
        return -1;
    }

    public CustomListItem FindItem(int nIdx) {
        int nSize = getCount();
        for (int i = 0; i < nSize; i++) {
            CustomListItem Item = (CustomListItem) getItem(i);
            if (Item.getIdx() == nIdx) {
                return Item;
            }
        }
        return null;
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public int getCount() {
        return this.Items.size();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.edit_image_item, null);
            holder = new ViewHolder();
            holder.ivImage = (ImageView) v.findViewById(C0181R.id.edit_image_item_imageView_Image);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            imageLoader.displayImage("file://" + item.getPath(), holder.ivImage, imgDisplayOptions);
        }
        return v;
    }
}
