package com.enus.myzik;

import android.content.Context;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import java.util.ArrayList;

public class CustomImageAdapter extends ArrayAdapter<CustomListItem> {
    private ArrayList<CustomListItem> Items;
    Context mContext;

    public CustomImageAdapter(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public void setGrayScale(ImageView v) {
        ColorMatrix matrix = new ColorMatrix();
        matrix.setSaturation(0.0f);
        v.setColorFilter(new ColorMatrixColorFilter(matrix));
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.add_image_item, null);
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            ImageView ivImage = (ImageView) v.findViewById(C0181R.id.add_image_item_imageView_ImageView);
            ivImage.setImageDrawable(null);
            if (item.getBitmap() == null) {
                ivImage.setImageResource(C0181R.drawable.listicon_pic);
            } else {
                ivImage.setImageBitmap(item.getBitmap());
                if (item.isSelected()) {
                    setGrayScale(ivImage);
                } else {
                    ivImage.clearColorFilter();
                }
            }
        }
        return v;
    }
}
