package com.enus.myzik;

import android.content.Context;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.ArrayList;

public class CustomListAdapter extends ArrayAdapter<CustomListItem> {
    private ArrayList<CustomListItem> Items;
    Context mContext;

    public CustomListAdapter(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public void recycle() {
        int nCount = getCount();
        for (int i = 0; i < nCount; i++) {
            ((CustomListItem) this.Items.get(i)).setBitmap(null);
        }
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public void setGrayScale(ImageView v) {
        ColorMatrix matrix = new ColorMatrix();
        matrix.setSaturation(0.0f);
        v.setColorFilter(new ColorMatrixColorFilter(matrix));
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.view_item, null);
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            TextView tvInfo = (TextView) v.findViewById(C0181R.id.view_item_textView_Info);
            ((TextView) v.findViewById(C0181R.id.view_item_textView_DisplayName)).setText(item.getDisplayName());
            tvInfo.setText(item.getInfo2() + " - " + item.getInfo1());
        }
        return v;
    }
}
