package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Vibrator;
import android.provider.MediaStore.Audio.Playlists.Members;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

@SuppressLint({"ViewConstructor"})
public class CustomListAdapter_Button extends CustomListAdapter {
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    static class ViewHolder {
        ImageButton butPlus;
        TextView tvDisplayName;
        TextView tvInfo;

        ViewHolder() {
        }
    }

    public CustomListAdapter_Button(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public void onInit(DatabaseManager DBManager, String strTableName) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    private int GetPlayOrder() {
        Cursor cur = this.mContext.getContentResolver().query(Members.getContentUri("external", Long.valueOf(this.strTableName.substring(3)).longValue()), new String[]{"MAX(PLAY_ORDER)"}, null, null, null);
        cur.moveToFirst();
        int nbase = cur.getInt(0) + 1;
        cur.close();
        return nbase;
    }

    public void SetList4PLfromMem(String strAID) {
        int nBase = GetPlayOrder();
        long nID = Long.valueOf(this.strTableName.substring(3)).longValue();
        ContentResolver resolver = this.mContext.getContentResolver();
        Uri uri = Members.getContentUri("external", nID);
        ContentValues values = new ContentValues();
        values.put("play_order", Integer.valueOf(nBase));
        values.put("audio_id", Long.valueOf(strAID));
        resolver.insert(uri, values);
    }

    public boolean chkTotalSizes(long nFileSize) {
        ContentValues values = new ContentValues();
        Cursor cursor = this.mDBManager.onSelect("SELECT sum(size) FROM `" + this.strTableName + "`");
        if (cursor == null) {
            return true;
        }
        if (!cursor.moveToFirst()) {
            return true;
        }
        if (((double) (nFileSize + cursor.getLong(cursor.getColumnIndex("sum(size)")))) <= 8.3752E9d) {
            return true;
        }
        return false;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        final int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.add_item, null);
            holder = new ViewHolder();
            holder.tvDisplayName = (TextView) v.findViewById(C0181R.id.add_item_textView_DisplayName);
            holder.tvInfo = (TextView) v.findViewById(C0181R.id.add_item_textView_Info);
            holder.butPlus = (ImageButton) v.findViewById(C0181R.id.add_item_button_Add);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            if (v != null) {
                Drawable drawable;
                if ((position & 1) == 1) {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01);
                } else {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02);
                }
                v.setBackgroundDrawable(drawable);
            }
            if (item.isSelected()) {
                holder.tvDisplayName.setTextColor(Color.rgb(100, 100, 100));
                holder.tvInfo.setTextColor(Color.rgb(100, 100, 100));
            } else {
                holder.tvDisplayName.setTextColor(-1);
                holder.tvInfo.setTextColor(-1);
            }
            holder.tvDisplayName.setText(item.getDisplayName());
            holder.tvInfo.setText(item.getInfo2() + " - " + item.getInfo1());
            holder.butPlus.setOnClickListener(new OnClickListener() {
                public void onClick(View v) {
                    ((Vibrator) CustomListAdapter_Button.this.mContext.getSystemService("vibrator")).vibrate(25);
                    ContentValues values = new ContentValues();
                    String strDisplayName = EXTHeader.DEFAULT_VALUE;
                    String strInfo1 = EXTHeader.DEFAULT_VALUE;
                    String strInfo2 = EXTHeader.DEFAULT_VALUE;
                    String strInfo3 = EXTHeader.DEFAULT_VALUE;
                    String strInfo4 = EXTHeader.DEFAULT_VALUE;
                    String strInfo5 = EXTHeader.DEFAULT_VALUE;
                    String strPath = EXTHeader.DEFAULT_VALUE;
                    String strThumbPath = EXTHeader.DEFAULT_VALUE;
                    String str = EXTHeader.DEFAULT_VALUE;
                    str = EXTHeader.DEFAULT_VALUE;
                    int nCount = CustomListAdapter_Button.this.mDBManager.onCount(CustomListAdapter_Button.this.strTableName, str);
                    MzServerApp MzApp;
                    if (nCount >= 500 || nCount < 0) {
                        MzApp = (MzServerApp) CustomListAdapter_Button.this.mContext.getApplicationContext();
                        if (nCount >= 500) {
                            MzApp.ShowMsg(CustomListAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg4), 1);
                            return;
                        }
                        return;
                    }
                    int nNumber = nCount;
                    String[] strData = new String[8];
                    strDisplayName = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getDisplayName();
                    strInfo1 = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getInfo1();
                    strInfo2 = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getInfo2();
                    strInfo3 = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getInfo3();
                    strInfo4 = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getInfo4();
                    strInfo5 = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getInfo5();
                    strPath = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getPath();
                    long nSize = ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).getSize();
                    if (!CustomListAdapter_Button.this.chkTotalSizes(nSize)) {
                        MzApp = (MzServerApp) CustomListAdapter_Button.this.mContext.getApplicationContext();
                        if (MzApp != null) {
                            MzApp.ShowMsg(CustomListAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg2), 1);
                        }
                    } else if (((double) nSize) <= 4.295E9d) {
                        ((CustomListItem) CustomListAdapter_Button.this.Items.get(pos)).setSelected(true);
                        if (CustomListAdapter_Button.this.strTableName.substring(0, 3).compareTo("PL_") == 0) {
                            CustomListAdapter_Button.this.SetList4PLfromMem(strInfo3);
                        } else {
                            Log.d("4pladd", CustomListAdapter_Button.this.strTableName.substring(0, 3));
                            values.put("number", Integer.valueOf(nNumber));
                            values.put("display_name", strDisplayName);
                            values.put("info1", strInfo1);
                            values.put("info2", strInfo2);
                            values.put("info3", strInfo3);
                            values.put("info4", strInfo4);
                            values.put("info5", strInfo5);
                            values.put("path", strPath);
                            values.put("size", Long.valueOf(nSize));
                            CustomListAdapter_Button.this.mDBManager.onInsert(CustomListAdapter_Button.this.strTableName, values);
                        }
                        CustomListAdapter_Button.this.notifyDataSetChanged();
                        MzApp = (MzServerApp) CustomListAdapter_Button.this.mContext.getApplicationContext();
                        if (MzApp != null) {
                            MzApp.ShowMsg(CustomListAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_added), 1);
                        }
                    } else {
                        MzApp = (MzServerApp) CustomListAdapter_Button.this.mContext.getApplicationContext();
                        if (MzApp != null) {
                            MzApp.ShowMsg(CustomListAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg1), 1);
                        }
                    }
                }
            });
        }
        return v;
    }
}
