package com.enus.myzik;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import java.util.ArrayList;

public class CustomSetSSIDAdapter extends ArrayAdapter<CustomSetItem> {
    public static final int nDisable_State = 1;
    public static final int nEnable_State = 0;
    public static final int nFirstCon_State = 2;
    private ArrayList<CustomSetItem> Items;
    Context mContext;

    static class ViewHolder {
        TextView tvSSID;

        ViewHolder() {
        }
    }

    public CustomSetSSIDAdapter(Context context, int textViewResourceId, ArrayList<CustomSetItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public View getDropDownView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(17367049, parent, false);
            holder = new ViewHolder();
            holder.tvSSID = (TextView) v.findViewById(16908308);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomSetItem Item = (CustomSetItem) this.Items.get(pos);
        if (Item != null) {
            holder.tvSSID.setText(Item.getSSID());
        }
        return v;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(17367048, parent, false);
            holder = new ViewHolder();
            holder.tvSSID = (TextView) v.findViewById(16908308);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomSetItem Item = (CustomSetItem) this.Items.get(pos);
        if (Item != null) {
            holder.tvSSID.setText(Item.getSSID());
            if (Item.getState() == 0) {
                holder.tvSSID.setTextColor(Color.rgb(19, 173, 3));
            } else if (Item.getState() == 1) {
                holder.tvSSID.setTextColor(-7829368);
            } else if (Item.getState() == 2) {
                holder.tvSSID.setTextColor(-65536);
            }
        }
        return v;
    }
}
