package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.graphics.Color;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Vibrator;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

@SuppressLint({"ViewConstructor"})
public class CustomVideoAdapter_Button extends CustomListAdapter {
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    static class ViewHolder {
        ImageButton butPlus;
        ImageView ivImage;
        TextView tvDisplayName;

        ViewHolder() {
        }
    }

    public CustomVideoAdapter_Button(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public CustomListItem getThumbItem(String strId) {
        int iSize = getCount();
        for (int i = 0; i < iSize; i++) {
            CustomListItem Item = (CustomListItem) this.Items.get(i);
            if (Item.getInfo3().equals(strId)) {
                return Item;
            }
        }
        return null;
    }

    public void onInit(DatabaseManager DBManager, String strTableName) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public void setGrayScale(ImageView v) {
        ColorMatrix matrix = new ColorMatrix();
        matrix.setSaturation(0.0f);
        v.setColorFilter(new ColorMatrixColorFilter(matrix));
    }

    private static void recycleBitmap(ImageView iv) {
        if (iv != null) {
            Drawable d = iv.getDrawable();
            if (d != null) {
                try {
                    if (d instanceof BitmapDrawable) {
                        ((BitmapDrawable) d).getBitmap().recycle();
                    }
                    d.setCallback(null);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public boolean chkTotalSizes(long nFileSize) {
        ContentValues values = new ContentValues();
        Cursor cursor = this.mDBManager.onSelect("SELECT sum(size) FROM `" + this.strTableName + "`");
        if (cursor == null) {
            return true;
        }
        if (!cursor.moveToFirst()) {
            return true;
        }
        if (((double) (nFileSize + cursor.getLong(cursor.getColumnIndex("sum(size)")))) <= 8.3752E9d) {
            return true;
        }
        return false;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        final int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.add_video_item, null);
            holder = new ViewHolder();
            holder.ivImage = (ImageView) v.findViewById(C0181R.id.add_video_imageView_Image);
            holder.tvDisplayName = (TextView) v.findViewById(C0181R.id.add_video_textView_DisplayName);
            holder.butPlus = (ImageButton) v.findViewById(C0181R.id.add_video_imageButton_Add);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            if (v != null) {
                Drawable drawable;
                if ((position & 1) == 1) {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01);
                } else {
                    drawable = this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02);
                }
                v.setBackgroundDrawable(drawable);
            }
            Log.d("tn", item.getInfo3());
            holder.ivImage.setImageDrawable(null);
            if (item.getBitmap() == null || item.getInfo4().compareTo("video/mp4") != 0) {
                holder.ivImage.setImageResource(C0181R.drawable.movie_thumbnail);
            } else {
                holder.ivImage.setImageBitmap(item.getBitmap());
            }
            if (item.isSelected()) {
                setGrayScale(holder.ivImage);
                holder.tvDisplayName.setTextColor(Color.rgb(100, 100, 100));
            } else {
                holder.ivImage.clearColorFilter();
                holder.tvDisplayName.setTextColor(-1);
            }
            holder.tvDisplayName.setText(item.getDisplayName());
            holder.butPlus.setOnClickListener(new OnClickListener() {
                public void onClick(View v) {
                    ((Vibrator) CustomVideoAdapter_Button.this.mContext.getSystemService("vibrator")).vibrate(25);
                    ContentValues values = new ContentValues();
                    String strDisplayName = EXTHeader.DEFAULT_VALUE;
                    String strInfo1 = EXTHeader.DEFAULT_VALUE;
                    String strInfo2 = EXTHeader.DEFAULT_VALUE;
                    String strInfo3 = EXTHeader.DEFAULT_VALUE;
                    String strInfo4 = EXTHeader.DEFAULT_VALUE;
                    String strInfo5 = EXTHeader.DEFAULT_VALUE;
                    String strPath = EXTHeader.DEFAULT_VALUE;
                    String strThumbPath = EXTHeader.DEFAULT_VALUE;
                    String str = EXTHeader.DEFAULT_VALUE;
                    str = EXTHeader.DEFAULT_VALUE;
                    int nCount = CustomVideoAdapter_Button.this.mDBManager.onCount(CustomVideoAdapter_Button.this.strTableName, str);
                    if (nCount >= 500 || nCount < 0) {
                        MzServerApp MzApp = (MzServerApp) CustomVideoAdapter_Button.this.mContext.getApplicationContext();
                        if (nCount >= 500) {
                            MzApp.ShowMsg(CustomVideoAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg4), 1);
                            return;
                        }
                        return;
                    }
                    int nNumber = nCount;
                    strDisplayName = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getDisplayName();
                    strInfo1 = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getInfo1();
                    strInfo2 = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getInfo2();
                    strInfo3 = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getInfo3();
                    strInfo4 = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getInfo4();
                    strInfo5 = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getInfo5();
                    strPath = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getPath();
                    long nSize = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getSize();
                    if (!CustomVideoAdapter_Button.this.chkTotalSizes(nSize)) {
                        ((MzServerApp) CustomVideoAdapter_Button.this.mContext.getApplicationContext()).ShowMsg(CustomVideoAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg2), 1);
                    } else if (((double) nSize) <= 4.295E9d) {
                        strThumbPath = ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).getThumbPath();
                        ((CustomListItem) CustomVideoAdapter_Button.this.Items.get(pos)).setSelected(true);
                        values.put("number", Integer.valueOf(nNumber));
                        values.put("display_name", strDisplayName);
                        values.put("info1", strInfo1);
                        values.put("info2", strInfo2);
                        values.put("info3", strInfo3);
                        values.put("info4", strInfo4);
                        values.put("info5", strInfo5);
                        values.put("path", strPath);
                        values.put("size", Long.valueOf(nSize));
                        values.put("thumb_path", strThumbPath);
                        CustomVideoAdapter_Button.this.mDBManager.onInsert(CustomVideoAdapter_Button.this.strTableName, values);
                        CustomVideoAdapter_Button.this.notifyDataSetChanged();
                        ((MzServerApp) CustomVideoAdapter_Button.this.mContext.getApplicationContext()).ShowMsg(CustomVideoAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_added), 1);
                    } else {
                        ((MzServerApp) CustomVideoAdapter_Button.this.mContext.getApplicationContext()).ShowMsg(CustomVideoAdapter_Button.this.mContext.getResources().getString(C0181R.string.pl_msg1), 1);
                    }
                }
            });
        }
        return v;
    }
}
