package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.Color;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import com.nostra13.universalimageloader.cache.disc.impl.UnlimitedDiscCache;
import com.nostra13.universalimageloader.cache.disc.naming.HashCodeFileNameGenerator;
import com.nostra13.universalimageloader.cache.memory.impl.LruMemoryCache;
import com.nostra13.universalimageloader.core.DisplayImageOptions;
import com.nostra13.universalimageloader.core.DisplayImageOptions.Builder;
import com.nostra13.universalimageloader.core.ImageLoader;
import com.nostra13.universalimageloader.core.ImageLoaderConfiguration;
import com.nostra13.universalimageloader.core.assist.QueueProcessingType;
import com.nostra13.universalimageloader.core.decode.BaseImageDecoder;
import com.nostra13.universalimageloader.core.download.BaseImageDownloader;
import com.nostra13.universalimageloader.utils.StorageUtils;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

@SuppressLint({"ViewConstructor"})
public class CustomViewImageAdapter2 extends CustomImageAdapter {
    static ImageLoaderConfiguration config;
    static ImageLoader imageLoader = ImageLoader.getInstance();
    static DisplayImageOptions imgDisplayOptions = new Builder().cacheInMemory().cacheOnDisc().build();
    static Context mContext;
    private ArrayList<CustomListItem> Items;
    public DatabaseManager mDBManager = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    class ViewHolder {
        ImageView ivImage;
        TextView ivText;

        ViewHolder() {
        }
    }

    public CustomViewImageAdapter2(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        mContext = context;
        config = new ImageLoaderConfiguration.Builder(mContext).memoryCacheExtraOptions(96, 96).discCacheExtraOptions(96, 96, CompressFormat.JPEG, 80).threadPoolSize(5).threadPriority(4).tasksProcessingOrder(QueueProcessingType.FIFO).denyCacheImageMultipleSizesInMemory().memoryCache(new LruMemoryCache(DLNAFlags.CONNECTION_STALL)).memoryCacheSize(DLNAFlags.CONNECTION_STALL).discCache(new UnlimitedDiscCache(StorageUtils.getCacheDirectory(mContext))).discCacheSize(52428800).discCacheFileCount(100).discCacheFileNameGenerator(new HashCodeFileNameGenerator()).imageDownloader(new BaseImageDownloader(context)).imageDecoder(new BaseImageDecoder(true)).defaultDisplayImageOptions(DisplayImageOptions.createSimple()).build();
        imageLoader.init(config);
        this.Items = items;
    }

    public void recycle() {
        int nCount = getCount();
        for (int i = 0; i < nCount; i++) {
            Bitmap bm = ((CustomListItem) this.Items.get(i)).getBitmap();
            if (bm != null) {
                bm.recycle();
            }
            ((CustomListItem) this.Items.get(i)).setBitmap(null);
        }
    }

    public void onInit(DatabaseManager DBManager, String strTableName) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public void setGrayScale(ImageView v) {
        ColorMatrix matrix = new ColorMatrix();
        matrix.setSaturation(0.0f);
        v.setColorFilter(new ColorMatrixColorFilter(matrix));
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.view_image_item, null);
            holder = new ViewHolder();
            holder.ivImage = (ImageView) v.findViewById(C0181R.id.view_image_item_imageView_ImageView);
            holder.ivImage.setPadding(4, 4, 4, 4);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            holder.ivText = (TextView) v.findViewById(C0181R.id.view_image_item_textView_TextView);
            String strImgPath = item.getPath();
            String strFolder = EXTHeader.DEFAULT_VALUE;
            if (!(strImgPath == null || strImgPath.isEmpty())) {
                strFolder = strImgPath.substring(0, strImgPath.lastIndexOf(47));
                strFolder = strFolder.substring(strFolder.lastIndexOf(47) + 1);
            }
            if (!(strFolder == null || strFolder.isEmpty())) {
                try {
                    holder.ivText.setText(strFolder);
                    holder.ivText.setBackgroundColor(Color.argb(200, 63, 121, 151));
                    holder.ivText.setVisibility(0);
                } catch (NullPointerException e) {
                    e.printStackTrace();
                }
            }
            holder.ivImage.setImageDrawable(null);
            if (item.getBitmap() == null) {
                holder.ivImage.setImageResource(C0181R.drawable.listicon_pic);
            }
            imageLoader.displayImage("file://" + item.getPath(), holder.ivImage, imgDisplayOptions);
        }
        return v;
    }
}
