package com.enus.myzik;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;
import java.util.ArrayList;

public class CustomViewListAdapter extends CustomListAdapter {
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;

    static class ViewHolder {
        ImageButton butDelete;
        ImageButton butMinus;
        TextView tvDisplayName;
        TextView tvInfo;

        ViewHolder() {
        }
    }

    public CustomViewListAdapter(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public void onInit(DatabaseManager DBManager, String strTableName) {
        this.mDBManager = DBManager;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.view_item, null);
            holder = new ViewHolder();
            holder.tvDisplayName = (TextView) v.findViewById(C0181R.id.view_item_textView_DisplayName);
            holder.tvInfo = (TextView) v.findViewById(C0181R.id.view_item_textView_Info);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            if (v != null) {
                v.setBackgroundDrawable((position & 1) == 1 ? this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01) : this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02));
            }
            holder.tvDisplayName.setText(item.getDisplayName());
            holder.tvInfo.setText(item.getInfo2() + " - " + item.getInfo1());
        }
        return v;
    }
}
