package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

@SuppressLint({"ViewConstructor"})
public class CustomViewVideoAdapter extends CustomListAdapter {
    private ArrayList<CustomListItem> Items;
    Context mContext;
    public DatabaseManager mDBManager = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    static class ViewHolder {
        ImageView ivImage;
        TextView tvDisplayName;

        ViewHolder() {
        }
    }

    public CustomViewVideoAdapter(Context context, int textViewResourceId, ArrayList<CustomListItem> items) {
        super(context, textViewResourceId, items);
        this.mContext = context;
        this.Items = items;
    }

    public void onInit(DatabaseManager DBManager, String strTableName) {
        this.mDBManager = DBManager;
        this.strTableName = strTableName;
    }

    public int getCount() {
        return this.Items.size();
    }

    public String getDisplayName(int position) {
        return ((CustomListItem) this.Items.get(position)).getDisplayName();
    }

    public long getItemId(int position) {
        return (long) position;
    }

    public void recycle() {
        int nCount = getCount();
        for (int i = 0; i < nCount; i++) {
            Bitmap bm = ((CustomListItem) this.Items.get(i)).getBitmap();
            if (bm != null) {
                bm.recycle();
            }
            ((CustomListItem) this.Items.get(i)).setBitmap(null);
        }
    }

    private static void recycleBitmap(ImageView iv) {
        if (iv != null) {
            Drawable d = iv.getDrawable();
            if (d != null) {
                try {
                    if (d instanceof BitmapDrawable) {
                        ((BitmapDrawable) d).getBitmap().recycle();
                    }
                    d.setCallback(null);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        View v = convertView;
        int pos = position;
        if (v == null) {
            v = ((LayoutInflater) getContext().getSystemService("layout_inflater")).inflate(C0181R.layout.view_video_item, null);
            holder = new ViewHolder();
            holder.ivImage = (ImageView) v.findViewById(C0181R.id.view_video_imageView_Image);
            holder.tvDisplayName = (TextView) v.findViewById(C0181R.id.view_video_item_textView_DisplayName);
            v.setTag(holder);
        } else {
            holder = (ViewHolder) v.getTag();
        }
        CustomListItem item = (CustomListItem) this.Items.get(pos);
        if (item != null) {
            if (v != null) {
                v.setBackgroundDrawable((position & 1) == 1 ? this.mContext.getResources().getDrawable(C0181R.drawable.list_bg01) : this.mContext.getResources().getDrawable(C0181R.drawable.list_bg02));
            }
            holder.ivImage.setImageDrawable(null);
            if (item.getBitmap() == null || item.getInfo4().compareTo("video/mp4") != 0) {
                holder.ivImage.setImageResource(C0181R.drawable.movie_thumbnail);
            } else {
                holder.ivImage.setImageBitmap(item.getBitmap());
            }
            holder.tvDisplayName.setText(item.getDisplayName());
        }
        return v;
    }
}
