package com.enus.myzik;

import android.content.Context;
import android.database.Cursor;
import android.util.Log;
import java.util.Arrays;
import org.teleal.cling.model.message.header.EXTHeader;

public class DatabaseControl {
    Context mContext;
    public DatabaseManager mDBManager = null;
    String[] strDatabase = null;
    private String strTableName = EXTHeader.DEFAULT_VALUE;

    public DatabaseControl(Context context, String strDatabaseName, String strTableName) {
        this.mContext = context;
        this.strTableName = strTableName;
        this.mDBManager = new DatabaseManager(this.mContext, strDatabaseName, 1, "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`type` INTEGER, " + "`list_name` TEXT, " + "`activate` INTEGER, " + "`contents` TEXT" + ")");
        this.mDBManager.open();
    }

    public String[] getData() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        if (this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE) <= 0) {
            return null;
        }
        Cursor cursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` WHERE `activate` = 1");
        if (cursor == null) {
            return null;
        }
        if (cursor.moveToFirst()) {
            int nColumnIndex = cursor.getColumnIndex("type");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            int nType = cursor.getInt(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("list_name");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            String strListName = cursor.getString(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("contents");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            String strContents = cursor.getString(nColumnIndex);
            cursor.close();
            if (!this.mDBManager.onSync(strContents)) {
                return null;
            }
            int nCount = this.mDBManager.onCount(strContents, EXTHeader.DEFAULT_VALUE);
            if (this.strDatabase != null) {
                onClear();
            }
            this.strDatabase = new String[((nCount * 8) + 2)];
            this.strDatabase[0] = Integer.toString(nType);
            int i = 0 + 1;
            this.strDatabase[i] = strListName;
            i++;
            cursor = this.mDBManager.onSelect("SELECT * FROM `" + strContents + "`");
            if (cursor == null) {
                return null;
            }
            cursor.moveToFirst();
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strInfo1 = EXTHeader.DEFAULT_VALUE;
            String strInfo2 = EXTHeader.DEFAULT_VALUE;
            String strInfo3 = EXTHeader.DEFAULT_VALUE;
            String strInfo4 = EXTHeader.DEFAULT_VALUE;
            String strInfo5 = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            while (!cursor.isAfterLast()) {
                nColumnIndex = cursor.getColumnIndex("display_name");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strDisplayName = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info1");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo1 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info2");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo2 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info3");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo3 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info4");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo4 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info5");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo5 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("path");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strPath = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("size");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                int nSize = cursor.getInt(nColumnIndex);
                this.strDatabase[i] = strDisplayName;
                this.strDatabase[i + 1] = strInfo1;
                this.strDatabase[i + 2] = strInfo2;
                this.strDatabase[i + 3] = strInfo3;
                this.strDatabase[i + 4] = strInfo4;
                this.strDatabase[i + 5] = strInfo5;
                this.strDatabase[i + 6] = strPath;
                this.strDatabase[i + 7] = Integer.toString(nSize);
                cursor.moveToNext();
                i += 8;
            }
            cursor.close();
            return this.strDatabase;
        }
        cursor.close();
        return null;
    }

    public String[] getwritelistData() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        if (this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE) <= 0) {
            return null;
        }
        Cursor cursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` WHERE `activate` = 1 and `type` = 5");
        if (cursor == null) {
            return null;
        }
        if (cursor.moveToFirst()) {
            int nColumnIndex = cursor.getColumnIndex("type");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            int nType = cursor.getInt(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("list_name");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            String strListName = cursor.getString(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("contents");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            String strContents = cursor.getString(nColumnIndex);
            cursor.close();
            if (!this.mDBManager.onSync(strContents)) {
                return null;
            }
            int nCount = this.mDBManager.onCount(strContents, EXTHeader.DEFAULT_VALUE);
            if (this.strDatabase != null) {
                onClear();
            }
            this.strDatabase = new String[((nCount * 8) + 2)];
            this.strDatabase[0] = Integer.toString(nType);
            int i = 0 + 1;
            this.strDatabase[i] = strListName;
            i++;
            cursor = this.mDBManager.onSelect("SELECT * FROM `" + strContents + "`");
            if (cursor == null) {
                return null;
            }
            cursor.moveToFirst();
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strInfo1 = EXTHeader.DEFAULT_VALUE;
            String strInfo2 = EXTHeader.DEFAULT_VALUE;
            String strInfo3 = EXTHeader.DEFAULT_VALUE;
            String strInfo4 = EXTHeader.DEFAULT_VALUE;
            String strInfo5 = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            while (!cursor.isAfterLast()) {
                nColumnIndex = cursor.getColumnIndex("display_name");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strDisplayName = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info1");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo1 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info2");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo2 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info3");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo3 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info4");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo4 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("info5");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strInfo5 = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("path");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                strPath = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("size");
                if (nColumnIndex < 0) {
                    if (this.strDatabase != null) {
                        Arrays.fill(this.strDatabase, null);
                    }
                    this.strDatabase = null;
                    return null;
                }
                int nSize = cursor.getInt(nColumnIndex);
                this.strDatabase[i] = strDisplayName;
                this.strDatabase[i + 1] = strInfo1;
                this.strDatabase[i + 2] = strInfo2;
                this.strDatabase[i + 3] = strInfo3;
                this.strDatabase[i + 4] = strInfo4;
                this.strDatabase[i + 5] = strInfo5;
                this.strDatabase[i + 6] = strPath;
                this.strDatabase[i + 7] = Integer.toString(nSize);
                cursor.moveToNext();
                i += 8;
            }
            cursor.close();
            return this.strDatabase;
        }
        cursor.close();
        return null;
    }

    public String MzgetActiveInfo(int nRType) {
        String strRes = EXTHeader.DEFAULT_VALUE;
        String strType = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strLPLName1 = this.mContext.getResources().getString(C0181R.string.lpl_name1);
        String strLPLName2 = this.mContext.getResources().getString(C0181R.string.lpl_name2);
        String strLPLName3 = this.mContext.getResources().getString(C0181R.string.lpl_name3);
        Log.d("enus", "Chk: MzgetActiveInfo " + strLPLName1);
        if (this.mDBManager == null) {
            Log.d("enus", "Chk: mDBManager null");
            return null;
        }
        Cursor cursor = this.mDBManager.onSelect("SELECT * FROM `playlist` WHERE `activate` = 1 and (`type`=1 or `type`=5 or `list_name`='" + strLPLName1 + "' or `list_name`='" + strLPLName2 + "' or `list_name`='" + strLPLName3 + "' )");
        if (cursor == null) {
            Log.d("enus", "Err: MzgetActiveInfo onSelect()");
            return strRes;
        } else if (cursor.moveToFirst()) {
            int nColumnIndex = cursor.getColumnIndex("list_name");
            if (nColumnIndex < 0) {
                cursor.close();
                return null;
            }
            String strListName = cursor.getString(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("type");
            if (nColumnIndex < 0) {
                Log.d("enus", "Err: MzgetActiveInfo Gettype");
                cursor.close();
                return strRes;
            }
            strType = cursor.getString(nColumnIndex);
            nColumnIndex = cursor.getColumnIndex("contents");
            if (nColumnIndex < 0) {
                Log.d("enus", "Err: MzgetActiveInfo Getcontents");
                cursor.close();
                return null;
            }
            int nPLType = Integer.valueOf(strType).intValue();
            if (nRType != 0) {
                strRes = strListName;
            } else if (nPLType == 4 || nPLType == 5) {
                strRes = new StringBuilder(String.valueOf(strType)).append(strListName).toString();
            } else {
                strRes = new StringBuilder(String.valueOf(strType)).append(cursor.getString(nColumnIndex)).toString();
            }
            cursor.close();
            return strRes;
        } else {
            Log.d("enus", "Err: MzgetActiveInfo moveToFirst()");
            cursor.close();
            return strRes;
        }
    }

    public String[] MzgetData() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        if (this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE) > 0) {
            Cursor cursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` WHERE `activate` = 1");
            if (cursor == null) {
                Log.d("enus", "Err: onSelect()");
                return null;
            } else if (cursor.moveToFirst()) {
                int nColumnIndex = cursor.getColumnIndex("type");
                if (nColumnIndex < 0) {
                    Log.d("enus", "Err: Gettype");
                    return null;
                }
                int nType = cursor.getInt(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("list_name");
                if (nColumnIndex < 0) {
                    Log.d("enus", "Err: Getlist_name");
                    cursor.close();
                    return null;
                }
                String strListName = cursor.getString(nColumnIndex);
                nColumnIndex = cursor.getColumnIndex("contents");
                if (nColumnIndex < 0) {
                    Log.d("enus", "Err: Getcontents");
                    cursor.close();
                    return null;
                }
                String strContents = cursor.getString(nColumnIndex);
                cursor.close();
                if (this.mDBManager.onSync(strContents)) {
                    int nCount = this.mDBManager.onCount(strContents, EXTHeader.DEFAULT_VALUE);
                    if (this.strDatabase != null) {
                        onClear();
                    }
                    this.strDatabase = new String[((nCount * 8) + 2)];
                    this.strDatabase[0] = Integer.toString(nType);
                    int i = 0 + 1;
                    this.strDatabase[i] = strListName;
                    i++;
                    cursor = this.mDBManager.onSelect("SELECT * FROM `" + strContents + "` ORDER BY `number`");
                    if (cursor == null) {
                        Log.d("enus", "Err: onSelect2()");
                        return null;
                    }
                    cursor.moveToFirst();
                    String strDisplayName = EXTHeader.DEFAULT_VALUE;
                    String strInfo1 = EXTHeader.DEFAULT_VALUE;
                    String strInfo2 = EXTHeader.DEFAULT_VALUE;
                    String strInfo3 = EXTHeader.DEFAULT_VALUE;
                    String strInfo4 = EXTHeader.DEFAULT_VALUE;
                    String strInfo5 = EXTHeader.DEFAULT_VALUE;
                    String strPath = EXTHeader.DEFAULT_VALUE;
                    while (!cursor.isAfterLast()) {
                        nColumnIndex = cursor.getColumnIndex("display_name");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strDisplayName = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("info1");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strInfo1 = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("info2");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strInfo2 = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("info3");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strInfo3 = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("info4");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strInfo4 = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("info5");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strInfo5 = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("path");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        strPath = cursor.getString(nColumnIndex);
                        nColumnIndex = cursor.getColumnIndex("size");
                        if (nColumnIndex < 0) {
                            if (this.strDatabase != null) {
                                Arrays.fill(this.strDatabase, null);
                            }
                            this.strDatabase = null;
                            return null;
                        }
                        int nSize = cursor.getInt(nColumnIndex);
                        this.strDatabase[i] = strDisplayName;
                        this.strDatabase[i + 1] = strInfo1;
                        this.strDatabase[i + 2] = strInfo2;
                        this.strDatabase[i + 3] = strInfo3;
                        this.strDatabase[i + 4] = strInfo4;
                        this.strDatabase[i + 5] = strInfo5;
                        this.strDatabase[i + 6] = strPath;
                        this.strDatabase[i + 7] = Integer.toString(nSize);
                        cursor.moveToNext();
                        i += 8;
                    }
                    cursor.close();
                    return this.strDatabase;
                }
                Log.d("enus", "Err: onSync()");
                return null;
            } else {
                Log.d("enus", "Err: moveToFirst()");
                cursor.close();
                return null;
            }
        }
        Log.d("enus", "Err: MzgetData() Count 0");
        return null;
    }

    public void onClear() {
        if (this.strDatabase != null) {
            Arrays.fill(this.strDatabase, null);
        }
        this.strDatabase = null;
    }

    public void onClose() {
        if (this.strDatabase != null) {
            onClear();
        }
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        System.gc();
    }
}
