package com.enus.myzik;

import android.app.Activity;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.GestureDetector;
import android.view.GestureDetector.OnGestureListener;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.FrameLayout.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageSwitcher;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ViewSwitcher.ViewFactory;
import com.squareup.picasso.Picasso;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class Edit02_Image_Activity extends Activity implements OnItemSelectedListener, ViewFactory, OnGestureListener {
    private static final int SWIPE_MAX_OFF_PATH = 250;
    private static final int SWIPE_MIN_DISTANCE = 120;
    private static final int SWIPE_THRESHOLD_VELOCITY = 200;
    private ArrayList<CustomListItem> Items;
    private Bitmap bm = null;
    private GestureDetector gestureDetector = null;
    ImageView imageView;
    Animation lin;
    Animation lout;
    Context mContext;
    ContentResolver mCr;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDeleteClickListener = new C00933();
    public OnClickListener mLeftClickListener = new C00911();
    public OnClickListener mRightClickListener = new C00922();
    ImageButton mbutLeft = null;
    ImageButton mbutRight = null;
    private ImageSwitcher misViewer = null;
    int nPosition = -1;
    int nType = 0;
    Animation rin;
    Animation rout;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C00911 implements OnClickListener {
        C00911() {
        }

        public void onClick(View v) {
            if (Edit02_Image_Activity.this.nPosition != 0) {
                Edit02_Image_Activity.this.misViewer.setInAnimation(Edit02_Image_Activity.this.lin);
                Edit02_Image_Activity.this.misViewer.setOutAnimation(Edit02_Image_Activity.this.rout);
                Edit02_Image_Activity edit02_Image_Activity = Edit02_Image_Activity.this;
                edit02_Image_Activity.nPosition--;
                if (Edit02_Image_Activity.this.nPosition < Edit02_Image_Activity.this.Items.size() - 1) {
                    Edit02_Image_Activity.this.mbutRight.setVisibility(0);
                }
                if (Edit02_Image_Activity.this.nPosition == 0) {
                    Edit02_Image_Activity.this.mbutLeft.setVisibility(4);
                } else {
                    Edit02_Image_Activity.this.mbutLeft.setVisibility(0);
                }
                Edit02_Image_Activity.this.SetImage(Edit02_Image_Activity.this.nPosition);
            }
        }
    }

    class C00922 implements OnClickListener {
        C00922() {
        }

        public void onClick(View v) {
            if (Edit02_Image_Activity.this.nPosition != Edit02_Image_Activity.this.Items.size() - 1) {
                Edit02_Image_Activity.this.misViewer.setInAnimation(Edit02_Image_Activity.this.rin);
                Edit02_Image_Activity.this.misViewer.setOutAnimation(Edit02_Image_Activity.this.lout);
                Edit02_Image_Activity edit02_Image_Activity = Edit02_Image_Activity.this;
                edit02_Image_Activity.nPosition++;
                if (Edit02_Image_Activity.this.nPosition > 0) {
                    Edit02_Image_Activity.this.mbutLeft.setVisibility(0);
                }
                if (Edit02_Image_Activity.this.nPosition == Edit02_Image_Activity.this.Items.size() - 1) {
                    Edit02_Image_Activity.this.mbutRight.setVisibility(4);
                } else {
                    Edit02_Image_Activity.this.mbutRight.setVisibility(0);
                }
                Edit02_Image_Activity.this.SetImage(Edit02_Image_Activity.this.nPosition);
            }
        }
    }

    class C00933 implements OnClickListener {
        C00933() {
        }

        public void onClick(View v) {
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            int nIdx = ((CustomListItem) Edit02_Image_Activity.this.Items.get(Edit02_Image_Activity.this.nPosition)).getIdx();
            int nNumber = ((CustomListItem) Edit02_Image_Activity.this.Items.get(Edit02_Image_Activity.this.nPosition)).getNumber();
            strDisplayName = ((CustomListItem) Edit02_Image_Activity.this.Items.get(Edit02_Image_Activity.this.nPosition)).getDisplayName();
            strPath = ((CustomListItem) Edit02_Image_Activity.this.Items.get(Edit02_Image_Activity.this.nPosition)).getPath();
            if (Edit02_Image_Activity.this.mDBManager.execSQL("DELETE FROM `" + Edit02_Image_Activity.this.strTableName + "` WHERE `idx` = " + nIdx)) {
                Edit02_Image_Activity.this.Items.remove(Edit02_Image_Activity.this.nPosition);
            } else {
                Toast.makeText(Edit02_Image_Activity.this.mContext, "Error", 0).show();
            }
            Edit02_Image_Activity.this.finish();
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.edit02_image);
        onInit(getApplicationContext());
        this.misViewer.setFactory(this);
        this.lin = AnimationUtils.loadAnimation(this.mContext, C0181R.anim.left_in);
        this.lout = AnimationUtils.loadAnimation(this.mContext, C0181R.anim.left_out);
        this.rin = AnimationUtils.loadAnimation(this.mContext, C0181R.anim.right_in);
        this.rout = AnimationUtils.loadAnimation(this.mContext, C0181R.anim.right_out);
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        onRead();
    }

    protected void onDestroy() {
        if (this.bm != null) {
            this.bm.recycle();
        }
        this.bm = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.misViewer != null) {
            this.misViewer.setImageDrawable(null);
        }
        this.misViewer = null;
        recursiveRecycle(getWindow().getDecorView());
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        System.gc();
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mbutLeft = null;
        this.mbutRight = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.bm != null) {
            this.bm.recycle();
        }
        this.bm = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        TextView tvTitle = (TextView) findViewById(C0181R.id.edit02_image_textView_Title);
        this.misViewer = (ImageSwitcher) findViewById(C0181R.id.edit02_image_imageSwitcher_Viewer);
        this.mbutLeft = (ImageButton) findViewById(C0181R.id.edit02_image_button_Left);
        this.mbutRight = (ImageButton) findViewById(C0181R.id.edit02_image_button_Right);
        ImageButton butDelete = (ImageButton) findViewById(C0181R.id.edit02_image_imageButton_Delete);
        if (tvTitle == null || this.misViewer == null || this.mbutLeft == null || this.mbutRight == null || butDelete == null) {
            return false;
        }
        this.mbutLeft.setOnClickListener(this.mLeftClickListener);
        this.mbutRight.setOnClickListener(this.mRightClickListener);
        butDelete.setOnClickListener(this.mDeleteClickListener);
        this.gestureDetector = new GestureDetector(this);
        this.Items = new ArrayList();
        this.mCr = getContentResolver();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nPosition = intent.getIntExtra("position", -1);
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 2) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER, " + "`thumb_path` TEXT" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nPosition = nPosition;
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    void SetImage(int nPos) {
        if (nPos >= 0 && nPos < this.Items.size()) {
            Picasso.with(this.mContext).load(new File(((CustomListItem) this.Items.get(nPos)).getPath())).into((ImageView) this.misViewer.getCurrentView());
        }
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
        if (this.mCursor == null) {
            return false;
        }
        if (this.mCursor.moveToFirst()) {
            int nNumber = 0;
            while (!this.mCursor.isAfterLast()) {
                int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                strDisplayName = this.mCursor.getString(this.mCursor.getColumnIndex("display_name"));
                strInfo1 = this.mCursor.getString(this.mCursor.getColumnIndex("info1"));
                strInfo2 = this.mCursor.getString(this.mCursor.getColumnIndex("info2"));
                strInfo3 = this.mCursor.getString(this.mCursor.getColumnIndex("info3"));
                strInfo4 = this.mCursor.getString(this.mCursor.getColumnIndex("info4"));
                strInfo5 = this.mCursor.getString(this.mCursor.getColumnIndex("info5"));
                strPath = this.mCursor.getString(this.mCursor.getColumnIndex("path"));
                int nSize = this.mCursor.getInt(this.mCursor.getColumnIndex("size"));
                CustomListItem Item = new CustomListItem(nNumber, strDisplayName, strInfo1, strInfo2, strInfo3, strInfo4, strInfo5, strPath, (long) nSize, this.mCursor.getString(this.mCursor.getColumnIndex("thumb_path")));
                Item.setIdx(nIdx);
                this.Items.add(Item);
                this.mCursor.moveToNext();
                nNumber++;
            }
            this.mCursor.close();
            if (this.nPosition == 0) {
                this.mbutLeft.setVisibility(4);
            } else if (this.nPosition == this.Items.size() - 1) {
                this.mbutRight.setVisibility(4);
            }
            SetImage(this.nPosition);
            return true;
        }
        this.mCursor.close();
        return false;
    }

    public View makeView() {
        ImageView i = new ImageView(this.mContext);
        i.setBackgroundColor(-16777216);
        i.setScaleType(ScaleType.FIT_CENTER);
        i.setLayoutParams(new LayoutParams(-1, -1));
        return i;
    }

    public void onItemSelected(AdapterView<?> adapterView, View view, int position, long id) {
    }

    public void onNothingSelected(AdapterView<?> adapterView) {
    }

    public boolean onTouchEvent(MotionEvent ev) {
        return this.gestureDetector.onTouchEvent(ev);
    }

    public boolean onDown(MotionEvent e) {
        return false;
    }

    public void onShowPress(MotionEvent e) {
    }

    public boolean onSingleTapUp(MotionEvent e) {
        return false;
    }

    public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
        return false;
    }

    public void onLongPress(MotionEvent e) {
    }

    public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
        try {
            if (Math.abs(e1.getY() - e2.getY()) <= 250.0f && ((e1.getX() - e2.getX() <= 120.0f || Math.abs(velocityX) <= 200.0f) && ((e2.getX() - e1.getX() <= 120.0f || Math.abs(velocityX) <= 200.0f) && ((e1.getY() - e2.getY() <= 120.0f || Math.abs(velocityX) <= 200.0f) && e2.getY() - e1.getY() > 120.0f)))) {
                Math.abs(velocityX);
            }
        } catch (Exception e) {
        }
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }
}
