package com.enus.myzik;

import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.provider.MediaStore.Audio.Playlists;
import android.provider.MediaStore.Audio.Playlists.Members;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.FrameLayout.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.enus.myzik.DListView.DropListener;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class Edit_Audio_Activity extends MzActivity {
    private CustomEditListAdapter Adapter;
    private ArrayList<CustomListItem> Items = null;
    private TextView lvf_txt = null;
    private View lvfooter = null;
    public OnClickListener mAddClickListener = new C00963();
    Context mContext;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDoneClickListener = new C00952();
    private DropListener mDropListener = new C04424();
    OnItemClickListener mItemClickListener = new C00941();
    DListView mdlvList = null;
    TextView mtvCount = null;
    TextView mtvText = null;
    int nType = 0;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C00941 implements OnItemClickListener {
        C00941() {
        }

        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            Toast.makeText(Edit_Audio_Activity.this.mContext, ((CustomListItem) parent.getAdapter().getItem(position)).getDisplayName(), 0).show();
            Edit_Audio_Activity.this.Adapter.notifyDataSetChanged();
        }
    }

    class C00952 implements OnClickListener {
        C00952() {
        }

        public void onClick(View v) {
            if (Edit_Audio_Activity.this.Adapter != null) {
                Edit_Audio_Activity.this.Adapter.onSort();
            }
            Edit_Audio_Activity.this.EmptyPL(Edit_Audio_Activity.this.strListName);
            Edit_Audio_Activity.this.MakePL(Edit_Audio_Activity.this.strListName);
            Edit_Audio_Activity.this.finish();
        }
    }

    class C00963 implements OnClickListener {
        C00963() {
        }

        public void onClick(View v) {
            if (Edit_Audio_Activity.this.Adapter != null) {
                Edit_Audio_Activity.this.Adapter.onSort();
            }
            Edit_Audio_Activity.this.EmptyPL(Edit_Audio_Activity.this.strListName);
            Edit_Audio_Activity.this.MakePL(Edit_Audio_Activity.this.strListName);
            Intent intent = new Intent(Edit_Audio_Activity.this, Add_Audio_Activity.class);
            intent.putExtra("type", Edit_Audio_Activity.this.nType);
            intent.putExtra("list_name", Edit_Audio_Activity.this.strListName);
            intent.putExtra("table_name", Edit_Audio_Activity.this.strTableName);
            Edit_Audio_Activity.this.startActivity(intent);
            Edit_Audio_Activity.this.finish();
        }
    }

    class C04424 implements DropListener {
        C04424() {
        }

        public void drop(int from, int to) {
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.edit_audio);
        onInit(getApplicationContext());
        if (this.Adapter != null) {
            this.Adapter.clear();
        }
        this.Adapter = null;
        this.Adapter = new CustomEditListAdapter(this.mContext, C0181R.layout.edit_item, this.Items);
        this.Adapter.onInit(this.mDBManager, this.strTableName, this.mtvCount);
        this.mdlvList.setEmptyView(this.mtvText);
        this.mdlvList.setOnCreateContextMenuListener(this);
        this.mdlvList.setAdapter(this.Adapter);
        this.mdlvList.setDropListener(this.mDropListener);
        this.mdlvList.setOnItemClickListener(this.mItemClickListener);
        this.mdlvList.onInit();
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        GetPL();
        this.Adapter.notifyDataSetChanged();
    }

    protected void onDestroy() {
        recursiveRecycle(getWindow().getDecorView());
        System.gc();
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
    }

    public void MakePL(String strPLName) {
        ContentResolver resolver = getContentResolver();
        Cursor c = resolver.query(Playlists.EXTERNAL_CONTENT_URI, null, "name=?", new String[]{strPLName}, null);
        c.moveToFirst();
        if (c.isAfterLast()) {
            ContentValues values = new ContentValues();
            values.put("name", strPLName);
            resolver.insert(Playlists.EXTERNAL_CONTENT_URI, values);
            c.close();
        } else {
            long nID = c.getLong(0);
            String strID = EXTHeader.DEFAULT_VALUE;
            strID = c.getString(c.getColumnIndex("_ID"));
            c.close();
        }
        SetList4PLfromMem(strPLName);
    }

    public void EmptyPL(String strPLName) {
        ContentResolver resolver = getContentResolver();
        Cursor c = resolver.query(Playlists.EXTERNAL_CONTENT_URI, null, "name=?", new String[]{strPLName}, null);
        c.moveToFirst();
        if (!c.isAfterLast()) {
            long nID = c.getLong(0);
            c.close();
            resolver.delete(Members.getContentUri("external", nID), "audio_id > 0", null);
        }
    }

    public void SetList4PLfromMem(String strPLName) {
        ContentResolver resolver = getContentResolver();
        Cursor c = resolver.query(Playlists.EXTERNAL_CONTENT_URI, null, "name=?", new String[]{strPLName}, null);
        c.moveToFirst();
        if (!c.isAfterLast()) {
            long nID = c.getLong(0);
            c.close();
            Uri uri = Members.getContentUri("external", nID);
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strInfo1 = EXTHeader.DEFAULT_VALUE;
            String strInfo2 = EXTHeader.DEFAULT_VALUE;
            String strInfo3 = EXTHeader.DEFAULT_VALUE;
            String strInfo4 = EXTHeader.DEFAULT_VALUE;
            String strInfo5 = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            for (int i = 0; i < this.Items.size(); i++) {
                strInfo3 = ((CustomListItem) this.Items.get(i)).getInfo3();
                ContentValues values = new ContentValues();
                values.put("play_order", Integer.valueOf(i));
                values.put("audio_id", Long.valueOf(strInfo3));
                DLog.m0d("4pl", "MEM_PLAY_ORDER:" + Integer.valueOf(0).toString() + " AUDIO_ID:" + Long.valueOf(strInfo3).toString());
                resolver.insert(uri, values);
            }
        }
    }

    public void SetList4PL(String strPLName) {
        ContentResolver resolver = getContentResolver();
        Cursor c = resolver.query(Playlists.EXTERNAL_CONTENT_URI, null, "name=?", new String[]{strPLName}, null);
        c.moveToFirst();
        if (!c.isAfterLast()) {
            long nID = c.getLong(0);
            c.close();
            Uri uri = Members.getContentUri("external", nID);
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strInfo1 = EXTHeader.DEFAULT_VALUE;
            String strInfo2 = EXTHeader.DEFAULT_VALUE;
            String strInfo3 = EXTHeader.DEFAULT_VALUE;
            String strInfo4 = EXTHeader.DEFAULT_VALUE;
            String strInfo5 = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            this.mCursor = null;
            this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
            if (this.mCursor != null) {
                if (this.mCursor.moveToFirst()) {
                    int nNumber = 0;
                    while (!this.mCursor.isAfterLast()) {
                        int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                        strDisplayName = this.mCursor.getString(this.mCursor.getColumnIndex("display_name"));
                        strInfo1 = this.mCursor.getString(this.mCursor.getColumnIndex("info1"));
                        strInfo2 = this.mCursor.getString(this.mCursor.getColumnIndex("info2"));
                        strInfo3 = this.mCursor.getString(this.mCursor.getColumnIndex("info3"));
                        strInfo4 = this.mCursor.getString(this.mCursor.getColumnIndex("info4"));
                        strInfo5 = this.mCursor.getString(this.mCursor.getColumnIndex("info5"));
                        strPath = this.mCursor.getString(this.mCursor.getColumnIndex("path"));
                        int nSize = this.mCursor.getInt(this.mCursor.getColumnIndex("size"));
                        ContentValues values = new ContentValues();
                        values.put("play_order", Integer.valueOf(nNumber));
                        values.put("audio_id", Long.valueOf(strInfo3));
                        DLog.m0d("4pl", "PLAY_ORDER:" + Integer.valueOf(nNumber).toString() + " AUDIO_ID:" + Long.valueOf(strInfo3).toString());
                        resolver.insert(uri, values);
                        this.mCursor.moveToNext();
                        nNumber++;
                    }
                    this.mCursor.close();
                    return;
                }
                this.mCursor.close();
            }
        }
    }

    public void onBackPressed() {
        if (this.Adapter != null) {
            this.Adapter.onSort();
        }
        EmptyPL(this.strListName);
        MakePL(this.strListName);
        finish();
    }

    private int px(float dips) {
        return Math.round(dips * getResources().getDisplayMetrics().density);
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mdlvList = null;
        this.mtvText = null;
        this.mtvCount = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        this.mdlvList = (DListView) findViewById(C0181R.id.edit_audio_listView_Editlist);
        this.mtvText = (TextView) findViewById(C0181R.id.edit_audio_textView_EmptyView);
        TextView tvTitle = (TextView) findViewById(C0181R.id.edit_audio_textView_Title);
        ImageButton butDone = (ImageButton) findViewById(C0181R.id.edit_audio_imageButton_Done);
        this.mtvCount = (TextView) findViewById(C0181R.id.edit_audio_textView_Count);
        ImageButton butAdd = (ImageButton) findViewById(C0181R.id.edit_audio_imageButton_Add);
        if (this.mdlvList == null || this.mtvText == null || tvTitle == null || butDone == null || this.mtvCount == null || butAdd == null) {
            return false;
        }
        final TextView lvf_txt = (TextView) findViewById(C0181R.id.edit_audio_lvf_txt);
        this.mdlvList.setOnScrollListener(new OnScrollListener() {

            class C00971 implements Runnable {
                C00971() {
                }

                public void run() {
                    Edit_Audio_Activity.this.mdlvList.setSelection(Edit_Audio_Activity.this.mdlvList.getCount() - 1);
                }
            }

            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState != 0) {
                    return;
                }
                if (Edit_Audio_Activity.this.mdlvList.IsScrollEnd()) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_Audio_Activity.this.px(40.0f));
                    Edit_Audio_Activity.this.mdlvList.setLayoutParams(layoutParams);
                    Edit_Audio_Activity.this.mdlvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_Audio_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_Audio_Activity.this.Items.size()), Edit_Audio_Activity.this.getResources().getString(C0181R.string.pl_songs)}));
                    lvf_txt.setVisibility(0);
                    new Handler().postDelayed(new C00971(), 10);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_Audio_Activity.this.mdlvList.setLayoutParams(layoutParams);
                lvf_txt.setVisibility(8);
            }

            public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
                if (totalItemCount <= 0) {
                    return;
                }
                if (Edit_Audio_Activity.this.mdlvList.IsScrollEnd() && Edit_Audio_Activity.this.mdlvList.getLastVisiblePosition() + 1 == totalItemCount) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_Audio_Activity.this.px(40.0f));
                    Edit_Audio_Activity.this.mdlvList.setLayoutParams(layoutParams);
                    Edit_Audio_Activity.this.mdlvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_Audio_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_Audio_Activity.this.Items.size()), Edit_Audio_Activity.this.getResources().getString(C0181R.string.pl_songs)}));
                    Handler handler = new Handler();
                    final TextView textView = lvf_txt;
                    handler.postDelayed(new Runnable() {
                        public void run() {
                            textView.setVisibility(0);
                        }
                    }, 20);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_Audio_Activity.this.mdlvList.setLayoutParams(layoutParams);
                Edit_Audio_Activity.this.mdlvList.refreshDrawableState();
                lvf_txt.setVisibility(8);
            }
        });
        butDone.setOnClickListener(this.mDoneClickListener);
        butAdd.setOnClickListener(this.mAddClickListener);
        this.Items = new ArrayList();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 1) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    private boolean GetPL() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        if (!this.mDBManager.execSQL("DROP TABLE IF EXISTS '" + this.strTableName + "'")) {
            Toast.makeText(this.mContext, "Error", 0).show();
        }
        if (this.nType == 1) {
            strQuery = "CREATE TABLE IF NOT EXISTS `" + this.strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER" + ")";
        } else {
            strQuery = EXTHeader.DEFAULT_VALUE;
        }
        if (!this.mDBManager.execSQL(strQuery)) {
            Toast.makeText(this.mContext, "Error", 0).show();
        }
        Cursor cursor = getContentResolver().query(Members.getContentUri("external", Long.valueOf(this.strTableName.substring(3)).longValue()), null, null, null, "play_order");
        if (cursor == null) {
            return false;
        }
        if (cursor.moveToFirst()) {
            int nNumber = 0;
            String strDisplayName = EXTHeader.DEFAULT_VALUE;
            String strInfo1 = EXTHeader.DEFAULT_VALUE;
            String strInfo2 = EXTHeader.DEFAULT_VALUE;
            String strInfo3 = EXTHeader.DEFAULT_VALUE;
            String strInfo4 = EXTHeader.DEFAULT_VALUE;
            String strInfo5 = EXTHeader.DEFAULT_VALUE;
            String strPath = EXTHeader.DEFAULT_VALUE;
            String strThumbPath = EXTHeader.DEFAULT_VALUE;
            while (!cursor.isAfterLast()) {
                int nColumnIdx = cursor.getColumnIndex("_display_name");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strDisplayName = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("artist");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strInfo1 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("album");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strInfo2 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("audio_id");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strInfo3 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("mime_type");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strInfo4 = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("title");
                if (nColumnIdx < 0) {
                    strInfo5 = strDisplayName;
                } else {
                    strInfo5 = cursor.getString(nColumnIdx);
                    if (strInfo5 == null) {
                        strInfo5 = strDisplayName;
                    } else if (strInfo5.length() <= 0) {
                        strInfo5 = strDisplayName;
                    }
                }
                nColumnIdx = cursor.getColumnIndex("_data");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                strPath = cursor.getString(nColumnIdx);
                nColumnIdx = cursor.getColumnIndex("_size");
                if (nColumnIdx < 0) {
                    cursor.close();
                    return false;
                }
                long nSize = cursor.getLong(nColumnIdx);
                DLog.m0d("4pl", this.strTableName + "//PLAY_ORDER:" + Integer.valueOf(nNumber + 1).toString() + " AUDIO_ID:" + Long.valueOf(strInfo3).toString());
                this.Items.add(new CustomListItem(nNumber, strInfo5, strInfo1, strInfo2, strInfo3, strInfo4, strDisplayName, strPath, nSize, EXTHeader.DEFAULT_VALUE));
                cursor.moveToNext();
                nNumber++;
            }
            cursor.close();
            if (this.mtvCount != null) {
                this.mtvCount.setText(new StringBuilder(String.valueOf(getResources().getString(C0181R.string.pl_total))).append(" ").append(this.Items.size()).append(" ").append(getResources().getString(C0181R.string.pl_songs)).toString());
            }
            return true;
        }
        cursor.close();
        return false;
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        int nCount = this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE);
        if (nCount >= 0) {
            this.mtvCount.setText(new StringBuilder(String.valueOf(getResources().getString(C0181R.string.pl_total))).append(" ").append(nCount).append(" ").append(getResources().getString(C0181R.string.pl_songs)).toString());
            this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
            if (this.mCursor == null) {
                return false;
            }
            if (this.mCursor.moveToFirst()) {
                int nNumber = 0;
                while (!this.mCursor.isAfterLast()) {
                    int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                    CustomListItem Item = new CustomListItem(nNumber, this.mCursor.getString(this.mCursor.getColumnIndex("display_name")), this.mCursor.getString(this.mCursor.getColumnIndex("info1")), this.mCursor.getString(this.mCursor.getColumnIndex("info2")), this.mCursor.getString(this.mCursor.getColumnIndex("info3")), this.mCursor.getString(this.mCursor.getColumnIndex("info4")), this.mCursor.getString(this.mCursor.getColumnIndex("info5")), this.mCursor.getString(this.mCursor.getColumnIndex("path")), (long) this.mCursor.getInt(this.mCursor.getColumnIndex("size")), EXTHeader.DEFAULT_VALUE);
                    Item.setIdx(nIdx);
                    this.Items.add(Item);
                    this.mCursor.moveToNext();
                    nNumber++;
                }
                this.mCursor.close();
                return true;
            }
            this.mCursor.close();
            return false;
        }
        Toast.makeText(this.mContext, "Error", 0).show();
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case 4:
                if (this.Adapter != null) {
                    this.Adapter.onSort();
                    break;
                }
                break;
        }
        return super.onKeyDown(keyCode, event);
    }
}
