package com.enus.myzik;

import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.webkit.MimeTypeMap;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.FrameLayout.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.enus.myzik.DFileView.DropListener;
import com.wireme.mediaserver.ContentTree;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class Edit_File_Activity extends MzActivity {
    private CustomEditFileAdapter Adapter;
    private ArrayList<CustomListItem> Items;
    private TextView lvf_txt = null;
    private View lvfooter = null;
    public OnClickListener mAddClickListener = new C01023();
    Context mContext;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDoneClickListener = new C01012();
    private DropListener mDropListener = new C04434();
    OnItemClickListener mItemClickListener = new C01001();
    DFileView mdfvList = null;
    TextView mtvCount = null;
    TextView mtvText = null;
    int nType = 0;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C01001 implements OnItemClickListener {
        C01001() {
        }

        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            Toast.makeText(Edit_File_Activity.this.mContext, ((CustomListItem) parent.getAdapter().getItem(position)).getDisplayName(), 0).show();
            Edit_File_Activity.this.Adapter.notifyDataSetChanged();
        }
    }

    class C01012 implements OnClickListener {
        C01012() {
        }

        public void onClick(View v) {
            if (Edit_File_Activity.this.Adapter != null) {
                Edit_File_Activity.this.Adapter.onSort();
            }
            Edit_File_Activity.this.finish();
        }
    }

    class C01023 implements OnClickListener {
        C01023() {
        }

        public void onClick(View v) {
            Intent intent = new Intent(Edit_File_Activity.this, Add_File_Activity.class);
            intent.putExtra("type", Edit_File_Activity.this.nType);
            intent.putExtra("list_name", Edit_File_Activity.this.strListName);
            intent.putExtra("table_name", Edit_File_Activity.this.strTableName);
            if (new File("/storage").listFiles() != null) {
                intent.putExtra("e_path", "/storage");
            } else {
                intent.putExtra("e_path", "/mnt");
            }
            Edit_File_Activity.this.startActivity(intent);
            Edit_File_Activity.this.finish();
        }
    }

    class C04434 implements DropListener {
        C04434() {
        }

        public void drop(int from, int to) {
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.edit_file);
        onInit(getApplicationContext());
        if (this.Adapter != null) {
            this.Adapter.clear();
        }
        this.Adapter = null;
        this.Adapter = new CustomEditFileAdapter(this.mContext, C0181R.layout.edit_file_item, this.Items);
        this.Adapter.onInit(this.mDBManager, this.strTableName, this.mtvCount);
        this.mdfvList.setEmptyView(this.mtvText);
        this.mdfvList.setOnCreateContextMenuListener(this);
        this.mdfvList.setDropListener(this.mDropListener);
        this.mdfvList.setAdapter(this.Adapter);
        this.mdfvList.setOnItemClickListener(this.mItemClickListener);
        this.mdfvList.onInit();
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        onRead();
        this.Adapter.notifyDataSetChanged();
    }

    protected void onDestroy() {
        recursiveRecycle(getWindow().getDecorView());
        System.gc();
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
    }

    public boolean setFileTable(String strPath) {
        ContentValues values = new ContentValues();
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        String strArgs = EXTHeader.DEFAULT_VALUE;
        File file = new File(strPath);
        int nSize = (int) file.length();
        String strExt = MimeTypeMap.getFileExtensionFromUrl(Uri.fromFile(file).toString()).toLowerCase();
        String strFName = file.getName();
        strFName = strFName.substring(0, (strFName.length() - strExt.length()) - 1);
        values.put("info4", String.format("file/%s", new Object[]{strExt}));
        values.put("info5", strFName);
        values.put("display_name", file.getName());
        values.put("path", strPath);
        values.put("size", Integer.valueOf(nSize));
        if (this.mDBManager != null) {
            if (this.mDBManager.onInsert(this.strTableName, values) == -1) {
                Toast.makeText(this.mContext, "Ins Fail", 1).show();
            }
        }
        return true;
    }

    public String getImgPath(Uri uri) {
        String strRes = EXTHeader.DEFAULT_VALUE;
        Cursor cursor = managedQuery(uri, new String[]{"_data"}, null, null, null);
        if (cursor == null) {
            return strRes;
        }
        int column_index = cursor.getColumnIndexOrThrow("_data");
        if (column_index == -1 || !cursor.moveToFirst()) {
            return strRes;
        }
        return cursor.getString(column_index);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        DLog.m0d("mz", "onActivityResult");
        switch (requestCode) {
            case 1:
                DLog.m0d("mz", ContentTree.VIDEO_ID);
                if (resultCode == -1) {
                    DLog.m0d("mz", "RESULT_OK");
                    String FilePath = getImgPath(data.getData());
                    if (FilePath.length() < 1) {
                        FilePath = data.getData().getPath();
                    }
                    setFileTable(FilePath);
                    DLog.m0d("mz", FilePath);
                    return;
                }
                return;
            default:
                return;
        }
    }

    private int px(float dips) {
        return Math.round(dips * getResources().getDisplayMetrics().density);
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mdfvList = null;
        this.mtvText = null;
        this.mtvCount = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        this.mdfvList = (DFileView) findViewById(C0181R.id.edit_file_listView_Editlist);
        this.mtvText = (TextView) findViewById(C0181R.id.edit_file_textView_EmptyView);
        TextView tvTitle = (TextView) findViewById(C0181R.id.edit_file_textView_Title);
        ImageButton butDone = (ImageButton) findViewById(C0181R.id.edit_file_imageButton_Done);
        this.mtvCount = (TextView) findViewById(C0181R.id.edit_file_textView_Count);
        ImageButton butAdd = (ImageButton) findViewById(C0181R.id.edit_file_imageButton_Add);
        if (this.mdfvList == null || this.mtvText == null || tvTitle == null || butDone == null || this.mtvCount == null || butAdd == null) {
            return false;
        }
        final TextView lvf_txt = (TextView) findViewById(C0181R.id.edit_file_lvf_txt);
        this.mdfvList.setOnScrollListener(new OnScrollListener() {

            class C01031 implements Runnable {
                C01031() {
                }

                public void run() {
                    Edit_File_Activity.this.mdfvList.setSelection(Edit_File_Activity.this.mdfvList.getCount() - 1);
                }
            }

            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState != 0) {
                    return;
                }
                if (Edit_File_Activity.this.mdfvList.IsScrollEnd()) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_File_Activity.this.px(40.0f));
                    Edit_File_Activity.this.mdfvList.setLayoutParams(layoutParams);
                    Edit_File_Activity.this.mdfvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_File_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_File_Activity.this.Items.size()), Edit_File_Activity.this.getResources().getString(C0181R.string.pl_files)}));
                    lvf_txt.setVisibility(0);
                    new Handler().postDelayed(new C01031(), 10);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_File_Activity.this.mdfvList.setLayoutParams(layoutParams);
                lvf_txt.setVisibility(8);
            }

            public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
                if (totalItemCount <= 0) {
                    return;
                }
                if (Edit_File_Activity.this.mdfvList.IsScrollEnd() && Edit_File_Activity.this.mdfvList.getLastVisiblePosition() + 1 == totalItemCount) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_File_Activity.this.px(40.0f));
                    Edit_File_Activity.this.mdfvList.setLayoutParams(layoutParams);
                    Edit_File_Activity.this.mdfvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_File_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_File_Activity.this.Items.size()), Edit_File_Activity.this.getResources().getString(C0181R.string.pl_files)}));
                    Handler handler = new Handler();
                    final TextView textView = lvf_txt;
                    handler.postDelayed(new Runnable() {
                        public void run() {
                            textView.setVisibility(0);
                        }
                    }, 20);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_File_Activity.this.mdfvList.setLayoutParams(layoutParams);
                Edit_File_Activity.this.mdfvList.refreshDrawableState();
                lvf_txt.setVisibility(8);
            }
        });
        butDone.setOnClickListener(this.mDoneClickListener);
        butAdd.setOnClickListener(this.mAddClickListener);
        this.Items = new ArrayList();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 4) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        int nCount = this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE);
        if (nCount >= 0) {
            this.mtvCount.setText(new StringBuilder(String.valueOf(this.mContext.getResources().getString(C0181R.string.pl_total))).append(" ").append(nCount).append(" ").append(this.mContext.getResources().getString(C0181R.string.pl_files)).toString());
            this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
            if (this.mCursor == null) {
                return false;
            }
            if (this.mCursor.moveToFirst()) {
                int nNumber = 0;
                while (!this.mCursor.isAfterLast()) {
                    int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                    CustomListItem Item = new CustomListItem(nNumber, this.mCursor.getString(this.mCursor.getColumnIndex("display_name")), this.mCursor.getString(this.mCursor.getColumnIndex("info1")), this.mCursor.getString(this.mCursor.getColumnIndex("info2")), this.mCursor.getString(this.mCursor.getColumnIndex("info3")), this.mCursor.getString(this.mCursor.getColumnIndex("info4")), this.mCursor.getString(this.mCursor.getColumnIndex("info5")), this.mCursor.getString(this.mCursor.getColumnIndex("path")), (long) this.mCursor.getInt(this.mCursor.getColumnIndex("size")), EXTHeader.DEFAULT_VALUE);
                    Item.setIdx(nIdx);
                    this.Items.add(Item);
                    this.mCursor.moveToNext();
                    nNumber++;
                }
                this.mCursor.close();
                return true;
            }
            this.mCursor.close();
            return false;
        }
        Toast.makeText(this.mContext, "Error", 0).show();
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case 4:
                if (this.Adapter != null) {
                    this.Adapter.onSort();
                    break;
                }
                break;
        }
        return super.onKeyDown(keyCode, event);
    }
}
