package com.enus.myzik;

import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore.Video.Thumbnails;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.FrameLayout.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.enus.myzik.DVideoView.DropListener;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class Edit_Video_Activity extends MzActivity {
    static final int STATE_DONE = 0;
    static final int STATE_RUNNING = 1;
    static final int STATE_STOP = 2;
    private CustomEditVideoAdapter Adapter;
    private ArrayList<CustomListItem> Items;
    private TextView lvf_txt = null;
    private View lvfooter = null;
    public OnClickListener mAddClickListener = new C01213();
    Context mContext;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDoneClickListener = new C01202();
    private DropListener mDropListener = new C04474();
    final Handler mHandlerV = new C01225();
    OnItemClickListener mItemClickListener = new C01191();
    ProgressThread m_Thread = null;
    DVideoView mdvvList = null;
    TextView mtvCount = null;
    TextView mtvText = null;
    int nType = 0;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C01191 implements OnItemClickListener {
        C01191() {
        }

        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            Toast.makeText(Edit_Video_Activity.this.mContext, ((CustomListItem) parent.getAdapter().getItem(position)).getDisplayName(), 0).show();
            Edit_Video_Activity.this.Adapter.notifyDataSetChanged();
        }
    }

    class C01202 implements OnClickListener {
        C01202() {
        }

        public void onClick(View v) {
            if (Edit_Video_Activity.this.Adapter != null) {
                Edit_Video_Activity.this.Adapter.onSort();
            }
            Edit_Video_Activity.this.finish();
        }
    }

    class C01213 implements OnClickListener {
        C01213() {
        }

        public void onClick(View v) {
            if (Edit_Video_Activity.this.Adapter != null) {
                Edit_Video_Activity.this.Adapter.onSort();
            }
            Intent intent = new Intent(Edit_Video_Activity.this, Add_Video_Activity.class);
            intent.putExtra("type", Edit_Video_Activity.this.nType);
            intent.putExtra("list_name", Edit_Video_Activity.this.strListName);
            intent.putExtra("table_name", Edit_Video_Activity.this.strTableName);
            Edit_Video_Activity.this.startActivity(intent);
            Edit_Video_Activity.this.finish();
        }
    }

    class C01225 extends Handler {
        C01225() {
        }

        public void handleMessage(Message msg) {
            if (msg.what == 0) {
                Edit_Video_Activity.this.Adapter.notifyDataSetChanged();
            } else if (msg.what == 1) {
                Edit_Video_Activity.this.Adapter.notifyDataSetChanged();
            }
        }
    }

    class C01267 implements Runnable {
        C01267() {
        }

        public void run() {
            try {
                Edit_Video_Activity.this.m_Thread.start();
            } catch (NullPointerException e) {
                e.printStackTrace();
            }
        }
    }

    private class ProgressThread extends Thread {
        static final int STATE_DONE = 0;
        static final int STATE_RUNNING = 1;
        static final int STATE_STOP = 2;
        Handler mHandler;
        int nState = 0;
        int nTotal = 0;

        ProgressThread(Handler h) {
            this.mHandler = h;
        }

        public void run() {
            this.nState = 1;
            this.nTotal = 0;
            this.nTotal = Edit_Video_Activity.this.Items.size();
            int i = 0;
            while (i < this.nTotal) {
                if (i > 0) {
                    try {
                        if (i % 5 == 0) {
                            Thread.sleep(50);
                        }
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
                if (this.nState != 1 || Edit_Video_Activity.this.m_Thread.isInterrupted()) {
                    break;
                }
                CustomListItem Item = (CustomListItem) Edit_Video_Activity.this.Items.get(i);
                Bitmap bm = null;
                if (Item.getInfo4().compareTo("video/mp4") == 0) {
                    bm = Thumbnails.getThumbnail(Edit_Video_Activity.this.mContext.getContentResolver(), Long.parseLong(Item.getInfo3()), 3, null);
                }
                if (bm != null) {
                    Item.setBitmap(bm);
                    Edit_Video_Activity.this.Items.set(i, Item);
                }
                if (i > 0 && i % 2 == 0 && this.mHandler != null) {
                    this.mHandler.sendEmptyMessage(0);
                }
                i++;
            }
            if (this.mHandler != null) {
                this.mHandler.sendEmptyMessage(1);
            }
            this.nState = 0;
        }

        public void onInit() {
            this.nState = 0;
        }

        public void setStateType(int nState) {
            if (this.nState != 0) {
                this.nState = nState;
            }
        }

        public int getStateType() {
            return this.nState;
        }
    }

    class C04474 implements DropListener {
        C04474() {
        }

        public void drop(int from, int to) {
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.edit_video);
        onInit(getApplicationContext());
        if (this.Adapter != null) {
            this.Adapter.clear();
        }
        this.Adapter = null;
        this.Adapter = new CustomEditVideoAdapter(this.mContext, C0181R.layout.edit_video_item, this.Items);
        this.Adapter.onInit(this.mDBManager, this.strTableName, this.mtvCount);
        this.mdvvList.setEmptyView(this.mtvText);
        this.mdvvList.setOnCreateContextMenuListener(this);
        this.mdvvList.setDropListener(this.mDropListener);
        this.mdvvList.setAdapter(this.Adapter);
        this.mdvvList.setOnItemClickListener(this.mItemClickListener);
        this.mdvvList.onInit();
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        onRead();
        this.Adapter.notifyDataSetChanged();
    }

    protected void onDestroy() {
        if (this.m_Thread != null) {
            boolean bDestroy = true;
            if (this.m_Thread.isAlive()) {
                bDestroy = false;
            }
            while (!bDestroy) {
                this.m_Thread.interrupt();
                this.m_Thread.setStateType(2);
                try {
                    this.m_Thread.join(1000);
                    bDestroy = true;
                } catch (InterruptedException e) {
                    e.printStackTrace();
                    this.m_Thread.stop();
                    this.m_Thread.destroy();
                }
            }
        }
        this.m_Thread = null;
        recursiveRecycle(getWindow().getDecorView());
        System.gc();
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
    }

    private int px(float dips) {
        return Math.round(dips * getResources().getDisplayMetrics().density);
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mdvvList = null;
        this.mtvText = null;
        this.mtvCount = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        this.mdvvList = (DVideoView) findViewById(C0181R.id.edit_video_listView_Editlist);
        this.mtvText = (TextView) findViewById(C0181R.id.edit_video_textView_EmptyView);
        TextView tvTitle = (TextView) findViewById(C0181R.id.edit_video_textView_Title);
        ImageButton butDone = (ImageButton) findViewById(C0181R.id.edit_video_imageButton_Done);
        this.mtvCount = (TextView) findViewById(C0181R.id.edit_video_textView_Count);
        ImageButton butAdd = (ImageButton) findViewById(C0181R.id.edit_video_imageButton_Add);
        if (this.mdvvList == null || this.mtvText == null || tvTitle == null || butDone == null || this.mtvCount == null || butAdd == null) {
            return false;
        }
        final TextView lvf_txt = (TextView) findViewById(C0181R.id.edit_video_lvf_txt);
        this.mdvvList.setOnScrollListener(new OnScrollListener() {

            class C01231 implements Runnable {
                C01231() {
                }

                public void run() {
                    Edit_Video_Activity.this.mdvvList.setSelection(Edit_Video_Activity.this.mdvvList.getCount() - 1);
                }
            }

            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState != 0) {
                    return;
                }
                if (Edit_Video_Activity.this.mdvvList.IsScrollEnd()) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_Video_Activity.this.px(40.0f));
                    Edit_Video_Activity.this.mdvvList.setLayoutParams(layoutParams);
                    Edit_Video_Activity.this.mdvvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_Video_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_Video_Activity.this.Items.size()), Edit_Video_Activity.this.getResources().getString(C0181R.string.pl_videos)}));
                    lvf_txt.setVisibility(0);
                    new Handler().postDelayed(new C01231(), 10);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_Video_Activity.this.mdvvList.setLayoutParams(layoutParams);
                lvf_txt.setVisibility(8);
            }

            public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
                if (totalItemCount <= 0) {
                    return;
                }
                if (Edit_Video_Activity.this.mdvvList.IsScrollEnd() && Edit_Video_Activity.this.mdvvList.getLastVisiblePosition() + 1 == totalItemCount) {
                    LayoutParams layoutParams = new LayoutParams(-1, -2, 0);
                    layoutParams.setMargins(0, 0, 0, Edit_Video_Activity.this.px(40.0f));
                    Edit_Video_Activity.this.mdvvList.setLayoutParams(layoutParams);
                    Edit_Video_Activity.this.mdvvList.refreshDrawableState();
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    lvf_txt.setText(String.format("%s %d %s", new Object[]{Edit_Video_Activity.this.getResources().getString(C0181R.string.pl_total), Integer.valueOf(Edit_Video_Activity.this.Items.size()), Edit_Video_Activity.this.getResources().getString(C0181R.string.pl_videos)}));
                    Handler handler = new Handler();
                    final TextView textView = lvf_txt;
                    handler.postDelayed(new Runnable() {
                        public void run() {
                            textView.setVisibility(0);
                        }
                    }, 20);
                    return;
                }
                layoutParams = new LayoutParams(-1, -2, 0);
                layoutParams.setMargins(0, 0, 0, 0);
                Edit_Video_Activity.this.mdvvList.setLayoutParams(layoutParams);
                Edit_Video_Activity.this.mdvvList.refreshDrawableState();
                lvf_txt.setVisibility(8);
            }
        });
        butDone.setOnClickListener(this.mDoneClickListener);
        butAdd.setOnClickListener(this.mAddClickListener);
        this.Items = new ArrayList();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 3) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER, " + "`thumb_path` TEXT" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        int nCount = this.mDBManager.onCount(this.strTableName, EXTHeader.DEFAULT_VALUE);
        if (nCount >= 0) {
            this.mtvCount.setText(new StringBuilder(String.valueOf(this.mContext.getResources().getString(C0181R.string.pl_total))).append(" ").append(nCount).append(" ").append(this.mContext.getResources().getString(C0181R.string.pl_videos)).toString());
            this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
            if (this.mCursor == null) {
                return false;
            }
            if (this.mCursor.moveToFirst()) {
                int nNumber = 0;
                while (!this.mCursor.isAfterLast()) {
                    int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                    strDisplayName = this.mCursor.getString(this.mCursor.getColumnIndex("display_name"));
                    strInfo1 = this.mCursor.getString(this.mCursor.getColumnIndex("info1"));
                    strInfo2 = this.mCursor.getString(this.mCursor.getColumnIndex("info2"));
                    strInfo3 = this.mCursor.getString(this.mCursor.getColumnIndex("info3"));
                    strInfo4 = this.mCursor.getString(this.mCursor.getColumnIndex("info4"));
                    strInfo5 = this.mCursor.getString(this.mCursor.getColumnIndex("info5"));
                    strPath = this.mCursor.getString(this.mCursor.getColumnIndex("path"));
                    int nSize = this.mCursor.getInt(this.mCursor.getColumnIndex("size"));
                    CustomListItem Item = new CustomListItem(nNumber, strDisplayName, strInfo1, strInfo2, strInfo3, strInfo4, strInfo5, strPath, (long) nSize, this.mCursor.getString(this.mCursor.getColumnIndex("thumb_path")));
                    Item.setIdx(nIdx);
                    this.Items.add(Item);
                    this.mCursor.moveToNext();
                    nNumber++;
                }
                this.mCursor.close();
                if (this.m_Thread != null) {
                    boolean bDestroy = true;
                    if (this.m_Thread.isAlive()) {
                        bDestroy = false;
                    }
                    while (!bDestroy) {
                        this.m_Thread.interrupt();
                        this.m_Thread.setStateType(2);
                        try {
                            this.m_Thread.join(1000);
                            bDestroy = true;
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                            this.m_Thread.stop();
                            this.m_Thread.destroy();
                        }
                    }
                }
                this.m_Thread = null;
                this.m_Thread = new ProgressThread(this.mHandlerV);
                this.m_Thread.onInit();
                this.m_Thread.setDaemon(true);
                new Handler().postDelayed(new C01267(), 500);
                return true;
            }
            this.mCursor.close();
            return false;
        }
        Toast.makeText(this.mContext, "Error", 0).show();
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case 4:
                if (this.Adapter != null) {
                    this.Adapter.onSort();
                    break;
                }
                break;
        }
        return super.onKeyDown(keyCode, event);
    }
}
