package com.enus.myzik;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences.Editor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Process;
import android.util.Log;
import com.google.android.gcm.GCMBaseIntentService;
import com.wireme.mediaserver.ContentTree;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.UnknownHostException;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.teleal.cling.model.message.header.EXTHeader;

public class GCMIntentService extends GCMBaseIntentService {
    private static final String PROJECT_ID = "481614878118";
    private static final String tag = "GCMIntentService";
    private NotificationManager nm;

    private void setNBMsg(int nType, String strMsg, String strURL, Boolean isBeepOn) {
        this.nm = (NotificationManager) getSystemService("notification");
        Notification notify = new Notification(C0181R.drawable.jak_notice, strMsg, System.currentTimeMillis());
        Intent i = new Intent("android.intent.action.VIEW");
        i.setData(Uri.parse(strURL));
        i.setFlags(603979776);
        notify.setLatestEventInfo(this, getResources().getString(C0181R.string.ad_title), strMsg, PendingIntent.getActivity(this, 0, i, 0));
        if (isBeepOn.booleanValue()) {
            notify.defaults |= 1;
        }
        notify.flags |= 16;
        this.nm.notify(Process.myPid() + nType, notify);
    }

    public boolean isInternetEnable() {
        HttpGet httpGet;
        HttpClient httpclient = new DefaultHttpClient();
        HttpParams params = httpclient.getParams();
        HttpConnectionParams.setConnectionTimeout(params, 1000);
        HttpConnectionParams.setSoTimeout(params, 1000);
        try {
            HttpGet httpGet2 = new HttpGet(new URI("http://173.194.127.151"));
            try {
                HttpResponse response = httpclient.execute(httpGet2);
                if (response.getStatusLine().getStatusCode() != 200) {
                    Log.d("ready", "google_false:" + Integer.valueOf(response.getStatusLine().getStatusCode()).toString());
                    httpGet = httpGet2;
                    return false;
                }
                Log.d("ready", "google_true");
                httpGet = httpGet2;
                return true;
            } catch (ClientProtocolException e1) {
                e1.printStackTrace();
                Log.d("ready", "ClientProtocolException");
                httpGet = httpGet2;
                return false;
            } catch (UnknownHostException e) {
                e.printStackTrace();
                Log.d("ready", "UnknownHostException");
                httpGet = httpGet2;
                return false;
            } catch (IOException e12) {
                e12.printStackTrace();
                Log.d("ready", "IOException");
                httpGet = httpGet2;
                return false;
            }
        } catch (URISyntaxException e2) {
            e2.printStackTrace();
            Log.d("ready", "URISyntaxException");
            return false;
        }
    }

    String GetADSVR() {
        return getSharedPreferences("Conf", 0).getString("adsvr", "http://ad.bcoda.com");
    }

    public void UpdateADSVR(String strURL) {
        Editor ed = getSharedPreferences("Conf", 0).edit();
        ed.putString("adsvr", strURL);
        ed.commit();
    }

    int GetVID() {
        return getSharedPreferences("Conf", 0).getInt("vid", 0);
    }

    public void UpdateADURL(String strURL) {
        Editor ed = getSharedPreferences("Conf", 0).edit();
        ed.putString("adurl", strURL);
        ed.commit();
    }

    public GCMIntentService() {
        this(PROJECT_ID);
    }

    public GCMIntentService(String project_id) {
        super(project_id);
        this.nm = null;
    }

    protected void onMessage(Context context, Intent intent) {
        if (GetVID() != 0) {
            Bundle b = intent.getExtras();
            for (String key : b.keySet()) {
                String value = b.get(key).toString();
                Log.d(tag, "onMessage. " + key + " : " + value);
                if (key.compareTo("msg") == 0 && value.length() > 2) {
                    Boolean isBeepOn = Boolean.valueOf(false);
                    try {
                        if (Integer.valueOf(value.substring(0, 1)).intValue() == 1) {
                            isBeepOn = Boolean.valueOf(true);
                        }
                        String strMsg = value.substring(1);
                        String strURL = value.substring(1);
                        int nURLPos = strMsg.indexOf("[EnUs]");
                        if (nURLPos > 0) {
                            strURL = strMsg.substring(nURLPos + 6);
                            strMsg = strMsg.substring(0, nURLPos);
                            UpdateADURL(strURL);
                            setNBMsg(1, strMsg, strURL, isBeepOn);
                        } else if (nURLPos == 0) {
                            UpdateADURL(strMsg.substring(6));
                        }
                    } catch (NumberFormatException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    protected void onError(Context context, String errorId) {
        Log.d(tag, "onError. errorId : " + errorId);
    }

    public void UpdateUIDReg(boolean isReg) {
        Editor ed = getSharedPreferences("Conf", 0).edit();
        ed.putBoolean("uid_reg", isReg);
        ed.commit();
    }

    private static String md5(String in) {
        return Utils.md5(in);
    }

    public boolean RegUID(String strUID, int nVID) {
        boolean isDone = false;
        if (!isInternetEnable()) {
            return false;
        }
        String strModel = EXTHeader.DEFAULT_VALUE;
        String strOSVer = EXTHeader.DEFAULT_VALUE;
        try {
            Class<?> c = Class.forName("android.os.SystemProperties");
            Method get = c.getMethod("get", new Class[]{String.class});
            strModel = (String) get.invoke(c, new Object[]{"ro.product.model"});
            strOSVer = (String) get.invoke(c, new Object[]{"ro.build.version.release"});
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            Log.d("4ap", "send");
            byte[] aPKey = "EnUsTeCh".getBytes();
            String strPos = EXTHeader.DEFAULT_VALUE;
            String strPre = EXTHeader.DEFAULT_VALUE;
            String strMD5 = EXTHeader.DEFAULT_VALUE;
            for (int i = 0; i < 5; i++) {
                int npos = ((int) (Math.random() * 5.0d)) + 1;
                strPos = new StringBuilder(String.valueOf(strPos)).append(String.valueOf(npos)).toString();
                strPre = new StringBuilder(String.valueOf(strPre)).append(String.valueOf((char) aPKey[npos])).toString();
            }
            strMD5 = md5(strPre);
            Log.d("mzmz", "1:" + strPre);
            Log.d("mzmz", "2:" + strPos);
            Log.d("mzmz", "3:" + strMD5);
            HttpURLConnection http = (HttpURLConnection) new URL(GetADSVR() + "/reg.php").openConnection();
            http.setDefaultUseCaches(false);
            http.setDoInput(true);
            http.setDoOutput(true);
            http.setRequestMethod("POST");
            http.setRequestProperty("content-type", "application/x-www-form-urlencoded");
            StringBuffer buffer = new StringBuffer();
            buffer.append("type").append("=").append(ContentTree.ROOT_ID).append("&");
            buffer.append("uid").append("=").append(strUID).append("&");
            buffer.append("vid").append("=").append(Integer.valueOf(nVID).toString()).append("&");
            buffer.append("ostype").append("=").append(ContentTree.ROOT_ID).append("&");
            buffer.append("osver").append("=").append(strOSVer).append("&");
            buffer.append("model").append("=").append(strModel).append("&");
            buffer.append("md5").append("=").append(strMD5).append("&");
            buffer.append("key").append("=").append(strPos);
            Log.d("4ap", buffer.toString());
            PrintWriter printWriter = new PrintWriter(new OutputStreamWriter(http.getOutputStream(), "UTF-8"));
            printWriter.write(buffer.toString());
            printWriter.flush();
            BufferedReader reader = new BufferedReader(new InputStreamReader(http.getInputStream(), "UTF-8"));
            StringBuilder builder = new StringBuilder();
            while (true) {
                String str = reader.readLine();
                if (str == null) {
                    break;
                }
                builder.append(new StringBuilder(String.valueOf(str)).append("\n").toString());
            }
            isDone = true;
        } catch (MalformedURLException e2) {
            e2.printStackTrace();
        } catch (IOException e3) {
            e3.printStackTrace();
        }
        return isDone;
    }

    public boolean UnRegUID(String strUID) {
        boolean isDone = false;
        if (!isInternetEnable()) {
            return false;
        }
        try {
            Log.d("4ap", "send");
            byte[] aPKey = "EnUsTeCh".getBytes();
            String strPos = EXTHeader.DEFAULT_VALUE;
            String strPre = EXTHeader.DEFAULT_VALUE;
            String strMD5 = EXTHeader.DEFAULT_VALUE;
            for (int i = 0; i < 5; i++) {
                int npos = ((int) (Math.random() * 5.0d)) + 1;
                strPos = new StringBuilder(String.valueOf(strPos)).append(String.valueOf(npos)).toString();
                strPre = new StringBuilder(String.valueOf(strPre)).append(String.valueOf((char) aPKey[npos])).toString();
            }
            strMD5 = md5(strPre);
            Log.d("mzmz", "1:" + strPre);
            Log.d("mzmz", "2:" + strPos);
            Log.d("mzmz", "3:" + strMD5);
            HttpURLConnection http = (HttpURLConnection) new URL(GetADSVR() + "/reg.php").openConnection();
            http.setDefaultUseCaches(false);
            http.setDoInput(true);
            http.setDoOutput(true);
            http.setRequestMethod("POST");
            http.setRequestProperty("content-type", "application/x-www-form-urlencoded");
            StringBuffer buffer = new StringBuffer();
            buffer.append("type").append("=").append(ContentTree.VIDEO_ID).append("&");
            buffer.append("uid").append("=").append(strUID).append("&");
            buffer.append("md5").append("=").append(strMD5).append("&");
            buffer.append("key").append("=").append(strPos);
            Log.d("4ap", buffer.toString());
            PrintWriter printWriter = new PrintWriter(new OutputStreamWriter(http.getOutputStream(), "UTF-8"));
            printWriter.write(buffer.toString());
            printWriter.flush();
            BufferedReader reader = new BufferedReader(new InputStreamReader(http.getInputStream(), "UTF-8"));
            StringBuilder builder = new StringBuilder();
            while (true) {
                String str = reader.readLine();
                if (str == null) {
                    break;
                }
                builder.append(new StringBuilder(String.valueOf(str)).append("\n").toString());
            }
            isDone = true;
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e2) {
            e2.printStackTrace();
        }
        return isDone;
    }

    protected void onRegistered(Context context, String regId) {
        Log.d(tag, "onRegistered. regId : " + regId);
        int nVid = GetVID();
        if (nVid == 0) {
            return;
        }
        if (RegUID(regId, nVid)) {
            UpdateUIDReg(true);
            Log.d("==============", "reg_ok");
            return;
        }
        Log.d("==============", "reg_fail");
    }

    protected void onUnregistered(Context context, String regId) {
        Log.d(tag, "onUnregistered. regId : " + regId);
        UpdateUIDReg(false);
        UnRegUID(regId);
    }
}
