package com.enus.myzik;

import android.app.Service;
import android.content.Intent;
import android.os.Binder;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.RemoteCallbackList;
import android.os.RemoteException;
import android.util.Log;
import com.enus.myzik.INIOService.Stub;
import com.wireme.mediaserver.ContentTree;
import java.io.IOException;
import java.util.StringTokenizer;
import org.teleal.cling.model.message.header.EXTHeader;

public class MzNIOService extends Service {
    private static final int GetApCCnt = 10;
    private static final int GetApCSSID = 9;
    private static final int GetApMac = 1;
    private static final int GetApMode = 8;
    private static final int GetApSSID = 11;
    private static final int GetDInfo = 2;
    private static final int GetFVer = 0;
    private static final int GetMode = 3;
    private static final int GetPort = 4;
    private static final int GetTModeInfo1 = 5;
    private static final int GetTModeInfo2 = 6;
    private static final int GetTModeInfo3 = 7;
    private static final int ParseInfo = 10;
    private static final int REQ_APLIST = 6;
    private static final int REQ_INFO = 5;
    private static final int SET_APLIST = 7;
    private static final int SET_HOTSPOT = 8;
    private static final int SetActive = 0;
    private static final int SetFReset = 9;
    private static final int SetMode = 1;
    private static final int SetTCPNewAPInfo = 3;
    private static final int SetTCPUpgrade = 2;
    private static final int SetTETHER = 4;
    public NIOServer NIOSvr = null;
    private final Stub mBinder = new C04861();
    final RemoteCallbackList<INIOServiceCallback> mCallbacks = new RemoteCallbackList();
    private final Handler mHandler = new C01782();
    private Thread mThread = null;

    class C01782 extends Handler {
        C01782() {
        }

        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 1:
                    int N = MzNIOService.this.mCallbacks.beginBroadcast();
                    for (int i = 0; i < N; i++) {
                        try {
                            ((INIOServiceCallback) MzNIOService.this.mCallbacks.getBroadcastItem(i)).GetResult(1);
                        } catch (RemoteException e) {
                        }
                    }
                    MzNIOService.this.mCallbacks.finishBroadcast();
                    sendMessageDelayed(obtainMessage(1), 1000);
                    return;
                default:
                    super.handleMessage(msg);
                    return;
            }
        }
    }

    public final class NIOServiceBinder extends Binder {
    }

    class C04861 extends Stub {
        C04861() {
        }

        public void registerCallback(INIOServiceCallback cb) {
            if (cb != null) {
                MzNIOService.this.mCallbacks.register(cb);
            }
        }

        public void unregisterCallback(INIOServiceCallback cb) {
            if (cb != null) {
                MzNIOService.this.mCallbacks.unregister(cb);
            }
        }

        public void SetCmd(int nCmd, String strValue) throws RemoteException {
            if (MzNIOService.this.NIOSvr != null) {
                switch (nCmd) {
                    case 0:
                        MzNIOService.this.NIOSvr.setActive();
                        return;
                    case 1:
                        MzNIOService.this.NIOSvr.setMode(Integer.valueOf(strValue).intValue());
                        return;
                    case 2:
                        MzNIOService.this.NIOSvr.setUpgrade(strValue);
                        return;
                    case 3:
                        String strSSID = EXTHeader.DEFAULT_VALUE;
                        String strOldPW = EXTHeader.DEFAULT_VALUE;
                        String strNewPW = EXTHeader.DEFAULT_VALUE;
                        StringTokenizer stok = new StringTokenizer(strValue, ",", false);
                        Log.d("setinfo", "ori:" + strValue);
                        int i = 0;
                        while (stok.hasMoreElements()) {
                            if (i == 0) {
                                strSSID = stok.nextToken();
                            } else if (i == 1) {
                                strOldPW = stok.nextToken();
                            } else if (i == 2) {
                                strNewPW = stok.nextToken();
                            } else {
                                stok.nextToken();
                            }
                            i++;
                        }
                        strSSID = strSSID.trim();
                        Log.d("setinfo", new StringBuilder(String.valueOf(strSSID)).append(",").append(strOldPW).append(",").append(strNewPW).toString());
                        MzNIOService.this.NIOSvr.setNewAPInfo(strSSID, strOldPW, strNewPW);
                        return;
                    case 4:
                        MzNIOService.this.NIOSvr.setTETHER(strValue);
                        Log.d("setteher02", strValue);
                        return;
                    case 5:
                        MzNIOService.this.NIOSvr.Req_Info();
                        Log.d("REQ_INFO", strValue);
                        return;
                    case 6:
                        MzNIOService.this.NIOSvr.Req_ApList();
                        Log.d("REQ_APLIST", strValue);
                        return;
                    case 7:
                        MzNIOService.this.NIOSvr.setAddApList(strValue);
                        Log.d("SET_APLIST", strValue);
                        return;
                    case 8:
                        MzNIOService.this.NIOSvr.setAddApList(strValue);
                        Log.d("SET_HOTSPOT", strValue);
                        return;
                    case 9:
                        MzNIOService.this.NIOSvr.setFReset(strValue);
                        return;
                    case 10:
                        MzNIOService.this.NIOSvr.ParseInfo();
                        Log.d("ParseInfo", "ParseInfo");
                        return;
                    default:
                        return;
                }
            }
        }

        public String GetValue(int nType) throws RemoteException {
            String strRes = ContentTree.ROOT_ID;
            if (MzNIOService.this.NIOSvr == null) {
                return strRes;
            }
            switch (nType) {
                case 0:
                    return MzNIOService.this.NIOSvr.GetFVer();
                case 1:
                    return MzNIOService.this.NIOSvr.GetApMac();
                case 2:
                    return MzNIOService.this.NIOSvr.getDInfo();
                case 3:
                    return Integer.valueOf(MzNIOService.this.NIOSvr.getMode()).toString();
                case 4:
                    return Integer.valueOf(MzNIOService.this.NIOSvr.getPort()).toString();
                case 5:
                    return MzNIOService.this.NIOSvr.GetTModeInfo1();
                case 6:
                    return MzNIOService.this.NIOSvr.GetTModeInfo2();
                case 7:
                    return MzNIOService.this.NIOSvr.GetTModeInfo3();
                case 8:
                    return MzNIOService.this.NIOSvr.GetApMode();
                case 9:
                    return MzNIOService.this.NIOSvr.GetApCSSID();
                case 10:
                    return MzNIOService.this.NIOSvr.GetApCCnt();
                case 11:
                    return MzNIOService.this.NIOSvr.GetApSSID();
                default:
                    return strRes;
            }
        }
    }

    boolean GetTestWriteMode() {
        return getSharedPreferences("Conf", 0).getBoolean("test_wmode", false);
    }

    public IBinder onBind(Intent intent) {
        Log.d("jmgs", "INIOService onBind");
        if (INIOService.class.getName().equals(intent.getAction())) {
            return this.mBinder;
        }
        return null;
    }

    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.d("jmgs", "INIOService onStartCommand");
        return 3;
    }

    public void startNIO() {
        this.NIOSvr = null;
        try {
            this.NIOSvr = new NIOServer(getBaseContext(), GetTestWriteMode());
        } catch (IOException e) {
            e.printStackTrace();
        }
        this.mThread = new Thread(this.NIOSvr);
        this.mThread.start();
    }

    public void stopNIO() {
        try {
            this.mThread.stop();
        } catch (UnsupportedOperationException e) {
            e.printStackTrace();
        }
    }

    public void onCreate() {
        super.onCreate();
        Log.d("jmgs", "INIOService onCreate");
        startNIO();
    }

    public void onDestroy() {
        Log.d("jmgs", "INIOService onDestroy");
        stopNIO();
        this.mCallbacks.kill();
    }
}
