package com.enus.myzik;

import android.app.Application;
import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.NetworkInfo.State;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Handler;
import android.os.RemoteException;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import com.wireme.mediaserver.ContentTree;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.InetAddress;
import java.nio.ByteBuffer;
import java.nio.charset.CharacterCodingException;
import java.nio.charset.Charset;
import java.util.List;
import java.util.StringTokenizer;
import org.teleal.cling.model.ServiceReference;
import org.teleal.cling.model.message.header.EXTHeader;

public class MzServerApp extends Application {
    private static final int GetApCCnt = 10;
    private static final int GetApCSSID = 9;
    private static final int GetApMac = 1;
    private static final int GetApMode = 8;
    private static final int GetApSSID = 11;
    private static final int GetDInfo = 2;
    private static final int GetFVer = 0;
    private static final int GetMSIP = 20;
    private static final int GetMode = 3;
    private static final int GetPort = 4;
    private static final int GetTModeInfo1 = 5;
    private static final int GetTModeInfo2 = 6;
    private static final int GetTModeInfo3 = 7;
    private static final int GetUDPIP = 12;
    private static final int ParseInfo = 10;
    private static final int REQ_APLIST = 6;
    private static final int REQ_INFO = 5;
    private static final int SET_APLIST = 7;
    private static final int SET_HOTSPOT = 8;
    private static final int SetFReset = 9;
    private static final int SetTCPActive = 0;
    private static final int SetTCPMode = 1;
    private static final int SetTCPNewAPInfo = 3;
    private static final int SetTCPUpgrade = 2;
    private static final int SetTETHER = 4;
    private static final int SetUDPIP = 11;
    public static boolean isPutLog = false;
    public static final String strDefSSID = "myzik_dongle";
    public static final String strDefSSID2 = "jhkim_dongle";
    public static final String strDefSSID3 = "rt3352";
    public static final String strDefSSID4 = "m-fly";
    public boolean isEnableEventRecv = true;
    public boolean isPressManualButton = false;
    public int mCntUDPSend = 0;
    IBService mIBService = null;
    private ScanResult mLastScanResult = null;
    public int mMode = 0;
    public String mStrIP = EXTHeader.DEFAULT_VALUE;
    public String mStrInnerFVer = EXTHeader.DEFAULT_VALUE;
    private String mStrLastSSID = EXTHeader.DEFAULT_VALUE;
    public String mStrSSID = EXTHeader.DEFAULT_VALUE;
    public int menu1Icon = 0;
    public int menu2Icon = 0;
    public int menu3Icon = 0;
    public String strSysInf = EXTHeader.DEFAULT_VALUE;
    public String strSysVer = EXTHeader.DEFAULT_VALUE;

    public boolean isWifiEnable() {
        return ((WifiManager) getSystemService("wifi")).isWifiEnabled();
    }

    public boolean isWifiConnected() {
        if (!isWifiEnable()) {
            return isWifiEnable();
        }
        ConnectivityManager connMgr = (ConnectivityManager) getSystemService("connectivity");
        if (connMgr != null) {
            NetworkInfo networkInfo = connMgr.getActiveNetworkInfo();
            if (networkInfo != null && networkInfo.isAvailable() && networkInfo.getType() == 1 && (networkInfo.getState() == State.CONNECTED || networkInfo.getState() == State.CONNECTING)) {
                return true;
            }
        }
        return false;
    }

    public void SetMenu1Icon(int nType) {
        this.menu1Icon = nType;
    }

    public void SetMenu2Icon(int nType) {
        this.menu2Icon = nType;
    }

    public void SetMenu3Icon(int nType) {
        this.menu3Icon = nType;
    }

    public void SetEventRecvFlag(Boolean flag) {
    }

    public int GetMenu1Icon() {
        return this.menu1Icon;
    }

    public int GetMenu2Icon() {
        return this.menu2Icon;
    }

    public int GetMenu3Icon() {
        return this.menu3Icon;
    }

    public Boolean GetEventRecvFlag() {
        return Boolean.valueOf(this.isEnableEventRecv);
    }

    public void SetLastScanResult(ScanResult LastScanResult) {
        this.mLastScanResult = LastScanResult;
    }

    public ScanResult GetLastScanResult() {
        return this.mLastScanResult;
    }

    public void SetLastSSID(String strSSID) {
        this.mStrLastSSID = strSSID;
    }

    public String GetLastSSID() {
        return this.mStrLastSSID;
    }

    public String GetSSID() {
        String strRes = EXTHeader.DEFAULT_VALUE;
        if (!isWifiConnected()) {
            return strRes;
        }
        WifiInfo wifiInfo = ((WifiManager) getSystemService("wifi")).getConnectionInfo();
        if (wifiInfo == null) {
            return strRes;
        }
        strRes = wifiInfo.getSSID();
        try {
            strRes = strRes.replace("\"", EXTHeader.DEFAULT_VALUE);
        } catch (NullPointerException e) {
            e.printStackTrace();
        }
        if (strRes == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        return strRes;
    }

    public boolean CheckSSID(String strSSID) {
        strSSID = strSSID.toLowerCase();
        if (strSSID.compareTo(strDefSSID) == 0 || strSSID.compareTo(strDefSSID2) == 0 || strSSID.compareTo(strDefSSID3) == 0 || strSSID.compareTo(strDefSSID4) == 0) {
            return true;
        }
        return false;
    }

    public String GetFVer() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return "none";
        }
        try {
            return this.mIBService.GetValue(0);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetApMac() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(1);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetApMode() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(8);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetApCSSID() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(9);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetApCCnt() {
        if (this.mMode == 0) {
            return ContentTree.ROOT_ID;
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(10);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetApSSID() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(11);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetDInfo() {
        if (this.mMode == 0) {
            return "none";
        }
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(2);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetTModeInfo1() {
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return this.mIBService.GetValue(5);
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String GetTModeInfo() {
        if (this.mIBService == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            if (GetTModeInfo1().compareTo("EXIT") == 0) {
                return new StringBuilder(String.valueOf(this.mIBService.GetValue(5))).append(ServiceReference.DELIMITER).append(this.mIBService.GetValue(6)).toString();
            }
            return new StringBuilder(String.valueOf(this.mIBService.GetValue(5))).append(ServiceReference.DELIMITER).append(this.mIBService.GetValue(6)).append(ServiceReference.DELIMITER).append(this.mIBService.GetValue(7)).toString();
        } catch (RemoteException e) {
            e.printStackTrace();
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public int GetMode() {
        int i = 0;
        if (this.mIBService != null) {
            try {
                i = Integer.valueOf(this.mIBService.GetValue(3)).intValue();
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
        return i;
    }

    public void SetActive() {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(0, EXTHeader.DEFAULT_VALUE);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public String LocalString(String val) {
        String str = null;
        if (val == null) {
            return str;
        }
        try {
            byte[] b = val.getBytes("8859_1");
            try {
                return Charset.forName("UTF-8").newDecoder().decode(ByteBuffer.wrap(b)).toString();
            } catch (CharacterCodingException e) {
                return new String(b, "EUC-KR");
            }
        } catch (UnsupportedEncodingException e1) {
            e1.printStackTrace();
            return str;
        }
    }

    public void setFriendlyName(String strFriendlyName) {
    }

    public void Req_Info() {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(5, EXTHeader.DEFAULT_VALUE);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void Req_ApList() {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(6, EXTHeader.DEFAULT_VALUE);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void Set_ApList(String strParam) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(7, strParam);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void Set_Hotspot(String strParam) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(8, strParam);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void SetTCPNewAPInfo(String strInfo) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(3, strInfo);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void SetTETHER(boolean isOn, String strPW, String strMID, String strMPW) {
        if (this.mIBService != null) {
            try {
                String strMode = "ENTER";
                String strData = EXTHeader.DEFAULT_VALUE;
                if (isOn) {
                    strData = String.format("%s,%s,%s,%s", new Object[]{strMode, strPW, strMID, strMPW});
                } else {
                    strData = String.format("%s,%s", new Object[]{"EXIT", strPW});
                }
                Log.d("setteher01", strData);
                this.mIBService.SetCmd(4, strData);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void SetFReset(String strPW) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(9, strPW);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void ParseInfo() {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(10, EXTHeader.DEFAULT_VALUE);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void SetUpgrade(String strURL) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(2, strURL);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public void SetMode(int nMode) {
        if (this.mIBService != null) {
            try {
                this.mIBService.SetCmd(1, Integer.valueOf(nMode).toString());
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    }

    public String GetUDPIP() {
        String strRes = EXTHeader.DEFAULT_VALUE;
        if (this.mIBService == null) {
            return strRes;
        }
        try {
            strRes = this.mIBService.GetValue(12);
            this.mStrIP = strRes;
            return strRes;
        } catch (RemoteException e) {
            e.printStackTrace();
            return strRes;
        }
    }

    public void SendUDPIP() {
        if (this.mIBService != null) {
            try {
                if (this.mCntUDPSend < 40) {
                    try {
                        this.mIBService.SetCmd(11, EXTHeader.DEFAULT_VALUE);
                        this.mCntUDPSend++;
                    } catch (NullPointerException e) {
                        e.printStackTrace();
                    }
                }
            } catch (RemoteException e2) {
                e2.printStackTrace();
            }
        }
    }

    public String GetAndroidVer() {
        String res = "x";
        if (this.strSysVer.length() <= 0) {
            return res;
        }
        Log.d("ddver", this.strSysVer);
        String srTmp = EXTHeader.DEFAULT_VALUE;
        try {
            srTmp = new String(this.strSysVer.getBytes(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        StringTokenizer stok = new StringTokenizer(srTmp, ".", false);
        int i = 0;
        String[] strVer = new String[this.strSysVer.length()];
        while (stok.hasMoreTokens()) {
            strVer[i] = stok.nextToken();
            i++;
        }
        Log.d("ddver", String.format("%s %s %s", new Object[]{strVer[0], strVer[1], strVer[2]}));
        try {
            if (Integer.valueOf(strVer[0]).intValue() == 4) {
                res = "kk";
                if (Integer.valueOf(strVer[1]).intValue() < 4) {
                    return "ics";
                }
                return res;
            } else if (Integer.valueOf(strVer[0]).intValue() == 3) {
                return "hc";
            } else {
                if (Integer.valueOf(strVer[0]).intValue() != 2) {
                    return res;
                }
                if (Integer.valueOf(strVer[1]).intValue() == 3) {
                    res = "gb";
                    if (Integer.valueOf(strVer[2]).intValue() < 6) {
                        return "gb_old";
                    }
                    return res;
                } else if (Integer.valueOf(strVer[1]).intValue() == 2) {
                    return "fy";
                } else {
                    if (Integer.valueOf(strVer[1]).intValue() < 2) {
                        return "etc";
                    }
                    return res;
                }
            }
        } catch (NumberFormatException e2) {
            e2.printStackTrace();
            return "ics";
        }
    }

    public boolean ConnectWiFi() {
        boolean res = false;
        if (isWifiEnable()) {
            WifiManager mwifi = (WifiManager) getSystemService("wifi");
            List<?> Aplist = mwifi.getScanResults();
            ScanResult ap = null;
            for (int i = 0; i < Aplist.size(); i++) {
                ap = (ScanResult) Aplist.get(i);
                if (CheckSSID(ap.SSID)) {
                    break;
                }
            }
            if (Aplist.size() == 0 || !CheckSSID(ap.SSID)) {
                return 0;
            }
            WifiConfiguration wfc = new WifiConfiguration();
            wfc.SSID = "\"" + ap.SSID + "\"";
            wfc.hiddenSSID = false;
            wfc.status = 1;
            wfc.priority = 1;
            wfc.allowedProtocols.set(1);
            wfc.allowedProtocols.set(0);
            wfc.allowedKeyManagement.set(1);
            wfc.allowedPairwiseCiphers.set(2);
            wfc.allowedPairwiseCiphers.set(1);
            wfc.allowedGroupCiphers.set(0);
            wfc.allowedGroupCiphers.set(1);
            wfc.allowedGroupCiphers.set(3);
            wfc.allowedGroupCiphers.set(2);
            wfc.preSharedKey = "\"".concat("12345678").concat("\"");
            int networkID = mwifi.addNetwork(wfc);
            if (networkID != -1) {
                mwifi.saveConfiguration();
                if (mwifi.enableNetwork(networkID, true)) {
                    res = true;
                    if (mwifi.disconnect()) {
                        mwifi.reconnect();
                    }
                    Log.d("wf", "connected MediaDongle!!");
                } else {
                    Log.d("wf", "Can't connect MediaDongle!! [2]");
                }
            } else {
                Log.d("wf", "Can't connect MediaDongle!!");
            }
        }
        return res;
    }

    public String getStrWifiIP() throws IOException {
        int broadcast = ((WifiManager) getSystemService("wifi")).getDhcpInfo().ipAddress;
        byte[] quads = new byte[4];
        for (int k = 0; k < 4; k++) {
            quads[k] = (byte) ((broadcast >> (k * 8)) & 255);
        }
        return InetAddress.getByAddress(quads).getHostAddress().toString();
    }

    public void SetNewAPInfo(String string) {
    }

    public void ShowMsg(String strMsg, int nType) {
        Context context = getApplicationContext();
        View layout = ((LayoutInflater) context.getSystemService("layout_inflater")).inflate(C0181R.layout.ltoast, null, false);
        ((TextView) layout.findViewById(C0181R.id.toast_text)).setText(strMsg);
        int nPxY = context.getResources().getDisplayMetrics().heightPixels - 50;
        if (nType == 1) {
            nPxY += 101;
        }
        int fPy = (int) ((((float) nPxY) / 10.0f) * 7.0f);
        Toast toast = new Toast(context);
        toast.setGravity(48, 0, fPy);
        toast.setDuration(0);
        toast.setView(layout);
        toast.show();
    }

    public void ShowNFMsg(String strTitle, String strMsg, int nType) {
        Context context = getApplicationContext();
        final Toast toast = new Toast(context);
        toast.setGravity(16, 0, 0);
        toast.setDuration(0);
        View layout = ((LayoutInflater) context.getSystemService("layout_inflater")).inflate(C0181R.layout.nftoast, null, false);
        TextView msg = (TextView) layout.findViewById(C0181R.id.nft_tv02);
        Button b_close = (Button) layout.findViewById(C0181R.id.ntf_b_close);
        ((TextView) layout.findViewById(C0181R.id.nft_tv01)).setText(strTitle);
        msg.setText(strMsg);
        b_close.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                toast.cancel();
            }
        });
        toast.setView(layout);
        toast.show();
        new Handler().postDelayed(new Runnable() {
            public void run() {
                toast.cancel();
            }
        }, 500);
    }
}
