package com.enus.myzik;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.WifiManager;
import android.util.Log;
import java.util.ArrayList;
import org.teleal.cling.model.ServerClientTokens;

public class Mz_CBR4TMode extends BroadcastReceiver {
    private static final int STATE_NONE = 0;
    private static final int STATE_WIFIAP_CONNECTED = 1;
    private static final int STATE_WIFIAP_DISCONNECTED = 2;
    private int ap_state = 0;
    private Context mContext = null;
    private WifiManager wifi;

    public Mz_CBR4TMode(Context context) {
        this.mContext = context;
    }

    public int getWifiAPState() {
        Log.d("apmode", "Check");
        String[] WIFI_STATE_TEXTSTATE = new String[]{"DISABLING", "DISABLED", "ENABLING", "ENABLED", "FAILED"};
        int state = -1;
        int nWifiAPState = -1;
        try {
            nWifiAPState = ((Integer) this.wifi.getClass().getMethod("getWifiApState", new Class[0]).invoke(this.wifi, new Object[0])).intValue();
        } catch (Exception e) {
        }
        if (nWifiAPState >= 10) {
            nWifiAPState -= 10;
        }
        Log.d("apmode", "getWifiAPState.state " + (state == -1 ? ServerClientTokens.UNKNOWN_PLACEHOLDER : WIFI_STATE_TEXTSTATE[state]));
        return state;
    }

    private void handleWifiApStateChanged(int state) {
    }

    public void onReceive(Context context, Intent intent) {
        String WIFI_AP_STATE_CHANGED_ACTION = "android.net.wifi.WIFI_AP_STATE_CHANGED";
        String EXTRA_WIFI_AP_STATE = "wifi_state";
        String EXTRA_AVAILABLE_TETHER = "availableArray";
        String EXTRA_ACTIVE_TETHER = "activeArray";
        String EXTRA_ERRORED_TETHER = "erroredArray";
        String ACTION_TETHER_STATE_CHANGED = "android.net.conn.TETHER_STATE_CHANGED";
        try {
            String action = intent.getAction();
            if (action.equals(WIFI_AP_STATE_CHANGED_ACTION)) {
                Log.d("apmodee", "WIFI_AP_STATE_CHANGED_ACTION");
                int nWifiAPState = -1;
                nWifiAPState = intent.getIntExtra(EXTRA_WIFI_AP_STATE, 4);
                if (nWifiAPState >= 10) {
                    nWifiAPState -= 10;
                }
                Intent intent2;
                if (nWifiAPState == 3) {
                    this.ap_state = 1;
                    Log.d("apmodee", "WIFI_AP_STATE_ENABLED");
                    intent2 = new Intent("cling.android.Router");
                    intent2.putExtra("enus", "wifiap_on");
                    this.mContext.sendBroadcast(intent2);
                } else if (nWifiAPState == 4) {
                    Log.d("apmodee", "WIFI_AP_STATE_FAILED");
                } else if (nWifiAPState == 1) {
                    Log.d("apmodee", "WIFI_AP_STATE_DISABLED");
                    if (this.ap_state == 1) {
                        intent2 = new Intent("cling.android.Router");
                        intent2.putExtra("enus", "wifiap_off");
                        this.mContext.sendBroadcast(intent2);
                    }
                    this.ap_state = 2;
                } else {
                    Log.d("apmodee", Integer.valueOf(intent.getIntExtra(EXTRA_WIFI_AP_STATE, 4)).toString());
                }
            } else if (action.equals(ACTION_TETHER_STATE_CHANGED)) {
                Log.d("apmode", "ACTION_TETHER_STATE_CHANGED");
                ArrayList<String> available = intent.getStringArrayListExtra(EXTRA_AVAILABLE_TETHER);
                ArrayList<String> active = intent.getStringArrayListExtra(EXTRA_ACTIVE_TETHER);
                intent.getStringArrayListExtra(EXTRA_ERRORED_TETHER);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
