package com.enus.myzik;

import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import com.nostra13.universalimageloader.core.download.BaseImageDownloader;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.List;
import org.teleal.cling.model.message.header.EXTHeader;

public class SplashActivity extends MzActivity {
    final String DL_Path = "/Download/";
    WifiManager mainWifi = null;

    class C02261 implements OnClickListener {
        C02261() {
        }

        public void onClick(View v) {
            if (SplashActivity.this.GetVID() != 0) {
                try {
                    Intent i = new Intent("android.intent.action.VIEW");
                    i.setData(Uri.parse(SplashActivity.this.GetADURL()));
                    SplashActivity.this.startActivity(i);
                } catch (ActivityNotFoundException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    class C02272 extends Handler {
        C02272() {
        }

        public void handleMessage(Message msg) {
            boolean isUseWiz = SplashActivity.this.GetWizConf().booleanValue();
            if (!isUseWiz) {
                SplashActivity.this.DoPaseScanResult();
            }
            SplashActivity.this.DoPaseScanResult();
            SplashActivity.this.finish();
            if (isUseWiz) {
                SplashActivity.this.startActivity(new Intent(SplashActivity.this, Step1_Activity.class));
            } else {
                SplashActivity.this.startActivity(new Intent(SplashActivity.this, List_Activity.class));
            }
        }
    }

    public void onBackPressed() {
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(C0181R.layout.splash);
        this.mainWifi = (WifiManager) getSystemService("wifi");
        this.mainWifi.startScan();
        if (GetVID() != 0) {
            String strFName = "ad.png";
            String strDataPath = new StringBuilder(String.valueOf(getFilesDir().getAbsolutePath())).append(File.separator).toString();
            ImageView ImgAd = (ImageView) findViewById(C0181R.id.splash_img);
            if (new File(strDataPath, strFName).exists()) {
                Bitmap bmAd = BitmapFactory.decodeFile(new StringBuilder(String.valueOf(strDataPath)).append(strFName).toString());
                if (bmAd != null) {
                    DLog.m0d("mzad", "decode");
                    ImgAd.setImageBitmap(bmAd);
                } else {
                    DLog.m0d("mzad", "BM null");
                }
            } else {
                DLog.m0d("mzad", "File not found");
            }
            ImgAd.setOnClickListener(new C02261());
        }
        initialize();
    }

    public String getstrDLPath() {
        return new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().getAbsolutePath())).append("/Download/").toString();
    }

    public String GetDataDir() {
        return Utils.GetDataDir(getApplicationContext());
    }

    public String getDownloadFromUrl() {
        try {
            String strDataPath = getstrDLPath();
            String strFName = "ad.png";
            File file = new File(strDataPath);
            if (!file.isDirectory()) {
                file.mkdir();
            }
            InputStream input = new BufferedInputStream(new URL("http://211.48.245.14:40000/" + strFName).openStream(), 8192);
            FileOutputStream output = new FileOutputStream(new StringBuilder(String.valueOf(strDataPath)).append(File.separator).append(strFName).toString());
            byte[] data = new byte[1024];
            while (true) {
                int count = input.read(data);
                if (count == -1) {
                    output.flush();
                    output.close();
                    input.close();
                    return new StringBuilder(String.valueOf(strDataPath)).append(File.separator).append(strFName).toString();
                }
                output.write(data, 0, count);
            }
        } catch (Exception e) {
            DLog.m2e("dn", " error : " + e);
            return null;
        }
    }

    private void initialize() {
        Handler handler = new C02272();
        int nDelay = 3000;
        if (!(GetVID() == 0 && GetWizConf().booleanValue())) {
            nDelay = BaseImageDownloader.DEFAULT_HTTP_CONNECT_TIMEOUT;
        }
        handler.sendEmptyMessageDelayed(0, (long) nDelay);
    }

    public void DoPaseScanResult() {
        try {
            List<ScanResult> wifiList = this.mainWifi.getScanResults();
            if (wifiList != null) {
                MzServerApp MzApp = (MzServerApp) getApplicationContext();
                String strLastSSID = GetLastSSIDConf();
                if (MzApp != null && MzApp.GetSSID().compareTo(strLastSSID) != 0) {
                    for (int i = 0; i < wifiList.size(); i++) {
                        String strTmpSSID = EXTHeader.DEFAULT_VALUE;
                        if (((ScanResult) wifiList.get(i)).SSID.compareTo(strLastSSID) == 0) {
                            Wifi.connectToConfiguredNetwork(getApplicationContext(), this.mainWifi, Wifi.getWifiConfiguration(this.mainWifi, (ScanResult) wifiList.get(i), Wifi.ConfigSec.getScanResultSecurity((ScanResult) wifiList.get(i))), false);
                        }
                    }
                }
            }
        } catch (NullPointerException e) {
            e.printStackTrace();
        }
    }
}
