package com.enus.myzik;

import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.provider.Settings.Secure;
import android.provider.Settings.SettingNotFoundException;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageButton;
import java.util.StringTokenizer;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

public class Step1_Activity extends MzActivity {
    private ImageButton ib_next = null;
    private ImageButton ib_save_conf = null;
    private Context mContext = null;

    class C02291 implements OnClickListener {
        C02291() {
        }

        public void onClick(View v) {
            if (Step1_Activity.this.isKT()) {
                Step1_Activity.this.startActivity(new Intent(Step1_Activity.this, Step2_kt_Activity.class));
                Step1_Activity.this.finish();
                return;
            }
            Step1_Activity.this.startActivity(new Intent(Step1_Activity.this, Step2_Activity.class));
            Step1_Activity.this.finish();
        }
    }

    class C02302 implements OnClickListener {
        C02302() {
        }

        public void onClick(View v) {
            Intent imove = new Intent(Step1_Activity.this, List_Activity.class);
            imove.setFlags(DLNAFlags.SN_INCREASE);
            Step1_Activity.this.startActivity(imove);
            Step1_Activity.this.finish();
        }
    }

    class C02313 implements DialogInterface.OnClickListener {
        C02313() {
        }

        public void onClick(DialogInterface dialog, int which) {
            Step1_Activity.this.finish();
            Intent iback = new Intent(Step1_Activity.this, Home_Activity.class);
            iback.putExtra("allfin", "yes");
            Step1_Activity.this.startActivity(iback);
        }
    }

    boolean chk_osver() {
        String strCVer = EXTHeader.DEFAULT_VALUE;
        try {
            Class<?> c = Class.forName("android.os.SystemProperties");
            strCVer = (String) c.getMethod("get", new Class[]{String.class}).invoke(c, new Object[]{"ro.build.version.release"});
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (strCVer.length() <= 0 || strCVer.compareTo("none") == 0) {
            return false;
        }
        int[] nCver = new int[3];
        int[] nFver = new int[3];
        if (strCVer == null || strCVer.isEmpty()) {
            return false;
        }
        StringTokenizer stok = new StringTokenizer(strCVer, ".", false);
        int i = 0;
        while (stok.hasMoreTokens()) {
            nCver[i] = Integer.valueOf(stok.nextToken()).intValue();
            if (i == 2) {
                break;
            }
            i++;
        }
        stok = new StringTokenizer("4.1.0", ".", false);
        i = 0;
        while (stok.hasMoreTokens()) {
            nFver[i] = Integer.valueOf(stok.nextToken()).intValue();
            if (i == 2) {
                break;
            }
            i++;
        }
        if (nFver[0] < nCver[0] || (nFver[0] == nCver[0] && nFver[1] <= nCver[1] && nFver[2] <= nCver[2])) {
            return true;
        }
        return false;
    }

    private int getWifiPoorNetworkDisable() {
        if (chk_osver()) {
            DLog.m0d("chk_osver()", "true");
            try {
                return Secure.getInt(getApplicationContext().getContentResolver(), "wifi_watchdog_poor_network_test_enabled");
            } catch (SettingNotFoundException e) {
                e.printStackTrace();
                return -1;
            }
        }
        DLog.m0d("chk_osver()", "false");
        return -1;
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(C0181R.layout.activity_step1);
        DLog.m0d("xxxxx", Integer.valueOf(getWifiPoorNetworkDisable()).toString());
        onInit();
    }

    protected void onResume() {
        super.onResume();
        onInit();
    }

    void SetWakeLock(int nType) {
    }

    protected void onDestroy() {
        DLog.m2e("jmg", "S1-onDestroy");
        super.onDestroy();
    }

    private boolean onInit() {
        if (this.mContext == null) {
            this.mContext = getApplicationContext();
        }
        if (this.ib_next == null) {
            this.ib_next = (ImageButton) findViewById(C0181R.id.step1_ib_next);
            this.ib_next.setOnClickListener(new C02291());
        }
        if (this.ib_save_conf == null) {
            this.ib_save_conf = (ImageButton) findViewById(C0181R.id.step1_ib_save_conf);
            this.ib_save_conf.setOnClickListener(new C02302());
        }
        return false;
    }

    public void onBackPressed() {
        String alertTitle = getResources().getString(C0181R.string.app_name);
        String buttonMessage = getResources().getString(C0181R.string.alert_msg_exit);
        String buttonYes = getResources().getString(C0181R.string.button_yes);
        String buttonNo = getResources().getString(C0181R.string.button_no);
        String buttonhide = getResources().getString(C0181R.string.button_hide);
        new Builder(this).setTitle(alertTitle).setMessage(buttonMessage).setNegativeButton(buttonYes, new C02313()).setPositiveButton(buttonNo, null).show();
    }
}
