package com.enus.myzik;

import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings.Secure;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

public class Step4_Activity extends MzActivity {
    private static final int nMenu_NewConn = 1;
    private static final String strDefPasswd = "12345678";
    private MzServerApp MzApp = null;
    private Button b_1st_connect = null;
    private Button b_new_connect = null;
    private EditText etPassword = null;
    Intent intent = null;
    private Context mContext = null;
    private WifiManager mainWifi = null;
    ScanResult scanresult = null;
    private TextView tv_text1 = null;

    class C02451 implements OnClickListener {
        C02451() {
        }

        public void onClick(DialogInterface dialog, int which) {
            String strCurPassword = EXTHeader.DEFAULT_VALUE;
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strSSID = EXTHeader.DEFAULT_VALUE;
            String strPassword = EXTHeader.DEFAULT_VALUE;
            strCurPassword = Step4_Activity.this.etPassword.getText().toString();
            if (strCurPassword.length() <= 0) {
                strCurPassword = Step4_Activity.strDefPasswd;
            } else if (strCurPassword.length() < 8 || strCurPassword.length() > 64) {
                if (Step4_Activity.this.MzApp != null) {
                    Step4_Activity.this.MzApp.ShowMsg("password length error (len: 8~64)", 1);
                }
                Step4_Activity.this.removeDialog(1);
                return;
            }
            Step4_Activity.this.removeDialog(1);
            try {
                if (Wifi.connectToNewNetwork(Step4_Activity.this.mContext, Step4_Activity.this.mainWifi, Step4_Activity.this.scanresult, strCurPassword, Secure.getInt(Step4_Activity.this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10))) {
                    Intent iset = new Intent("cling.android.Router");
                    iset.putExtra("enus", "setLastWifiScanResult");
                    Step4_Activity.this.mContext.sendBroadcast(iset);
                    Step4_Activity.this.DoFin();
                } else if (Step4_Activity.this.MzApp != null) {
                    Step4_Activity.this.MzApp.ShowMsg("WiFi Connect Failed", 1);
                }
            } catch (ArrayIndexOutOfBoundsException e) {
                e.printStackTrace();
            } catch (IndexOutOfBoundsException e2) {
                e2.printStackTrace();
            }
        }
    }

    class C02462 implements OnClickListener {
        C02462() {
        }

        public void onClick(DialogInterface dialog, int which) {
            Step4_Activity.this.removeDialog(1);
        }
    }

    class C02473 implements Runnable {
        C02473() {
        }

        public void run() {
            Step4_Activity.this.finish();
        }
    }

    class C02484 implements View.OnClickListener {
        C02484() {
        }

        public void onClick(View v) {
            if (Step4_Activity.this.scanresult != null) {
                Intent intent = new Intent(Step4_Activity.this, Step5_Activity.class);
                intent.putExtra("rs_wifi", Step4_Activity.this.scanresult);
                Step4_Activity.this.startActivity(intent);
            } else {
                Intent imove = new Intent(Step4_Activity.this, Step9_Activity.class);
                imove.putExtra("is_kt", "no");
                imove.setFlags(DLNAFlags.SN_INCREASE);
                Step4_Activity.this.startActivity(imove);
            }
            Step4_Activity.this.finish();
        }
    }

    class C02495 implements View.OnClickListener {
        C02495() {
        }

        public void onClick(View v) {
            Step4_Activity.this.DoForget(Step4_Activity.this.scanresult);
            Intent intent = new Intent(Step4_Activity.this, Step5_Activity.class);
            if (Step4_Activity.this.scanresult != null) {
                intent.putExtra("rs_wifi", Step4_Activity.this.scanresult);
            }
            Step4_Activity.this.startActivity(intent);
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(C0181R.layout.activity_step4);
        this.MzApp = (MzServerApp) getApplicationContext();
        this.mainWifi = (WifiManager) getSystemService("wifi");
        onInit();
    }

    protected void onResume() {
        super.onResume();
        onInit();
    }

    protected void onDestroy() {
        DLog.m2e("jmg", "S4-onDestroy");
        super.onDestroy();
    }

    protected Dialog onCreateDialog(int id) {
        LayoutInflater factory = LayoutInflater.from(this.mContext);
        switch (id) {
            case 1:
                View vApAddLayout = factory.inflate(C0181R.layout.aplist_newcon_dialog, null);
                this.etPassword = null;
                this.etPassword = (EditText) vApAddLayout.findViewById(C0181R.id.aplist_password_editText_New);
                Dialog ApAddDialog = new Builder(this).setView(vApAddLayout).setNegativeButton("Connect", new C02451()).setPositiveButton("Cancel", new C02462()).create();
                ApAddDialog.setCancelable(false);
                return ApAddDialog;
            default:
                return null;
        }
    }

    private boolean isAdHoc(ScanResult wScanResult) {
        return wScanResult.capabilities.indexOf("IBSS") != -1;
    }

    void DoFin() {
        Intent iset = new Intent("cling.android.Router");
        iset.putExtra("enus", "EnableEventRecv");
        this.mContext.sendBroadcast(iset);
        new Handler().postDelayed(new C02473(), 300);
    }

    void DoForget(ScanResult wScanResult) {
        if (wScanResult == null) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("No data in Intent!", 1);
            }
            DoFin();
            return;
        }
        WifiConfiguration config = Wifi.getWifiConfiguration(this.mainWifi, wScanResult, Wifi.ConfigSec.getScanResultSecurity(wScanResult));
        if (config != null) {
            boolean result;
            if (this.mainWifi.removeNetwork(config.networkId) && this.mainWifi.saveConfiguration()) {
                result = true;
            } else {
                result = false;
            }
            if (!result && this.MzApp != null) {
                this.MzApp.ShowMsg("Failed!", 1);
            }
        }
    }

    void DoConnectWifi(ScanResult wScanResult) {
        if (wScanResult == null) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("No data in Intent!", 1);
            }
            DoFin();
        } else if (isAdHoc(wScanResult)) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("adhoc_not_supported_yet", 1);
            }
            DoFin();
        } else {
            WifiConfiguration config = Wifi.getWifiConfiguration(this.mainWifi, wScanResult, Wifi.ConfigSec.getScanResultSecurity(wScanResult));
            Intent iset;
            if (config == null) {
                if (Wifi.ConfigSec.isOpenNetwork(Wifi.ConfigSec.getScanResultSecurity(wScanResult))) {
                    if (Wifi.connectToNewNetwork(this.mContext, this.mainWifi, wScanResult, null, Secure.getInt(this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10))) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "setLastWifiScanResult");
                        this.mContext.sendBroadcast(iset);
                        DoFin();
                        return;
                    } else if (this.MzApp != null) {
                        this.MzApp.ShowMsg("WiFi Connect Failed", 1);
                        return;
                    } else {
                        return;
                    }
                }
                showDialog(1);
            } else if (Wifi.connectToConfiguredNetwork(this.mContext, this.mainWifi, config, false)) {
                iset = new Intent("cling.android.Router");
                iset.putExtra("enus", "setLastWifiScanResult");
                this.mContext.sendBroadcast(iset);
                DoFin();
            } else if (this.MzApp != null) {
                this.MzApp.ShowMsg("WiFi Connect Failed", 1);
            }
        }
    }

    private boolean onInit() {
        if (this.intent == null) {
            this.intent = getIntent();
        }
        if (this.intent != null) {
            this.tv_text1 = (TextView) findViewById(C0181R.id.step4_tv_text1);
            this.scanresult = (ScanResult) this.intent.getExtras().get("rs_wifi");
            this.tv_text1.setText(this.scanresult.SSID);
        } else {
            this.tv_text1 = (TextView) findViewById(C0181R.id.step4_tv_text1);
            this.tv_text1.setText(EXTHeader.DEFAULT_VALUE);
        }
        if (this.mContext == null) {
            this.mContext = getApplicationContext();
        }
        if (this.b_1st_connect == null) {
            this.b_1st_connect = (Button) findViewById(C0181R.id.step4_b_1stconnect);
            this.b_1st_connect.setText(getResources().getString(C0181R.string.apl_menu1));
            this.b_1st_connect.setOnClickListener(new C02484());
        }
        if (this.mContext == null) {
            this.mContext = getApplicationContext();
        }
        if (this.b_new_connect == null) {
            this.b_new_connect = (Button) findViewById(C0181R.id.step4_b_newconnect);
            this.b_new_connect.setText(getResources().getString(C0181R.string.apl_menu2));
            this.b_new_connect.setOnClickListener(new C02495());
        }
        return false;
    }
}
