package com.enus.myzik;

import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings.Secure;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

public class Step5_Activity extends MzActivity {
    private static final int nMenu_NewConn = 1;
    private static final String strDefPasswd = "12345678";
    private MzServerApp MzApp = null;
    private Button b_cancel = null;
    private Button b_connect = null;
    private EditText etPassword = null;
    private EditText et_pw = null;
    Intent intent = null;
    private Context mContext = null;
    private WifiManager mainWifi = null;
    ScanResult scanresult = null;

    class C02501 implements OnClickListener {
        C02501() {
        }

        public void onClick(DialogInterface dialog, int which) {
            String strCurPassword = EXTHeader.DEFAULT_VALUE;
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strSSID = EXTHeader.DEFAULT_VALUE;
            String strPassword = EXTHeader.DEFAULT_VALUE;
            strCurPassword = Step5_Activity.this.etPassword.getText().toString();
            if (strCurPassword.length() <= 0) {
                strCurPassword = Step5_Activity.strDefPasswd;
            } else if (strCurPassword.length() < 8 || strCurPassword.length() > 64) {
                if (Step5_Activity.this.MzApp != null) {
                    Step5_Activity.this.MzApp.ShowMsg("password length error (len: 8~64)", 1);
                }
                Step5_Activity.this.removeDialog(1);
                return;
            }
            Step5_Activity.this.removeDialog(1);
            try {
                if (Wifi.connectToNewNetwork(Step5_Activity.this.mContext, Step5_Activity.this.mainWifi, Step5_Activity.this.scanresult, strCurPassword, Secure.getInt(Step5_Activity.this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10))) {
                    Intent iset = new Intent("cling.android.Router");
                    iset.putExtra("enus", "setLastWifiScanResult");
                    Step5_Activity.this.mContext.sendBroadcast(iset);
                    Step5_Activity.this.DoFin();
                } else if (Step5_Activity.this.MzApp != null) {
                    Step5_Activity.this.MzApp.ShowMsg("WiFi Connect Failed", 1);
                }
            } catch (ArrayIndexOutOfBoundsException e) {
                e.printStackTrace();
            } catch (IndexOutOfBoundsException e2) {
                e2.printStackTrace();
            }
        }
    }

    class C02512 implements OnClickListener {
        C02512() {
        }

        public void onClick(DialogInterface dialog, int which) {
            Step5_Activity.this.removeDialog(1);
        }
    }

    class C02523 implements Runnable {
        C02523() {
        }

        public void run() {
            Step5_Activity.this.finish();
        }
    }

    class C02534 implements View.OnClickListener {
        C02534() {
        }

        public void onClick(View v) {
            String strCurPassword = EXTHeader.DEFAULT_VALUE;
            String strQuery = EXTHeader.DEFAULT_VALUE;
            String strSSID = EXTHeader.DEFAULT_VALUE;
            String strPassword = EXTHeader.DEFAULT_VALUE;
            strCurPassword = Step5_Activity.this.et_pw.getText().toString();
            if (strCurPassword.length() <= 0) {
                strCurPassword = Step5_Activity.strDefPasswd;
            } else if (strCurPassword.length() < 8 || strCurPassword.length() > 64) {
                if (Step5_Activity.this.MzApp != null) {
                    Step5_Activity.this.MzApp.ShowMsg("password length error (len: 8~64)", 1);
                    return;
                }
                return;
            }
            try {
                if (Wifi.connectToNewNetwork(Step5_Activity.this.mContext, Step5_Activity.this.mainWifi, Step5_Activity.this.scanresult, strCurPassword, Secure.getInt(Step5_Activity.this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10))) {
                    Intent iset = new Intent("cling.android.Router");
                    iset.putExtra("enus", "setLastWifiScanResult");
                    Step5_Activity.this.mContext.sendBroadcast(iset);
                    Step5_Activity.this.startActivity(new Intent(Step5_Activity.this, Step6_Activity.class));
                    return;
                }
                Intent imove = new Intent(Step5_Activity.this, Step9_Activity.class);
                imove.putExtra("is_kt", "no");
                imove.setFlags(DLNAFlags.SN_INCREASE);
                Step5_Activity.this.startActivity(imove);
            } catch (ArrayIndexOutOfBoundsException e) {
                e.printStackTrace();
            } catch (IndexOutOfBoundsException e2) {
                e2.printStackTrace();
            }
        }
    }

    class C02545 implements View.OnClickListener {
        C02545() {
        }

        public void onClick(View v) {
            Step5_Activity.this.onBackPressed();
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(C0181R.layout.activity_step5);
        this.MzApp = (MzServerApp) getApplicationContext();
        this.mainWifi = (WifiManager) getSystemService("wifi");
        onInit();
    }

    protected void onResume() {
        super.onResume();
        onInit();
    }

    protected void onDestroy() {
        DLog.m2e("jmg", "S5-onDestroy");
        super.onDestroy();
    }

    protected Dialog onCreateDialog(int id) {
        LayoutInflater factory = LayoutInflater.from(this.mContext);
        switch (id) {
            case 1:
                View vApAddLayout = factory.inflate(C0181R.layout.aplist_newcon_dialog, null);
                this.etPassword = null;
                this.etPassword = (EditText) vApAddLayout.findViewById(C0181R.id.aplist_password_editText_New);
                Dialog ApAddDialog = new Builder(this).setView(vApAddLayout).setNegativeButton("Connect", new C02501()).setPositiveButton("Cancel", new C02512()).create();
                ApAddDialog.setCancelable(false);
                return ApAddDialog;
            default:
                return null;
        }
    }

    private boolean isAdHoc(ScanResult wScanResult) {
        return wScanResult.capabilities.indexOf("IBSS") != -1;
    }

    void DoFin() {
        Intent iset = new Intent("cling.android.Router");
        iset.putExtra("enus", "EnableEventRecv");
        this.mContext.sendBroadcast(iset);
        new Handler().postDelayed(new C02523(), 300);
    }

    void DoForget(ScanResult wScanResult) {
        if (wScanResult == null) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("No data in Intent!", 1);
            }
            DoFin();
            return;
        }
        WifiConfiguration config = Wifi.getWifiConfiguration(this.mainWifi, wScanResult, Wifi.ConfigSec.getScanResultSecurity(wScanResult));
        if (config != null) {
            boolean result;
            if (this.mainWifi.removeNetwork(config.networkId) && this.mainWifi.saveConfiguration()) {
                result = true;
            } else {
                result = false;
            }
            if (result) {
                showDialog(1);
                return;
            } else if (this.MzApp != null) {
                this.MzApp.ShowMsg("Failed!", 1);
                return;
            } else {
                return;
            }
        }
        showDialog(1);
    }

    void DoConnectWifi(ScanResult wScanResult) {
        DLog.m0d("ui2w", "DoConnectWifi");
        if (this.MzApp == null) {
            this.MzApp = (MzServerApp) getApplicationContext();
        }
        if (wScanResult == null) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("No data in Intent!", 1);
            }
        } else if (!isAdHoc(wScanResult)) {
            WifiConfiguration config = Wifi.getWifiConfiguration(this.mainWifi, wScanResult, Wifi.ConfigSec.getScanResultSecurity(wScanResult));
            Intent iset;
            Intent imove;
            if (config == null) {
                DLog.m0d("ui2w", "config null");
                if (this.MzApp != null) {
                    this.MzApp.SetMenu1Icon(-1);
                }
                if (Wifi.ConfigSec.isOpenNetwork(Wifi.ConfigSec.getScanResultSecurity(wScanResult))) {
                    int nNumOpenNetworksKept = Secure.getInt(this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10);
                    if (false) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "setLastWifiScanResult");
                        this.mContext.sendBroadcast(iset);
                        startActivity(new Intent(this, Step6_Activity.class));
                        return;
                    }
                    imove = new Intent(this, Step9_Activity.class);
                    imove.putExtra("is_kt", "no");
                    imove.setFlags(DLNAFlags.SN_INCREASE);
                    startActivity(imove);
                    return;
                }
                return;
            }
            boolean connResult;
            DLog.m0d("ui2w", "config OK");
            if (this.mainWifi == null) {
                this.mainWifi = (WifiManager) getSystemService("wifi");
            }
            String str = EXTHeader.DEFAULT_VALUE;
            boolean isReConn = false;
            if (this.MzApp.GetSSID().compareTo(config.SSID.replace("\"", EXTHeader.DEFAULT_VALUE)) == 0) {
                DLog.m0d("ui2w", "WiFi Reconnect");
                connResult = this.mainWifi.reassociate();
                isReConn = true;
            } else {
                DLog.m0d("ui2w", "connectToConfiguredNetwork");
                connResult = Wifi.connectToConfiguredNetwork(this.mContext, this.mainWifi, config, false);
            }
            if (connResult) {
                if (!isReConn) {
                    if (this.MzApp != null) {
                        this.MzApp.SetMenu1Icon(-1);
                    }
                    iset = new Intent("cling.android.Router");
                    iset.putExtra("enus", "setLastWifiScanResult");
                    this.mContext.sendBroadcast(iset);
                }
                startActivity(new Intent(this, Step6_Activity.class));
                return;
            }
            imove = new Intent(this, Step9_Activity.class);
            imove.putExtra("is_kt", "no");
            imove.setFlags(DLNAFlags.SN_INCREASE);
            startActivity(imove);
        } else if (this.MzApp != null) {
            this.MzApp.ShowMsg("adhoc_not_supported_yet", 1);
        }
    }

    void DoConnectWifi2(ScanResult wScanResult) {
        if (wScanResult == null) {
            if (this.MzApp != null) {
                this.MzApp.ShowMsg("No data in Intent!", 1);
            }
        } else if (!isAdHoc(wScanResult)) {
            WifiConfiguration config = Wifi.getWifiConfiguration(this.mainWifi, wScanResult, Wifi.ConfigSec.getScanResultSecurity(wScanResult));
            Intent iset;
            if (config == null) {
                if (Wifi.ConfigSec.isOpenNetwork(Wifi.ConfigSec.getScanResultSecurity(wScanResult))) {
                    if (Wifi.connectToNewNetwork(this.mContext, this.mainWifi, wScanResult, null, Secure.getInt(this.mContext.getContentResolver(), "wifi_num_open_networks_kept", 10))) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "setLastWifiScanResult");
                        this.mContext.sendBroadcast(iset);
                        startActivity(new Intent(this, Step6_Activity.class));
                        return;
                    } else if (this.MzApp != null) {
                        this.MzApp.ShowMsg("WiFi Connect Failed", 1);
                        return;
                    } else {
                        return;
                    }
                }
                return;
            }
            if (this.mContext == null) {
                this.mContext = getApplicationContext();
            }
            if (this.mainWifi == null) {
                this.mainWifi = (WifiManager) getSystemService("wifi");
            }
            if (Wifi.connectToConfiguredNetwork(this.mContext, this.mainWifi, config, false)) {
                iset = new Intent("cling.android.Router");
                iset.putExtra("enus", "setLastWifiScanResult");
                this.mContext.sendBroadcast(iset);
                startActivity(new Intent(this, Step6_Activity.class));
                return;
            }
            Intent imove = new Intent(this, Step9_Activity.class);
            imove.putExtra("is_kt", "no");
            imove.setFlags(DLNAFlags.SN_INCREASE);
            startActivity(imove);
        } else if (this.MzApp != null) {
            this.MzApp.ShowMsg("adhoc_not_supported_yet", 1);
        }
    }

    private boolean onInit() {
        if (this.intent == null) {
            this.intent = getIntent();
        }
        if (this.intent != null) {
            this.et_pw = (EditText) findViewById(C0181R.id.step5_et_pw);
            this.scanresult = (ScanResult) this.intent.getExtras().get("rs_wifi");
            this.et_pw.setText(EXTHeader.DEFAULT_VALUE);
        } else {
            this.et_pw = (EditText) findViewById(C0181R.id.step5_et_pw);
            this.et_pw.setText(EXTHeader.DEFAULT_VALUE);
        }
        this.et_pw.setInputType(1);
        if (this.mContext == null) {
            this.mContext = getApplicationContext();
        }
        DoConnectWifi(this.scanresult);
        if (this.b_connect == null) {
            this.b_connect = (Button) findViewById(C0181R.id.step5_b_connect);
            this.b_connect.setText(getResources().getString(C0181R.string.apl_menu3));
            this.b_connect.setOnClickListener(new C02534());
        }
        if (this.b_cancel == null) {
            this.b_cancel = (Button) findViewById(C0181R.id.step5_b_cancel);
            this.b_cancel.setText(getResources().getString(C0181R.string.apl_menu4));
            this.b_cancel.setOnClickListener(new C02545());
        }
        return false;
    }
}
