package com.enus.myzik;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.graphics.drawable.AnimationDrawable;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.ProtocolInfo.DLNAFlags;

public class Step6_Activity extends MzActivity {
    private MzServerApp MzApp = null;
    private final BroadcastReceiver br = new C02551();
    private ImageButton ib_next = null;
    private Boolean is_kt = Boolean.valueOf(false);
    private ImageView iv_aniwifi = null;
    private Context mContext = null;
    private TextView tv_connected = null;

    class C02551 extends BroadcastReceiver {
        C02551() {
        }

        public void onReceive(Context context, Intent intent) {
            if (intent.getAction().equals("cling.android.Router")) {
                if (Step6_Activity.this.MzApp == null) {
                    Step6_Activity.this.MzApp = (MzServerApp) Step6_Activity.this.getApplicationContext();
                }
                if (intent.getExtras() != null) {
                    String strMsg = EXTHeader.DEFAULT_VALUE;
                    strMsg = intent.getExtras().getString("enus");
                    if (strMsg != null && strMsg.length() > 0 && strMsg.startsWith("icon_")) {
                        if (Step6_Activity.this.MzApp.mMode == 1 || Step6_Activity.this.MzApp.mMode == 2) {
                            Step6_Activity.this.ShowPreConnICon(2);
                        }
                    }
                }
            }
        }
    }

    class C02562 implements Runnable {
        C02562() {
        }

        public void run() {
            Step6_Activity.this.finish();
        }
    }

    class C02594 implements OnClickListener {
        C02594() {
        }

        public void onClick(View v) {
            Step6_Activity.this.startActivity(new Intent(Step6_Activity.this, Step7_Activity.class));
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(C0181R.layout.activity_step6);
        Bundle bundle = getIntent().getExtras();
        if (bundle != null && bundle.getString("is_kt").compareTo("yes") == 0) {
            this.is_kt = Boolean.valueOf(true);
            startActivity(new Intent("android.net.wifi.PICK_WIFI_NETWORK"));
        }
        onInit();
        this.MzApp = (MzServerApp) getApplicationContext();
        if (this.MzApp.mMode == 1 || this.MzApp.mMode == 2) {
            ShowPreConnICon(2);
        } else if (!this.is_kt.booleanValue()) {
            ShowPreConnICon(1);
        }
        registerReceiver(this.br, new IntentFilter("cling.android.Router"));
    }

    void DoFin() {
        new Handler().postDelayed(new C02562(), 300);
    }

    public void onBackPressed() {
        if (this.is_kt.booleanValue()) {
            Intent iback = new Intent(this, Step2_kt_Activity.class);
            iback.setFlags(DLNAFlags.SN_INCREASE);
            startActivity(iback);
            finish();
            return;
        }
        iback = new Intent(this, Step3_Activity.class);
        iback.setFlags(DLNAFlags.SN_INCREASE);
        startActivity(iback);
        finish();
    }

    protected void onResume() {
        super.onResume();
        onInit();
        if (this.MzApp == null) {
            this.MzApp = (MzServerApp) getApplicationContext();
        }
        if (!this.is_kt.booleanValue()) {
            return;
        }
        if (this.MzApp.mMode == 1 || this.MzApp.mMode == 2) {
            ShowPreConnICon(2);
        } else {
            ShowPreConnICon(1);
        }
    }

    protected void onDestroy() {
        if (this.br != null) {
            unregisterReceiver(this.br);
        }
        DLog.m2e("jmg", "S6-onDestroy");
        super.onDestroy();
    }

    public void ShowPreConnICon(final int flag_show) {
        if (this.iv_aniwifi != null) {
            new Handler().postDelayed(new Runnable() {

                class C02571 implements Runnable {
                    C02571() {
                    }

                    public void run() {
                        if (Step6_Activity.this.iv_aniwifi.getTag() != null && Integer.parseInt(Step6_Activity.this.iv_aniwifi.getTag().toString()) == C0181R.drawable.ani_wifi) {
                            Intent imove = new Intent(Step6_Activity.this, Step9_Activity.class);
                            if (Step6_Activity.this.is_kt.booleanValue()) {
                                imove.putExtra("is_kt", "yes");
                            } else {
                                imove.putExtra("is_kt", "no");
                            }
                            imove.setFlags(DLNAFlags.SN_INCREASE);
                            Step6_Activity.this.startActivity(imove);
                        }
                    }
                }

                public void run() {
                    try {
                        Step6_Activity.this.iv_aniwifi.setImageResource(C0181R.drawable.ani_wifi);
                        Step6_Activity.this.iv_aniwifi.setTag(Integer.valueOf(C0181R.drawable.ani_wifi));
                        AnimationDrawable frame = (AnimationDrawable) Step6_Activity.this.iv_aniwifi.getDrawable();
                        frame.stop();
                        if (flag_show == 2) {
                            Step6_Activity.this.tv_connected.setTextColor(Color.parseColor("#6cf62f"));
                            Step6_Activity.this.tv_connected.setText(Step6_Activity.this.getResources().getString(C0181R.string.step6_msg1));
                            Step6_Activity.this.iv_aniwifi.setImageResource(C0181R.drawable.wz02_wifi_connect);
                            Step6_Activity.this.iv_aniwifi.setTag(Integer.valueOf(C0181R.drawable.wz02_wifi_connect));
                            return;
                        }
                        Step6_Activity.this.tv_connected.setTextColor(Color.parseColor("#cccccc"));
                        Step6_Activity.this.tv_connected.setText(Step6_Activity.this.getResources().getString(C0181R.string.step6_msg2));
                        if (flag_show == 1) {
                            frame.start();
                            new Handler().postDelayed(new C02571(), 17000);
                        }
                    } catch (OutOfMemoryError e) {
                        e.printStackTrace();
                    }
                }
            }, 300);
        }
    }

    private boolean onInit() {
        if (this.mContext == null) {
            this.mContext = getApplicationContext();
        }
        if (this.ib_next == null) {
            this.ib_next = (ImageButton) findViewById(C0181R.id.step6_ib_next);
            this.ib_next.setOnClickListener(new C02594());
        }
        if (this.iv_aniwifi == null) {
            this.iv_aniwifi = (ImageView) findViewById(C0181R.id.step6_iv_aniwifi);
        }
        if (this.tv_connected == null) {
            this.tv_connected = (TextView) findViewById(C0181R.id.step6_tv_connected);
        }
        return false;
    }
}
