package com.enus.myzik;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;

public class TabItem extends LinearLayout {
    ImageView tabItemImage = null;

    public TabItem(Context context) {
        super(context);
        init(context, null);
    }

    public TabItem(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context, attrs);
    }

    private void init(Context context, AttributeSet attrs) {
        TypedArray typedArray = getContext().obtainStyledAttributes(attrs, C0181R.styleable.TableItem);
        LinearLayout v = (LinearLayout) ((LayoutInflater) context.getSystemService("layout_inflater")).inflate(C0181R.layout.tabitem, null);
        v.setLayoutParams(new LayoutParams(-1, -1));
        addView(v);
        this.tabItemImage = (ImageView) v.findViewById(C0181R.id.tabItemImage);
        this.tabItemImage.setImageResource(typedArray.getResourceId(1, 0));
    }

    public void SetImg(int resId) {
        this.tabItemImage.setImageResource(resId);
    }

    public Drawable GetImg() {
        return this.tabItemImage.getDrawable();
    }
}
