package com.enus.myzik;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Environment;
import com.enus.myzik.DataSet.TInfo;
import com.wireme.mediaserver.ContentTree;
import java.io.File;
import org.teleal.cling.model.message.header.EXTHeader;

public class Util4ConfRead {
    Context mContext = null;

    Util4ConfRead(Context pContext) {
        this.mContext = pContext;
    }

    Boolean GetLogConf() {
        Boolean DefValue = Boolean.valueOf(false);
        return this.mContext == null ? DefValue : Boolean.valueOf(this.mContext.getSharedPreferences("Conf", 0).getBoolean("putlog", DefValue.booleanValue()));
    }

    Boolean GetWizConf() {
        Boolean DefValue = Boolean.valueOf(true);
        return this.mContext == null ? DefValue : Boolean.valueOf(this.mContext.getSharedPreferences("Conf", 0).getBoolean("wiz", DefValue.booleanValue()));
    }

    String GetLastSSIDConf() {
        String DefValue = "JJak";
        return this.mContext == null ? DefValue : this.mContext.getSharedPreferences("Conf", 0).getString("lssid", DefValue);
    }

    int GetVID() {
        if (this.mContext == null) {
            return 0;
        }
        return this.mContext.getSharedPreferences("Conf", 0).getInt("vid", 0);
    }

    boolean GetTestWriteMode() {
        Boolean DefValue = Boolean.valueOf(false);
        if (this.mContext == null) {
            return DefValue.booleanValue();
        }
        return this.mContext.getSharedPreferences("Conf", 0).getBoolean("test_wmode", DefValue.booleanValue());
    }

    boolean GetForceUPMode() {
        Boolean DefValue = Boolean.valueOf(false);
        if (this.mContext == null) {
            return DefValue.booleanValue();
        }
        return this.mContext.getSharedPreferences("Conf", 0).getBoolean("forceup_mode", DefValue.booleanValue());
    }

    public int DoReadWiFiSleepPolicy() {
        if (this.mContext == null) {
            return 0;
        }
        return this.mContext.getSharedPreferences("Conf", 0).getInt("wifi_sleep_policy", 0);
    }

    boolean GetASoundMode() {
        Boolean DefValue = Boolean.valueOf(false);
        if (this.mContext == null) {
            return DefValue.booleanValue();
        }
        return this.mContext.getSharedPreferences("Conf", 0).getBoolean("isASoundOff", DefValue.booleanValue());
    }

    boolean GetUIDReg() {
        Boolean DefValue = Boolean.valueOf(false);
        if (this.mContext == null) {
            return DefValue.booleanValue();
        }
        return this.mContext.getSharedPreferences("Conf", 0).getBoolean("uid_reg", DefValue.booleanValue());
    }

    String GetADURL() {
        String DefValue = "http://www.enus.co.kr";
        return this.mContext == null ? DefValue : this.mContext.getSharedPreferences("Conf", 0).getString("adurl", DefValue);
    }

    String GetADSVR() {
        String DefValue = "http://ad.bcoda.com";
        return this.mContext == null ? DefValue : this.mContext.getSharedPreferences("Conf", 0).getString("adsvr", DefValue);
    }

    String GetDNTime() {
        String DefValue = ContentTree.ROOT_ID;
        return this.mContext == null ? DefValue : this.mContext.getSharedPreferences("Conf", 0).getString("dntime", DefValue);
    }

    String GetPLHome() {
        String DefValue = new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().toString())).append(File.separator).append("DownLoad").append(File.separator).toString();
        return this.mContext == null ? DefValue : this.mContext.getSharedPreferences("Conf", 0).getString("home", DefValue);
    }

    TInfo DoReadTInfos() {
        TInfo infos = new TInfo();
        infos.strMID = EXTHeader.DEFAULT_VALUE;
        infos.strMPW = EXTHeader.DEFAULT_VALUE;
        infos.nTmode = 0;
        if (this.mContext != null) {
            SharedPreferences prefs = this.mContext.getSharedPreferences("Conf", 0);
            infos.strMID = prefs.getString("tssid", EXTHeader.DEFAULT_VALUE);
            infos.strMPW = prefs.getString("tpw", EXTHeader.DEFAULT_VALUE);
            infos.nTmode = prefs.getInt("tmode", 0);
        }
        return infos;
    }

    boolean GetListMode() {
        Boolean DefValue = Boolean.valueOf(false);
        if (this.mContext == null) {
            return DefValue.booleanValue();
        }
        return this.mContext.getSharedPreferences("Conf", 0).getBoolean("isWList", DefValue.booleanValue());
    }

    static Boolean GetLogConf(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        return pContext == null ? DefValue : Boolean.valueOf(pContext.getSharedPreferences("Conf", 0).getBoolean("putlog", DefValue.booleanValue()));
    }

    static Boolean GetWizConf(Context pContext) {
        Boolean DefValue = Boolean.valueOf(true);
        return pContext == null ? DefValue : Boolean.valueOf(pContext.getSharedPreferences("Conf", 0).getBoolean("wiz", DefValue.booleanValue()));
    }

    static String GetLastSSIDConf(Context pContext) {
        String DefValue = "JJak";
        return pContext == null ? DefValue : pContext.getSharedPreferences("Conf", 0).getString("lssid", DefValue);
    }

    static int GetVID(Context pContext) {
        if (pContext == null) {
            return 0;
        }
        return pContext.getSharedPreferences("Conf", 0).getInt("vid", 0);
    }

    static boolean GetTestWriteMode(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        if (pContext == null) {
            return DefValue.booleanValue();
        }
        return pContext.getSharedPreferences("Conf", 0).getBoolean("test_wmode", DefValue.booleanValue());
    }

    static boolean GetForceUPMode(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        if (pContext == null) {
            return DefValue.booleanValue();
        }
        return pContext.getSharedPreferences("Conf", 0).getBoolean("forceup_mode", DefValue.booleanValue());
    }

    public static int DoReadWiFiSleepPolicy(Context pContext) {
        if (pContext == null) {
            return 0;
        }
        return pContext.getSharedPreferences("Conf", 0).getInt("wifi_sleep_policy", 0);
    }

    static boolean GetASoundMode(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        if (pContext == null) {
            return DefValue.booleanValue();
        }
        return pContext.getSharedPreferences("Conf", 0).getBoolean("isASoundOff", DefValue.booleanValue());
    }

    static boolean GetUIDReg(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        if (pContext == null) {
            return DefValue.booleanValue();
        }
        return pContext.getSharedPreferences("Conf", 0).getBoolean("uid_reg", DefValue.booleanValue());
    }

    static String GetADURL(Context pContext) {
        String DefValue = "http://www.enus.co.kr";
        return pContext == null ? DefValue : pContext.getSharedPreferences("Conf", 0).getString("adurl", DefValue);
    }

    static String GetADSVR(Context pContext) {
        String DefValue = "http://ad.bcoda.com";
        return pContext == null ? DefValue : pContext.getSharedPreferences("Conf", 0).getString("adsvr", DefValue);
    }

    static String GetDNTime(Context pContext) {
        String DefValue = ContentTree.ROOT_ID;
        return pContext == null ? DefValue : pContext.getSharedPreferences("Conf", 0).getString("dntime", DefValue);
    }

    static String GetPLHome(Context pContext) {
        String DefValue = new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().toString())).append(File.separator).append("DownLoad").append(File.separator).toString();
        return pContext == null ? DefValue : pContext.getSharedPreferences("Conf", 0).getString("home", DefValue);
    }

    static TInfo DoReadTInfos(Context pContext) {
        TInfo infos = new TInfo();
        infos.strMID = EXTHeader.DEFAULT_VALUE;
        infos.strMPW = EXTHeader.DEFAULT_VALUE;
        infos.nTmode = 0;
        if (pContext != null) {
            SharedPreferences prefs = pContext.getSharedPreferences("Conf", 0);
            infos.strMID = prefs.getString("tssid", EXTHeader.DEFAULT_VALUE);
            infos.strMPW = prefs.getString("tpw", EXTHeader.DEFAULT_VALUE);
            infos.nTmode = prefs.getInt("tmode", 0);
        }
        return infos;
    }

    static boolean GetListMode(Context pContext) {
        Boolean DefValue = Boolean.valueOf(false);
        if (pContext == null) {
            return DefValue.booleanValue();
        }
        return pContext.getSharedPreferences("Conf", 0).getBoolean("isWList", DefValue.booleanValue());
    }
}
