package com.enus.myzik;

import android.content.Context;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.util.Log;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Locale;
import java.util.StringTokenizer;
import org.teleal.cling.model.message.header.EXTHeader;

public class Utils {
    public static String GetDataDir(Context pContext) {
        PackageManager m = pContext.getPackageManager();
        String strPName = pContext.getPackageName();
        String strDataDir = EXTHeader.DEFAULT_VALUE;
        try {
            return m.getPackageInfo(strPName, 0).applicationInfo.dataDir;
        } catch (NameNotFoundException e) {
            Log.w("yourtag", "Error Package name not found ", e);
            return strDataDir;
        }
    }

    public static String md5(String in) {
        try {
            MessageDigest digest = MessageDigest.getInstance("MD5");
            digest.reset();
            digest.update(in.getBytes());
            byte[] a = digest.digest();
            int len = a.length;
            StringBuilder sb = new StringBuilder(len << 1);
            for (int i = 0; i < len; i++) {
                sb.append(Character.forDigit((a[i] & 240) >> 4, 16));
                sb.append(Character.forDigit(a[i] & 15, 16));
            }
            return sb.toString();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String GetDeviceModel() {
        String strRes = EXTHeader.DEFAULT_VALUE;
        try {
            Class<?> c = Class.forName("android.os.SystemProperties");
            return (String) c.getMethod("get", new Class[]{String.class}).invoke(c, new Object[]{"ro.product.model"});
        } catch (Exception e) {
            return strRes;
        }
    }

    public static String GetDeviceOSVer() {
        String strRes = EXTHeader.DEFAULT_VALUE;
        try {
            Class<?> c = Class.forName("android.os.SystemProperties");
            return (String) c.getMethod("get", new Class[]{String.class}).invoke(c, new Object[]{"ro.build.version.release"});
        } catch (Exception e) {
            return strRes;
        }
    }

    public static String GetCurrentLanguage() {
        return Locale.getDefault().getDisplayLanguage();
    }

    public static String GetDeviceVendor() {
        String strRes = EXTHeader.DEFAULT_VALUE;
        try {
            Class<?> c = Class.forName("android.os.SystemProperties");
            return (String) c.getMethod("get", new Class[]{String.class}).invoke(c, new Object[]{"ro.product.manufacturer"});
        } catch (Exception e) {
            return strRes;
        }
    }

    public static String GetAndroidVer() {
        String res = "x";
        String strSysVer = GetDeviceOSVer();
        if (strSysVer.length() <= 0) {
            return res;
        }
        Log.d("ddver", strSysVer);
        String srTmp = EXTHeader.DEFAULT_VALUE;
        try {
            srTmp = new String(strSysVer.getBytes(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        StringTokenizer stok = new StringTokenizer(srTmp, ".", false);
        int i = 0;
        String[] strVer = new String[strSysVer.length()];
        while (stok.hasMoreTokens()) {
            strVer[i] = stok.nextToken();
            i++;
        }
        Log.d("ddver", String.format("%s %s %s", new Object[]{strVer[0], strVer[1], strVer[2]}));
        try {
            if (Integer.valueOf(strVer[0]).intValue() == 4) {
                res = "kk";
                if (Integer.valueOf(strVer[1]).intValue() < 4) {
                    return "ics";
                }
                return res;
            } else if (Integer.valueOf(strVer[0]).intValue() == 3) {
                return "hc";
            } else {
                if (Integer.valueOf(strVer[0]).intValue() != 2) {
                    return res;
                }
                if (Integer.valueOf(strVer[1]).intValue() == 3) {
                    res = "gb";
                    if (Integer.valueOf(strVer[2]).intValue() < 6) {
                        return "gb_old";
                    }
                    return res;
                } else if (Integer.valueOf(strVer[1]).intValue() == 2) {
                    return "fy";
                } else {
                    if (Integer.valueOf(strVer[1]).intValue() < 2) {
                        return "etc";
                    }
                    return res;
                }
            }
        } catch (NumberFormatException e2) {
            e2.printStackTrace();
            return "ics";
        }
    }
}
