package com.enus.myzik;

import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.Matrix;
import android.os.Bundle;
import android.os.Vibrator;
import android.provider.MediaStore.Images.Media;
import android.provider.MediaStore.Images.Thumbnails;
import android.view.GestureDetector;
import android.view.GestureDetector.OnGestureListener;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.FrameLayout.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageSwitcher;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.TextView;
import android.widget.ViewSwitcher.ViewFactory;
import com.squareup.picasso.Picasso;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class View02_Image_Activity extends MzActivity implements OnItemSelectedListener, ViewFactory, OnGestureListener {
    private static final int SWIPE_MAX_OFF_PATH = 250;
    private static final int SWIPE_MIN_DISTANCE = 120;
    private static final int SWIPE_THRESHOLD_VELOCITY = 200;
    static Context mContext;
    private ArrayList<CustomListItem> Items;
    private GestureDetector gestureDetector = null;
    Animation lin;
    Animation lout;
    ImageView mBtnRoL = null;
    ImageView mBtnRoR = null;
    ContentResolver mCr;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mLeftClickListener = new C02791();
    public OnClickListener mRightClickListener = new C02802();
    Vibrator mVib = null;
    ImageButton mbutLeft = null;
    ImageButton mbutRight = null;
    private ImageSwitcher misViewer = null;
    int nPosition = -1;
    int nType = 0;
    Animation rin;
    Animation rout;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C02791 implements OnClickListener {
        C02791() {
        }

        public void onClick(View v) {
            if (View02_Image_Activity.this.nPosition != 0) {
                View02_Image_Activity.this.misViewer.setInAnimation(View02_Image_Activity.this.lin);
                View02_Image_Activity.this.misViewer.setOutAnimation(View02_Image_Activity.this.rout);
                View02_Image_Activity view02_Image_Activity = View02_Image_Activity.this;
                view02_Image_Activity.nPosition--;
                if (View02_Image_Activity.this.nPosition < View02_Image_Activity.this.Items.size() - 1) {
                    View02_Image_Activity.this.mbutRight.setVisibility(0);
                }
                if (View02_Image_Activity.this.nPosition == 0) {
                    View02_Image_Activity.this.mbutLeft.setVisibility(4);
                } else {
                    View02_Image_Activity.this.mbutLeft.setVisibility(0);
                }
                View02_Image_Activity.this.SetImage(View02_Image_Activity.this.nPosition);
            }
        }
    }

    class C02802 implements OnClickListener {
        C02802() {
        }

        public void onClick(View v) {
            if (View02_Image_Activity.this.nPosition != View02_Image_Activity.this.Items.size() - 1) {
                View02_Image_Activity.this.misViewer.setInAnimation(View02_Image_Activity.this.rin);
                View02_Image_Activity.this.misViewer.setOutAnimation(View02_Image_Activity.this.lout);
                View02_Image_Activity view02_Image_Activity = View02_Image_Activity.this;
                view02_Image_Activity.nPosition++;
                if (View02_Image_Activity.this.nPosition > 0) {
                    View02_Image_Activity.this.mbutLeft.setVisibility(0);
                }
                if (View02_Image_Activity.this.nPosition == View02_Image_Activity.this.Items.size() - 1) {
                    View02_Image_Activity.this.mbutRight.setVisibility(4);
                } else {
                    View02_Image_Activity.this.mbutRight.setVisibility(0);
                }
                View02_Image_Activity.this.SetImage(View02_Image_Activity.this.nPosition);
            }
        }
    }

    class C02813 implements OnClickListener {
        C02813() {
        }

        public void onClick(View view) {
            View02_Image_Activity.this.mVib.vibrate(500);
            View02_Image_Activity.this.RotImage(View02_Image_Activity.this.nPosition);
            View02_Image_Activity.this.SetImage(View02_Image_Activity.this.nPosition);
        }
    }

    class C02824 implements OnClickListener {
        C02824() {
        }

        public void onClick(View view) {
            View02_Image_Activity.this.mVib.vibrate(500);
            View02_Image_Activity.this.RotImage(View02_Image_Activity.this.nPosition);
            View02_Image_Activity.this.SetImage(View02_Image_Activity.this.nPosition);
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.view02_image);
        this.lin = AnimationUtils.loadAnimation(getApplicationContext(), C0181R.anim.left_in);
        this.lout = AnimationUtils.loadAnimation(getApplicationContext(), C0181R.anim.left_out);
        this.rin = AnimationUtils.loadAnimation(getApplicationContext(), C0181R.anim.right_in);
        this.rout = AnimationUtils.loadAnimation(getApplicationContext(), C0181R.anim.right_out);
        onInit(getApplicationContext());
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        if (this.strListName.compareTo(mContext.getResources().getString(C0181R.string.lpl_name2)) == 0) {
            GetLPL();
        } else {
            onRead();
        }
    }

    protected void onDestroy() {
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.misViewer != null) {
            this.misViewer.setImageDrawable(null);
        }
        this.misViewer = null;
        recursiveRecycle(getWindow().getDecorView());
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        System.gc();
    }

    void RotImage(int nPos) {
    }

    void SetImage(int nPos) {
        if (nPos >= 0 && nPos < this.Items.size()) {
            Picasso.with(mContext).load(new File(((CustomListItem) this.Items.get(nPos)).getPath())).into((ImageView) this.misViewer.getCurrentView());
        }
    }

    private static void removeThumbnails(ContentResolver contentResolver, long photoId) {
        ContentResolver contentResolver2 = contentResolver;
        Cursor thumbnails = contentResolver2.query(Thumbnails.EXTERNAL_CONTENT_URI, null, "image_id=?", new String[]{String.valueOf(photoId)}, null);
        thumbnails.moveToFirst();
        while (!thumbnails.isAfterLast()) {
            long thumbnailId = thumbnails.getLong(thumbnails.getColumnIndex("_id"));
            if (new File(thumbnails.getString(thumbnails.getColumnIndex("_data"))).delete()) {
                contentResolver.delete(Thumbnails.EXTERNAL_CONTENT_URI, "_id=?", new String[]{String.valueOf(thumbnailId)});
            }
            thumbnails.moveToNext();
        }
    }

    public static Bitmap rotateImg(Bitmap image, int degrees, String strPath) {
        if (!(degrees == 0 || image == null)) {
            Matrix m = new Matrix();
            m.preRotate((float) degrees);
            Bitmap b2 = Bitmap.createBitmap(image, 0, 0, image.getWidth(), image.getHeight(), m, true);
            if (image != b2) {
                image.recycle();
                image = b2;
            }
            FileOutputStream outStream = null;
            ByteArrayOutputStream stream = new ByteArrayOutputStream();
            b2.compress(CompressFormat.PNG, 100, stream);
            byte[] data = stream.toByteArray();
            try {
                outStream = new FileOutputStream(strPath);
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
            try {
                outStream.write(data);
            } catch (IOException e2) {
                e2.printStackTrace();
            }
            try {
                outStream.close();
            } catch (IOException e22) {
                e22.printStackTrace();
            }
        }
        return image;
    }

    String getThumbnailPathForLocalFile(long fileId) {
        String thumbnailPath = null;
        Cursor thumbCursor = null;
        try {
            thumbCursor = getBaseContext().getContentResolver().query(Thumbnails.EXTERNAL_CONTENT_URI, null, "image_id = " + fileId + " AND " + "kind" + " = " + 1, null, null);
            if (thumbCursor.moveToFirst()) {
                thumbnailPath = thumbCursor.getString(thumbCursor.getColumnIndexOrThrow("_data"));
            } else if (thumbCursor != null) {
                thumbCursor.close();
            }
            return thumbnailPath;
        } finally {
            if (thumbCursor != null) {
                thumbCursor.close();
            }
        }
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mbutLeft = null;
        this.mbutRight = null;
        this.mBtnRoL = null;
        this.mBtnRoR = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        mContext = context;
        this.mVib = (Vibrator) mContext.getSystemService("vibrator");
        TextView tvTitle = (TextView) findViewById(C0181R.id.view02_image_textView_Title);
        this.misViewer = (ImageSwitcher) findViewById(C0181R.id.view02_image_imageSwitcher_Viewer);
        this.mbutLeft = (ImageButton) findViewById(C0181R.id.view02_image_button_Left);
        this.mbutRight = (ImageButton) findViewById(C0181R.id.view02_image_button_Right);
        this.mBtnRoL = (ImageView) findViewById(C0181R.id.view02_imageView_ro_left);
        this.mBtnRoR = (ImageView) findViewById(C0181R.id.view02_imageView_ro_right);
        this.misViewer.setFactory(this);
        if (tvTitle == null || this.misViewer == null || this.mbutLeft == null || this.mbutRight == null) {
            return false;
        }
        this.mbutLeft.setOnClickListener(this.mLeftClickListener);
        this.mbutRight.setOnClickListener(this.mRightClickListener);
        this.mBtnRoL.setOnClickListener(new C02813());
        this.mBtnRoR.setOnClickListener(new C02824());
        this.gestureDetector = new GestureDetector(this);
        this.Items = new ArrayList();
        this.mCr = getContentResolver();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nTmpPosition = intent.getIntExtra("position", -1);
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 2) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER, " + "`thumb_path` TEXT" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nPosition = nTmpPosition;
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    public boolean GetLPL() {
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        Cursor cursor = this.mCr.query(Media.EXTERNAL_CONTENT_URI, null, "_size<= 4.295E+9", null, "date_added DESC limit 100");
        if (cursor == null) {
            return false;
        } else if (cursor.moveToFirst()) {
            long nTotalSize = 0;
            r7 = strDisplayName;
            while (!cursor.isAfterLast()) {
                int nColumnIdx = cursor.getColumnIndex("_display_name");
                if (nColumnIdx >= 0) {
                    r7 = cursor.getString(nColumnIdx);
                    nColumnIdx = cursor.getColumnIndex("description");
                    if (nColumnIdx >= 0) {
                        strInfo1 = cursor.getString(nColumnIdx);
                        nColumnIdx = cursor.getColumnIndex("datetaken");
                        if (nColumnIdx >= 0) {
                            strInfo2 = cursor.getString(nColumnIdx);
                            nColumnIdx = cursor.getColumnIndex("_id");
                            if (nColumnIdx >= 0) {
                                strInfo3 = cursor.getString(nColumnIdx);
                                nColumnIdx = cursor.getColumnIndex("mime_type");
                                if (nColumnIdx >= 0) {
                                    strInfo4 = cursor.getString(nColumnIdx);
                                    nColumnIdx = cursor.getColumnIndex("title");
                                    if (nColumnIdx >= 0) {
                                        strInfo5 = cursor.getString(nColumnIdx);
                                        if (strInfo5 == null) {
                                            strInfo5 = r7;
                                        } else if (strInfo5.length() <= 0) {
                                            strInfo5 = r7;
                                        }
                                        nColumnIdx = cursor.getColumnIndex("_data");
                                        if (nColumnIdx >= 0) {
                                            strPath = cursor.getString(nColumnIdx);
                                            nColumnIdx = cursor.getColumnIndex("_size");
                                            if (nColumnIdx >= 0) {
                                                long nSize = cursor.getLong(nColumnIdx);
                                                nColumnIdx = cursor.getColumnIndex("_data");
                                                if (nColumnIdx >= 0) {
                                                    strThumbPath = cursor.getString(nColumnIdx);
                                                    nTotalSize += nSize;
                                                    if (((double) nTotalSize) > 8.3752E9d) {
                                                        break;
                                                    }
                                                    this.Items.add(new CustomListItem(0, r7, strInfo1, strInfo2, strInfo3, strInfo4, strInfo5, strPath, nSize, EXTHeader.DEFAULT_VALUE));
                                                    cursor.moveToNext();
                                                } else {
                                                    cursor.close();
                                                    return false;
                                                }
                                            }
                                            cursor.close();
                                            return false;
                                        }
                                        cursor.close();
                                        return false;
                                    }
                                    cursor.close();
                                    return false;
                                }
                                cursor.close();
                                return false;
                            }
                            cursor.close();
                            return false;
                        }
                        cursor.close();
                        return false;
                    }
                    cursor.close();
                    return false;
                }
                cursor.close();
                return false;
            }
            cursor.close();
            if (this.nPosition == 0) {
                this.mbutLeft.setVisibility(4);
            } else if (this.nPosition == this.Items.size() - 1) {
                this.mbutRight.setVisibility(4);
            }
            SetImage(this.nPosition);
            return true;
        } else {
            cursor.close();
            r7 = strDisplayName;
            return false;
        }
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        String strThumbPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
        if (this.mCursor == null) {
            return false;
        }
        if (this.mCursor.moveToFirst()) {
            int nNumber = 0;
            while (!this.mCursor.isAfterLast()) {
                int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                strDisplayName = this.mCursor.getString(this.mCursor.getColumnIndex("display_name"));
                strInfo1 = this.mCursor.getString(this.mCursor.getColumnIndex("info1"));
                strInfo2 = this.mCursor.getString(this.mCursor.getColumnIndex("info2"));
                strInfo3 = this.mCursor.getString(this.mCursor.getColumnIndex("info3"));
                strInfo4 = this.mCursor.getString(this.mCursor.getColumnIndex("info4"));
                strInfo5 = this.mCursor.getString(this.mCursor.getColumnIndex("info5"));
                strPath = this.mCursor.getString(this.mCursor.getColumnIndex("path"));
                int nSize = this.mCursor.getInt(this.mCursor.getColumnIndex("size"));
                CustomListItem Item = new CustomListItem(nNumber, strDisplayName, strInfo1, strInfo2, strInfo3, strInfo4, strInfo5, strPath, (long) nSize, this.mCursor.getString(this.mCursor.getColumnIndex("thumb_path")));
                Item.setIdx(nIdx);
                this.Items.add(Item);
                this.mCursor.moveToNext();
                nNumber++;
            }
            this.mCursor.close();
            if (this.nPosition == 0) {
                this.mbutLeft.setVisibility(4);
            } else if (this.nPosition == this.Items.size() - 1) {
                this.mbutRight.setVisibility(4);
            }
            SetImage(this.nPosition);
            return true;
        }
        this.mCursor.close();
        return false;
    }

    public View makeView() {
        ImageView i = new ImageView(mContext);
        i.setBackgroundColor(-16777216);
        i.setScaleType(ScaleType.FIT_CENTER);
        i.setLayoutParams(new LayoutParams(-1, -1));
        return i;
    }

    public void onItemSelected(AdapterView<?> adapterView, View view, int position, long id) {
    }

    public void onNothingSelected(AdapterView<?> adapterView) {
    }

    public boolean onTouchEvent(MotionEvent ev) {
        return this.gestureDetector.onTouchEvent(ev);
    }

    public boolean onDown(MotionEvent e) {
        return false;
    }

    public void onShowPress(MotionEvent e) {
    }

    public boolean onSingleTapUp(MotionEvent e) {
        return false;
    }

    public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
        return false;
    }

    public void onLongPress(MotionEvent e) {
    }

    public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
        try {
            if (Math.abs(e1.getY() - e2.getY()) <= 250.0f && ((e1.getX() - e2.getX() <= 120.0f || Math.abs(velocityX) <= 200.0f) && ((e2.getX() - e1.getX() <= 120.0f || Math.abs(velocityX) <= 200.0f) && ((e1.getY() - e2.getY() <= 120.0f || Math.abs(velocityX) <= 200.0f) && e2.getY() - e1.getY() > 120.0f)))) {
                Math.abs(velocityX);
            }
        } catch (Exception e) {
        }
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }
}
