package com.enus.myzik;

import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.ActivityNotFoundException;
import android.content.ContentResolver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.webkit.MimeTypeMap;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import java.io.File;
import java.util.ArrayList;
import org.teleal.cling.model.message.header.EXTHeader;

public class View_File_Activity extends MzActivity {
    private static final int nMenu_Delete = 3;
    private static final int nMenu_Edit = 1;
    private static final int nMenu_Empty = 2;
    private CustomViewFileAdapter Adapter;
    private ArrayList<CustomListItem> Items;
    private TextView lvf_txt = null;
    private View lvfooter = null;
    Context mContext;
    ContentResolver mCr;
    private Cursor mCursor = null;
    public DatabaseManager mDBManager = null;
    public OnClickListener mDeleteClickListener = new C02964();
    public OnClickListener mEditClickListener = new C02942();
    public OnClickListener mEmptyClickListener = new C02953();
    OnItemClickListener mItemClickListener = new C02931();
    ImageButton mbutDelete;
    ImageButton mbutEdit;
    ImageButton mbutEmpty;
    ListView mlvList;
    TextView mtvText;
    int nType = 0;
    String strListName = EXTHeader.DEFAULT_VALUE;
    String strTableName = EXTHeader.DEFAULT_VALUE;

    class C02931 implements OnItemClickListener {
        C02931() {
        }

        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            CustomListItem Item = (CustomListItem) parent.getAdapter().getItem(position);
            String strData = Item.getDisplayName();
            try {
                String strExt = Item.getPath();
                int nFindDot = strExt.lastIndexOf(46);
                if (nFindDot > 0) {
                    strExt = strExt.substring(nFindDot + 1);
                    if (!(strExt == null || strExt.isEmpty())) {
                        strExt = strExt.toLowerCase();
                    }
                } else {
                    strExt = MimeTypeMap.getFileExtensionFromUrl(Item.getPath());
                    if (!(strExt == null || strExt.isEmpty())) {
                        strExt = strExt.toLowerCase();
                    }
                }
                String strMimeType = EXTHeader.DEFAULT_VALUE;
                if (!(strExt == null || strExt.isEmpty())) {
                    strMimeType = MimeTypeMap.getSingleton().getMimeTypeFromExtension(strExt);
                }
                if (strMimeType == null || strMimeType.isEmpty()) {
                    ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg(strData, 1);
                    return;
                }
                Intent it = new Intent("android.intent.action.VIEW");
                it.setDataAndType(Uri.parse("file://" + Item.getPath()), strMimeType);
                View_File_Activity.this.startActivity(it);
            } catch (ActivityNotFoundException e) {
                e.printStackTrace();
                ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg(strData, 1);
            }
        }
    }

    class C02942 implements OnClickListener {
        C02942() {
        }

        public void onClick(View v) {
            MzServerApp MzApp = (MzServerApp) View_File_Activity.this.mContext.getApplicationContext();
            Intent intent = new Intent(View_File_Activity.this, Edit_File_Activity.class);
            intent.putExtra("type", View_File_Activity.this.nType);
            intent.putExtra("list_name", View_File_Activity.this.strListName);
            intent.putExtra("table_name", View_File_Activity.this.strTableName);
            View_File_Activity.this.startActivity(intent);
        }
    }

    class C02953 implements OnClickListener {
        C02953() {
        }

        public void onClick(View v) {
            View_File_Activity.this.showDialog(2);
        }
    }

    class C02964 implements OnClickListener {
        C02964() {
        }

        public void onClick(View v) {
            View_File_Activity.this.showDialog(3);
        }
    }

    class C02975 implements DialogInterface.OnClickListener {
        C02975() {
        }

        public void onClick(DialogInterface dialog, int which) {
            String strQuery = EXTHeader.DEFAULT_VALUE;
            if (!View_File_Activity.this.mDBManager.execSQL("DROP TABLE IF EXISTS '" + View_File_Activity.this.strTableName + "'")) {
                ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
            }
            if (View_File_Activity.this.nType == 4) {
                strQuery = "CREATE TABLE IF NOT EXISTS `" + View_File_Activity.this.strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER" + ")";
            } else {
                strQuery = EXTHeader.DEFAULT_VALUE;
            }
            if (!View_File_Activity.this.mDBManager.execSQL(strQuery)) {
                ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
            }
            View_File_Activity.this.removeDialog(2);
            View_File_Activity.this.finish();
        }
    }

    class C02986 implements DialogInterface.OnClickListener {
        C02986() {
        }

        public void onClick(DialogInterface dialog, int which) {
            View_File_Activity.this.removeDialog(2);
        }
    }

    class C02997 implements DialogInterface.OnClickListener {
        C02997() {
        }

        public void onClick(DialogInterface dialog, int which) {
            View_File_Activity.this.rm_dir(View_File_Activity.this.strListName);
            String strQuery = EXTHeader.DEFAULT_VALUE;
            if (View_File_Activity.this.mDBManager.execSQL("DROP TABLE IF EXISTS '" + View_File_Activity.this.strTableName + "'")) {
                Cursor cursor = View_File_Activity.this.mDBManager.onSelect("SELECT count(*) FROM `playlist`");
                if (cursor == null) {
                    ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
                    View_File_Activity.this.removeDialog(3);
                    View_File_Activity.this.finish();
                    return;
                } else if (cursor.moveToFirst()) {
                    int nCount = cursor.getInt(cursor.getColumnIndex("count(*)"));
                    cursor.close();
                    if (nCount <= 0) {
                        ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
                        View_File_Activity.this.removeDialog(3);
                        View_File_Activity.this.finish();
                        return;
                    }
                    if (!View_File_Activity.this.mDBManager.execSQL("DELETE FROM `playlist` WHERE `contents` = '" + View_File_Activity.this.strTableName + "' AND `type` = " + View_File_Activity.this.nType)) {
                        ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
                    }
                    View_File_Activity.this.removeDialog(3);
                    View_File_Activity.this.finish();
                    return;
                } else {
                    cursor.close();
                    ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
                    View_File_Activity.this.removeDialog(3);
                    View_File_Activity.this.finish();
                    return;
                }
            }
            ((MzServerApp) View_File_Activity.this.mContext.getApplicationContext()).ShowMsg("Error", 1);
            View_File_Activity.this.removeDialog(3);
            View_File_Activity.this.finish();
        }
    }

    class C03008 implements DialogInterface.OnClickListener {
        C03008() {
        }

        public void onClick(DialogInterface dialog, int which) {
            View_File_Activity.this.removeDialog(3);
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(1);
        setContentView(C0181R.layout.view_file);
        onInit(getApplicationContext());
        this.Adapter = new CustomViewFileAdapter(this.mContext, C0181R.layout.view_file_item, this.Items);
        this.Adapter.onInit(this.mDBManager, this.strTableName);
        this.mlvList.setEmptyView(this.mtvText);
        this.lvfooter = getLayoutInflater().inflate(C0181R.layout.lvfooter, null, false);
        this.lvf_txt = (TextView) this.lvfooter.findViewById(C0181R.id.lvf_txt);
        this.mlvList.addFooterView(this.lvfooter, null, false);
        this.mlvList.setAdapter(this.Adapter);
        this.mlvList.setOnItemClickListener(this.mItemClickListener);
    }

    protected void onResume() {
        super.onResume();
        if (this.Items != null) {
            this.Items.clear();
        }
        if (this.mDBManager == null) {
            onInit(getApplicationContext());
        }
        onRead();
        this.Adapter.notifyDataSetChanged();
    }

    protected void onDestroy() {
        recursiveRecycle(getWindow().getDecorView());
        clearApplicationCache(null);
        super.onDestroy();
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        System.gc();
    }

    void rm_dir(String strDirName) {
        String[] children;
        String strPath = new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().toString())).append(File.separator).append(getResources().getString(C0181R.string.root_directory)).append(File.separator).append(strDirName).toString();
        File fSubFolder = new File(new StringBuilder(String.valueOf(strPath)).append(File.separator).append("NoScan").toString());
        if (fSubFolder.exists()) {
            if (fSubFolder.isDirectory()) {
                children = fSubFolder.list();
                for (String file : children) {
                    new File(fSubFolder, file).delete();
                }
            }
            fSubFolder.delete();
        }
        File fNewFolder = new File(strPath);
        if (fNewFolder.exists()) {
            if (fNewFolder.isDirectory()) {
                children = fNewFolder.list();
                for (String file2 : children) {
                    new File(fNewFolder, file2).delete();
                }
            }
            fNewFolder.delete();
        }
    }

    protected Dialog onCreateDialog(int id) {
        LayoutInflater factory = LayoutInflater.from(this.mContext);
        switch (id) {
            case 2:
                Dialog ClearDialog = new Builder(this).setMessage(getResources().getString(C0181R.string.list_msg2)).setNegativeButton("OK", new C02975()).setPositiveButton("Cancel", new C02986()).create();
                ClearDialog.setCancelable(false);
                return ClearDialog;
            case 3:
                Dialog DeleteDialog = new Builder(this).setMessage(getResources().getString(C0181R.string.list_msg3)).setNegativeButton("OK", new C02997()).setPositiveButton("Cancel", new C03008()).create();
                DeleteDialog.setCancelable(false);
                return DeleteDialog;
            default:
                return null;
        }
    }

    public boolean onInit(Context context) {
        String strListName = EXTHeader.DEFAULT_VALUE;
        String strTableName = EXTHeader.DEFAULT_VALUE;
        String strQuery = EXTHeader.DEFAULT_VALUE;
        this.mlvList = null;
        this.mtvText = null;
        this.mbutEdit = null;
        this.mbutEmpty = null;
        this.mbutDelete = null;
        if (this.Items != null) {
            this.Items.clear();
        }
        this.Items = null;
        if (this.mDBManager != null) {
            this.mDBManager.close();
        }
        this.mDBManager = null;
        this.mContext = context;
        this.mlvList = (ListView) findViewById(C0181R.id.view_file_listView_Viewlist);
        this.mtvText = (TextView) findViewById(C0181R.id.view_file_textView_EmptyView);
        TextView tvTitle = (TextView) findViewById(C0181R.id.view_file_textView_Title);
        this.mbutEdit = (ImageButton) findViewById(C0181R.id.view_file_imageButton_Edit);
        this.mbutEmpty = (ImageButton) findViewById(C0181R.id.view_file_imageButton_Empty);
        this.mbutDelete = (ImageButton) findViewById(C0181R.id.view_file_imageButton_Delete);
        if (this.mlvList == null || this.mtvText == null || tvTitle == null || this.mbutEdit == null || this.mbutEmpty == null || this.mbutDelete == null) {
            return false;
        }
        this.lvfooter = getLayoutInflater().inflate(C0181R.layout.lvfooter, null, false);
        this.lvf_txt = (TextView) this.lvfooter.findViewById(C0181R.id.lvf_txt);
        this.mbutEdit.setOnClickListener(this.mEditClickListener);
        this.mbutEmpty.setOnClickListener(this.mEmptyClickListener);
        this.mbutDelete.setOnClickListener(this.mDeleteClickListener);
        this.Items = new ArrayList();
        this.mCr = getContentResolver();
        Intent intent = getIntent();
        if (intent == null) {
            return false;
        }
        int nType = intent.getIntExtra("type", 0);
        strListName = intent.getStringExtra("list_name");
        strTableName = intent.getStringExtra("table_name");
        if (nType != 4) {
            return false;
        }
        strQuery = "CREATE TABLE IF NOT EXISTS `" + strTableName + "` (" + "`idx` INTEGER PRIMARY KEY AUTOINCREMENT, " + "`number` INTEGER, " + "`display_name` TEXT, " + "`info1` TEXT, " + "`info2` TEXT, " + "`info3` TEXT, " + "`info4` TEXT, " + "`info5` TEXT, " + "`path` TEXT, " + "`size` INTEGER" + ")";
        this.mDBManager = new DatabaseManager(context, "mediadongle.sqlite", 1, strQuery);
        this.mDBManager.open();
        this.mDBManager.execSQL(strQuery);
        tvTitle.setText(strListName);
        this.nType = nType;
        this.strListName = strListName;
        this.strTableName = strTableName;
        return true;
    }

    public boolean onRead() {
        String strQuery = EXTHeader.DEFAULT_VALUE;
        String strDisplayName = EXTHeader.DEFAULT_VALUE;
        String strInfo1 = EXTHeader.DEFAULT_VALUE;
        String strInfo2 = EXTHeader.DEFAULT_VALUE;
        String strInfo3 = EXTHeader.DEFAULT_VALUE;
        String strInfo4 = EXTHeader.DEFAULT_VALUE;
        String strInfo5 = EXTHeader.DEFAULT_VALUE;
        String strPath = EXTHeader.DEFAULT_VALUE;
        this.mCursor = null;
        this.mCursor = this.mDBManager.onSelect("SELECT * FROM `" + this.strTableName + "` ORDER BY `number`");
        if (this.mCursor == null) {
            return false;
        }
        if (this.mCursor.moveToFirst()) {
            int nNumber = 0;
            while (!this.mCursor.isAfterLast()) {
                int nIdx = this.mCursor.getInt(this.mCursor.getColumnIndex("idx"));
                CustomListItem Item = new CustomListItem(nNumber, this.mCursor.getString(this.mCursor.getColumnIndex("display_name")), this.mCursor.getString(this.mCursor.getColumnIndex("info1")), this.mCursor.getString(this.mCursor.getColumnIndex("info2")), this.mCursor.getString(this.mCursor.getColumnIndex("info3")), this.mCursor.getString(this.mCursor.getColumnIndex("info4")), this.mCursor.getString(this.mCursor.getColumnIndex("info5")), this.mCursor.getString(this.mCursor.getColumnIndex("path")), (long) this.mCursor.getInt(this.mCursor.getColumnIndex("size")), EXTHeader.DEFAULT_VALUE);
                Item.setIdx(nIdx);
                this.Items.add(Item);
                this.mCursor.moveToNext();
                nNumber++;
            }
            this.mCursor.close();
            this.mDBManager.onSync(this.strTableName);
            if (this.lvf_txt != null) {
                this.Adapter.notifyDataSetChanged();
                if (this.mlvList.getFooterViewsCount() > 0) {
                    this.mlvList.removeFooterView(this.lvfooter);
                    String strCnt = EXTHeader.DEFAULT_VALUE;
                    this.lvf_txt.setText(String.format("%s %d %s", new Object[]{getResources().getString(C0181R.string.pl_total), Integer.valueOf(this.Items.size()), getResources().getString(C0181R.string.pl_files)}));
                    this.mlvList.addFooterView(this.lvfooter, null, false);
                }
            }
            return true;
        }
        this.mCursor.close();
        return false;
    }

    public static void recursiveRecycle(View root) {
        if (root != null) {
            root.setBackgroundDrawable(null);
            if (root instanceof ViewGroup) {
                ViewGroup group = (ViewGroup) root;
                int count = group.getChildCount();
                for (int i = 0; i < count; i++) {
                    recursiveRecycle(group.getChildAt(i));
                }
                if (!(root instanceof AdapterView)) {
                    group.removeAllViews();
                }
            }
            if (root instanceof ImageView) {
                ((ImageView) root).setImageDrawable(null);
            }
        }
    }

    private void clearApplicationCache(File dir) {
        if (dir == null) {
            dir = getCacheDir();
        }
        if (dir != null) {
            File[] children = dir.listFiles();
            int i = 0;
            while (i < children.length) {
                try {
                    if (children[i].isDirectory()) {
                        clearApplicationCache(children[i]);
                    } else {
                        children[i].delete();
                    }
                    i++;
                } catch (Exception e) {
                    return;
                }
            }
        }
    }
}
