package com.enus.myzik;

import android.annotation.SuppressLint;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.NetworkInfo.State;
import android.net.wifi.SupplicantState;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.util.Log;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;
import org.teleal.cling.model.message.header.EXTHeader;

@SuppressLint({"Instantiatable"})
public class WiFiMonitor4Err extends BroadcastReceiver {
    private static final int STATE_MOBILE_CONNECTED = 2;
    private static final int STATE_NONE = 0;
    private static final int STATE_WIFI_CONNECTED = 1;
    private Context mContext = null;
    private String mstrSSID = EXTHeader.DEFAULT_VALUE;
    private int state = 0;

    public WiFiMonitor4Err(Context context) {
        this.mContext = context;
    }

    public String getLocalIpAddress() {
        try {
            String strIP = EXTHeader.DEFAULT_VALUE;
            Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces();
            while (en.hasMoreElements()) {
                NetworkInterface intf = (NetworkInterface) en.nextElement();
                Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses();
                while (enumIpAddr.hasMoreElements()) {
                    InetAddress inetAddress = (InetAddress) enumIpAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress() && (inetAddress instanceof Inet4Address)) {
                        if (intf.getName().startsWith("eth") || intf.getName().startsWith("wlan")) {
                            strIP = inetAddress.getHostAddress().toString();
                            Log.i("svr", "***** IP1=" + inetAddress.getHostAddress() + " //" + intf.getName());
                            break;
                        }
                    }
                }
            }
            return strIP;
        } catch (Exception ex) {
            Log.e("svr", ex.toString());
            return null;
        }
    }

    private void handleSupplicantStateChanged(SupplicantState state, boolean hasError, int error) {
        if (hasError && error == 1) {
            Log.d("wifierr", "Find!!!");
            if (this.mContext != null && Utils.GetCurrentLanguage().compareTo("한국어") == 0) {
                Intent iset = new Intent("cling.android.Router");
                iset.putExtra("enus", "WIFI_AF");
                this.mContext.sendBroadcast(iset);
            }
        }
    }

    public void onReceive(Context context, Intent intent) {
        try {
            String action = intent.getAction();
            if (action.equals("android.net.conn.CONNECTIVITY_CHANGE")) {
                ConnectivityManager cm = (ConnectivityManager) context.getSystemService("connectivity");
                NetworkInfo niWifi = cm.getNetworkInfo(1);
                NetworkInfo niMobile = cm.getNetworkInfo(0);
                Log.d("CBR", "onReceive:" + Integer.valueOf(this.state).toString());
                Intent iset;
                WifiInfo wifiInfo;
                int ipAddress;
                if (this.state == 0) {
                    if (niWifi.getState() == State.CONNECTED) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_on");
                        this.mContext.sendBroadcast(iset);
                        this.state = 1;
                        Log.d("CBR", "STATE_WIFI_CONNECTED1");
                        wifiInfo = ((WifiManager) context.getSystemService("wifi")).getConnectionInfo();
                        if (wifiInfo != null) {
                            this.mstrSSID = wifiInfo.getSSID();
                            Log.d("CBR", "getSSID:" + wifiInfo.getSSID());
                            ipAddress = wifiInfo.getIpAddress();
                            Log.d("CBR", "IP:" + String.format("%d.%d.%d.%d", new Object[]{Integer.valueOf(ipAddress & 255), Integer.valueOf((ipAddress >> 8) & 255), Integer.valueOf((ipAddress >> 16) & 255), Integer.valueOf((ipAddress >> 24) & 255)}));
                        }
                    } else if (niMobile.getState() == State.CONNECTED) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_off");
                        this.mContext.sendBroadcast(iset);
                        this.state = 2;
                    } else if (niWifi.getState() == State.SUSPENDED) {
                        Log.d("CBR", "STATE_SUSPENDED");
                    } else if (niWifi.getState() == State.CONNECTING) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_off");
                        this.mContext.sendBroadcast(iset);
                        Log.d("CBR", "STATE_CONNECTING");
                    } else if (niWifi.getState() == State.DISCONNECTING) {
                        Log.d("CBR", "STATE_DISCONNECTING");
                    } else if (niWifi.getState() == State.UNKNOWN) {
                        Log.d("CBR", "STATE_UNKNOWN");
                    }
                } else if (this.state == 1) {
                    if (niWifi.getState() == State.DISCONNECTED || niWifi.getState() == State.DISCONNECTING) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_off");
                        this.mContext.sendBroadcast(iset);
                        this.state = 0;
                        Log.d("CBR", "Wi-Fi DISCONNECTED!");
                    } else if (niWifi.getState() == State.CONNECTED) {
                        this.state = 1;
                        Log.d("CBR", "STATE_WIFI_CONNECTED2");
                        wifiInfo = ((WifiManager) context.getSystemService("wifi")).getConnectionInfo();
                        if (wifiInfo != null) {
                            if (this.mstrSSID.compareTo(wifiInfo.getSSID()) != 0) {
                                iset = new Intent("cling.android.Router");
                                iset.putExtra("enus", "wifi_on");
                                this.mContext.sendBroadcast(iset);
                            }
                            this.mstrSSID = wifiInfo.getSSID();
                        }
                        if (wifiInfo != null) {
                            Log.d("CBR", "getSSID:" + wifiInfo.getSSID());
                            ipAddress = wifiInfo.getIpAddress();
                            Log.d("CBR", "IP:" + String.format("%d.%d.%d.%d", new Object[]{Integer.valueOf(ipAddress & 255), Integer.valueOf((ipAddress >> 8) & 255), Integer.valueOf((ipAddress >> 16) & 255), Integer.valueOf((ipAddress >> 24) & 255)}));
                        }
                    } else if (niWifi.getState() == State.SUSPENDED) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_off");
                        this.mContext.sendBroadcast(iset);
                        Log.d("CBR", "STATE_SUSPENDED");
                    } else if (niWifi.getState() == State.CONNECTING) {
                        iset = new Intent("cling.android.Router");
                        iset.putExtra("enus", "wifi_off");
                        this.mContext.sendBroadcast(iset);
                        Log.d("CBR", "STATE_CONNECTING");
                    } else if (niWifi.getState() == State.DISCONNECTING) {
                        Log.d("CBR", "STATE_DISCONNECTING");
                    } else if (niWifi.getState() == State.UNKNOWN) {
                        Log.d("CBR", "STATE_UNKNOWN");
                    }
                } else if (this.state != 2) {
                } else {
                    if (niMobile.getState() == State.DISCONNECTED || niMobile.getState() == State.DISCONNECTING) {
                        this.state = 0;
                        Log.d("CBR", "3G/4G DISCONNECTED!");
                        return;
                    }
                    Log.d("CBR", "STATE_MOBILE_CONNECTED => Mobile:" + niMobile.getState().toString() + " WiFi:" + niWifi.getState().toString());
                }
            } else if (action.equals("android.net.wifi.supplicant.STATE_CHANGE")) {
                handleSupplicantStateChanged((SupplicantState) intent.getParcelableExtra("newState"), intent.hasExtra("supplicantError"), intent.getIntExtra("supplicantError", 0));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
