package com.gc.android.market.api;

import com.gc.android.market.api.MarketSession.Callback;
import com.gc.android.market.api.model.Market.AppsRequest;
import com.gc.android.market.api.model.Market.CommentsRequest;
import com.gc.android.market.api.model.Market.GetImageRequest;
import com.gc.android.market.api.model.Market.GetImageRequest.AppImageUsage;
import com.gc.android.market.api.model.Market.GetImageResponse;
import com.gc.android.market.api.model.Market.ResponseContext;
import com.wireme.mediaserver.ContentTree;
import java.io.FileOutputStream;

public class Main {

    class C04531 implements Callback {
        C04531() {
        }

        public void onResult(ResponseContext context, Object response) {
            System.out.println("Response : " + response);
        }
    }

    class C04542 implements Callback<GetImageResponse> {
        C04542() {
        }

        public void onResult(ResponseContext context, GetImageResponse response) {
            try {
                FileOutputStream fos = new FileOutputStream("icon.png");
                fos.write(response.getImageData().toByteArray());
                fos.close();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }

    public static void main(String[] args) {
        try {
            if (args.length < 2) {
                System.out.println("Usage :\nmarket email password query");
                return;
            }
            String login = args[0];
            String password = args[1];
            String query = args.length > 2 ? args[2] : "Test";
            MarketSession session = new MarketSession();
            System.out.println("Login...");
            session.login(login, password);
            System.out.println("Login done");
            AppsRequest appsRequest = AppsRequest.newBuilder().setQuery(query).setStartIndex(2).setEntriesCount(10).setWithExtendedInfo(true).build();
            CommentsRequest commentsRequest = CommentsRequest.newBuilder().setAppId("7065399193137006744").setStartIndex(0).setEntriesCount(10).build();
            GetImageRequest imgReq = GetImageRequest.newBuilder().setAppId("-7934792861962808905").setImageUsage(AppImageUsage.SCREENSHOT).setImageId(ContentTree.VIDEO_ID).build();
            Callback callback = new C04531();
            session.append(appsRequest, callback);
            session.flush();
            session.append(imgReq, new C04542());
            session.flush();
            session.append(commentsRequest, callback);
            session.flush();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
