package com.wireme.mediaserver;

import android.content.Context;
import android.os.Environment;
import java.io.File;
import java.util.HashMap;
import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.cling.support.model.WriteStatus;
import org.teleal.cling.support.model.container.Container;

public class ContentTree {
    public static final String AUDIO_ID = "2";
    public static final String AUDIO_PREFIX = "audio-item-";
    public static final String IMAGE_ID = "3";
    public static final String IMAGE_PREFIX = "image-item-";
    public static final String ROOT_ID = "0";
    public static final String VIDEO_ID = "1";
    public static final String VIDEO_PREFIX = "video-item-";
    private static HashMap<String, ContentNode> contentMap = new HashMap();
    public static Context mContext = null;
    private static ContentNode rootNode = createRootNode();
    public static String strPLHome = new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().getAbsolutePath())).append(File.separator).append("DownLoad").append(File.separator).toString();
    public static String strUUID = EXTHeader.DEFAULT_VALUE;
    public static Boolean write_flag = Boolean.valueOf(false);

    protected static ContentNode createRootNode() {
        Container root = new Container();
        root.setId(ROOT_ID);
        root.setParentID("-1");
        root.setTitle("GNaP MediaServer root directory");
        root.setCreator("GNaP Media Server");
        root.setRestricted(true);
        root.setSearchable(true);
        root.setWriteStatus(WriteStatus.NOT_WRITABLE);
        root.setChildCount(Integer.valueOf(0));
        ContentNode rootNode = new ContentNode(ROOT_ID, root);
        contentMap.put(ROOT_ID, rootNode);
        return rootNode;
    }

    public static void flush() {
        rootNode = null;
        contentMap.remove(ROOT_ID);
        contentMap.remove(VIDEO_ID);
        contentMap.remove(AUDIO_ID);
        contentMap.remove(IMAGE_ID);
        rootNode = createRootNode();
        write_flag = Boolean.valueOf(false);
        strPLHome = new StringBuilder(String.valueOf(Environment.getExternalStorageDirectory().getAbsolutePath())).append(File.separator).append("DownLoad").append(File.separator).toString();
    }

    public static ContentNode getRootNode() {
        return rootNode;
    }

    public static ContentNode getNode(String id) {
        if (contentMap.containsKey(id)) {
            return (ContentNode) contentMap.get(id);
        }
        return null;
    }

    public static boolean hasNode(String id) {
        return contentMap.containsKey(id);
    }

    public static void addNode(String ID, ContentNode Node) {
        contentMap.put(ID, Node);
    }

    public static void SetPLHome(String strPath) {
        strPLHome = strPath;
    }

    public static void SetUUID(String strpUUID) {
        strUUID = strpUUID;
    }

    public static void SetWriteFlag(Boolean isWriteMode) {
        write_flag = isWriteMode;
    }

    public static Boolean GetWriteFlag() {
        return write_flag;
    }

    public static String GetUUID() {
        return strUUID;
    }

    public static String GetPLHome() {
        return strPLHome;
    }

    public static void SetContext(Context context) {
        mContext = context;
    }

    public static Context GetContext() {
        return mContext;
    }
}
