package org.teleal.cling.binding.staging;

import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import org.teleal.cling.model.ValidationException;
import org.teleal.cling.model.meta.Action;
import org.teleal.cling.model.meta.Device;
import org.teleal.cling.model.meta.Service;
import org.teleal.cling.model.meta.StateVariable;
import org.teleal.cling.model.types.ServiceId;
import org.teleal.cling.model.types.ServiceType;

public class MutableService {
    public List<MutableAction> actions = new ArrayList();
    public URI controlURI;
    public URI descriptorURI;
    public URI eventSubscriptionURI;
    public ServiceId serviceId;
    public ServiceType serviceType;
    public List<MutableStateVariable> stateVariables = new ArrayList();

    public Service build(Device prototype) throws ValidationException {
        return prototype.newInstance(this.serviceType, this.serviceId, this.descriptorURI, this.controlURI, this.eventSubscriptionURI, createActions(), createStateVariables());
    }

    public Action[] createActions() {
        Action[] array = new Action[this.actions.size()];
        int i = 0;
        for (MutableAction action : this.actions) {
            int i2 = i + 1;
            array[i] = action.build();
            i = i2;
        }
        return array;
    }

    public StateVariable[] createStateVariables() {
        StateVariable[] array = new StateVariable[this.stateVariables.size()];
        int i = 0;
        for (MutableStateVariable stateVariable : this.stateVariables) {
            int i2 = i + 1;
            array[i] = stateVariable.build();
            i = i2;
        }
        return array;
    }
}
