package org.teleal.cling.binding.staging;

import java.util.List;
import org.teleal.cling.model.meta.StateVariable;
import org.teleal.cling.model.meta.StateVariableAllowedValueRange;
import org.teleal.cling.model.meta.StateVariableEventDetails;
import org.teleal.cling.model.meta.StateVariableTypeDetails;
import org.teleal.cling.model.types.Datatype;

public class MutableStateVariable {
    public MutableAllowedValueRange allowedValueRange;
    public List<String> allowedValues;
    public Datatype dataType;
    public String defaultValue;
    public StateVariableEventDetails eventDetails;
    public String name;

    public StateVariable build() {
        StateVariableAllowedValueRange stateVariableAllowedValueRange = null;
        String str = this.name;
        Datatype datatype = this.dataType;
        String str2 = this.defaultValue;
        String[] strArr = (this.allowedValues == null || this.allowedValues.size() == 0) ? null : (String[]) this.allowedValues.toArray(new String[this.allowedValues.size()]);
        if (this.allowedValueRange != null) {
            stateVariableAllowedValueRange = new StateVariableAllowedValueRange(this.allowedValueRange.minimum.longValue(), this.allowedValueRange.maximum.longValue(), this.allowedValueRange.step.longValue());
        }
        return new StateVariable(str, new StateVariableTypeDetails(datatype, str2, strArr, stateVariableAllowedValueRange), this.eventDetails);
    }
}
