package org.teleal.cling.model.message;

import java.net.URI;
import java.net.URL;
import org.teleal.cling.model.message.UpnpMessage.BodyType;
import org.teleal.cling.model.message.UpnpRequest.Method;

public class StreamRequestMessage extends UpnpMessage<UpnpRequest> {
    public StreamRequestMessage(StreamRequestMessage source) {
        super((UpnpMessage) source);
    }

    public StreamRequestMessage(UpnpRequest operation) {
        super((UpnpOperation) operation);
    }

    public StreamRequestMessage(Method method, URI uri) {
        super(new UpnpRequest(method, uri));
    }

    public StreamRequestMessage(Method method, URL url) {
        super(new UpnpRequest(method, url));
    }

    public StreamRequestMessage(UpnpRequest operation, String body) {
        super(operation, BodyType.STRING, body);
    }

    public StreamRequestMessage(Method method, URI uri, String body) {
        super(new UpnpRequest(method, uri), BodyType.STRING, body);
    }

    public StreamRequestMessage(Method method, URL url, String body) {
        super(new UpnpRequest(method, url), BodyType.STRING, body);
    }

    public StreamRequestMessage(UpnpRequest operation, byte[] body) {
        super(operation, BodyType.BYTES, body);
    }

    public StreamRequestMessage(Method method, URI uri, byte[] body) {
        super(new UpnpRequest(method, uri), BodyType.BYTES, body);
    }

    public StreamRequestMessage(Method method, URL url, byte[] body) {
        super(new UpnpRequest(method, url), BodyType.BYTES, body);
    }

    public URI getUri() {
        return ((UpnpRequest) getOperation()).getURI();
    }
}
