package org.teleal.cling.model.message.control;

import org.teleal.cling.model.message.StreamResponseMessage;
import org.teleal.cling.model.message.UpnpResponse;
import org.teleal.cling.model.message.UpnpResponse.Status;

public class IncomingActionResponseMessage extends StreamResponseMessage implements ActionResponseMessage {
    public IncomingActionResponseMessage(StreamResponseMessage source) {
        super(source);
    }

    public IncomingActionResponseMessage(UpnpResponse operation) {
        super(operation);
    }

    public String getActionNamespace() {
        return null;
    }

    public boolean isFailedNonRecoverable() {
        int statusCode = ((UpnpResponse) getOperation()).getStatusCode();
        return (!((UpnpResponse) getOperation()).isFailed() || statusCode == Status.METHOD_NOT_SUPPORTED.getStatusCode() || (statusCode == Status.INTERNAL_SERVER_ERROR.getStatusCode() && hasBody())) ? false : true;
    }

    public boolean isFailedRecoverable() {
        return hasBody() && ((UpnpResponse) getOperation()).getStatusCode() == Status.INTERNAL_SERVER_ERROR.getStatusCode();
    }
}
