package org.teleal.cling.model.message.discovery;

import org.teleal.cling.model.message.IncomingDatagramMessage;
import org.teleal.cling.model.message.UpnpRequest;
import org.teleal.cling.model.message.header.MANHeader;
import org.teleal.cling.model.message.header.MXHeader;
import org.teleal.cling.model.message.header.UpnpHeader;
import org.teleal.cling.model.message.header.UpnpHeader.Type;
import org.teleal.cling.model.types.NotificationSubtype;

public class IncomingSearchRequest extends IncomingDatagramMessage<UpnpRequest> {
    public IncomingSearchRequest(IncomingDatagramMessage<UpnpRequest> source) {
        super(source);
    }

    public UpnpHeader getSearchTarget() {
        return getHeaders().getFirstHeader(Type.ST);
    }

    public Integer getMX() {
        MXHeader header = (MXHeader) getHeaders().getFirstHeader(Type.MX, MXHeader.class);
        if (header != null) {
            return (Integer) header.getValue();
        }
        return null;
    }

    public boolean isMANSSDPDiscover() {
        MANHeader header = (MANHeader) getHeaders().getFirstHeader(Type.MAN, MANHeader.class);
        return header != null && ((String) header.getValue()).equals(NotificationSubtype.DISCOVER.getHeaderString());
    }
}
