package org.teleal.cling.model.message.gena;

import java.net.URL;
import java.util.List;
import org.teleal.cling.model.gena.RemoteGENASubscription;
import org.teleal.cling.model.message.StreamRequestMessage;
import org.teleal.cling.model.message.UpnpRequest.Method;
import org.teleal.cling.model.message.header.CallbackHeader;
import org.teleal.cling.model.message.header.NTEventHeader;
import org.teleal.cling.model.message.header.TimeoutHeader;
import org.teleal.cling.model.message.header.UpnpHeader.Type;

public class OutgoingSubscribeRequestMessage extends StreamRequestMessage {
    public OutgoingSubscribeRequestMessage(RemoteGENASubscription subscription, List<URL> callbackURLs) {
        super(Method.SUBSCRIBE, subscription.getEventSubscriptionURL());
        getHeaders().add(Type.CALLBACK, new CallbackHeader((List) callbackURLs));
        getHeaders().add(Type.NT, new NTEventHeader());
        getHeaders().add(Type.TIMEOUT, new TimeoutHeader(subscription.getRequestedDurationSeconds()));
    }

    public boolean hasCallbackURLs() {
        return ((List) ((CallbackHeader) getHeaders().getFirstHeader(Type.CALLBACK, CallbackHeader.class)).getValue()).size() > 0;
    }
}
