package org.teleal.cling.model.message.gena;

import org.teleal.cling.model.gena.LocalGENASubscription;
import org.teleal.cling.model.message.StreamResponseMessage;
import org.teleal.cling.model.message.UpnpResponse;
import org.teleal.cling.model.message.UpnpResponse.Status;
import org.teleal.cling.model.message.header.ServerHeader;
import org.teleal.cling.model.message.header.SubscriptionIdHeader;
import org.teleal.cling.model.message.header.TimeoutHeader;
import org.teleal.cling.model.message.header.UpnpHeader.Type;

public class OutgoingSubscribeResponseMessage extends StreamResponseMessage {
    public OutgoingSubscribeResponseMessage(Status status) {
        super(status);
    }

    public OutgoingSubscribeResponseMessage(LocalGENASubscription subscription) {
        super(new UpnpResponse(Status.OK));
        getHeaders().add(Type.SERVER, new ServerHeader());
        getHeaders().add(Type.SID, new SubscriptionIdHeader(subscription.getSubscriptionId()));
        getHeaders().add(Type.TIMEOUT, new TimeoutHeader(subscription.getActualDurationSeconds()));
    }
}
