package org.teleal.cling.model.message.header;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class CallbackHeader extends UpnpHeader<List<URL>> {
    public CallbackHeader() {
        setValue(new ArrayList());
    }

    public CallbackHeader(List<URL> urls) {
        this();
        ((List) getValue()).addAll(urls);
    }

    public CallbackHeader(URL url) {
        this();
        ((List) getValue()).add(url);
    }

    public void setString(String s) throws InvalidHeaderException {
        if (s.length() != 0) {
            if (s.contains("<") && s.contains(">")) {
                s = s.replaceAll("<", EXTHeader.DEFAULT_VALUE);
                String[] split = s.split(">");
                try {
                    List<URL> urls = new ArrayList();
                    String[] arr$ = split;
                    int len$ = arr$.length;
                    int i$ = 0;
                    while (i$ < len$) {
                        String sp = arr$[i$].trim();
                        if (sp.startsWith("http://")) {
                            urls.add(new URL(sp));
                            i$++;
                        } else {
                            throw new InvalidHeaderException("Can't parse non-http callback URL: " + sp);
                        }
                    }
                    setValue(urls);
                    return;
                } catch (MalformedURLException ex) {
                    throw new InvalidHeaderException("Can't parse callback URLs from '" + s + "': " + ex);
                }
            }
            throw new InvalidHeaderException("URLs not in brackets: " + s);
        }
    }

    public String getString() {
        StringBuilder s = new StringBuilder();
        for (URL url : (List) getValue()) {
            s.append("<").append(url.toString()).append(">");
        }
        return s.toString();
    }
}
