package org.teleal.cling.model.message.header;

import com.wireme.mediaserver.HttpServer;
import org.teleal.common.util.MimeType;

public class ContentTypeHeader extends UpnpHeader<MimeType> {
    public static final MimeType DEFAULT_CONTENT_TYPE = MimeType.valueOf(HttpServer.MIME_XML);
    public static final MimeType DEFAULT_CONTENT_TYPE_UTF8 = MimeType.valueOf("text/xml;charset=\"utf-8\"");

    public ContentTypeHeader() {
        setValue(DEFAULT_CONTENT_TYPE);
    }

    public ContentTypeHeader(MimeType contentType) {
        setValue(contentType);
    }

    public ContentTypeHeader(String s) throws InvalidHeaderException {
        setString(s);
    }

    public void setString(String s) throws InvalidHeaderException {
        setValue(MimeType.valueOf(s));
    }

    public String getString() {
        return ((MimeType) getValue()).toString();
    }

    public boolean isUDACompliantXML() {
        return isText() && ((MimeType) getValue()).getSubtype().equals(DEFAULT_CONTENT_TYPE.getSubtype());
    }

    public boolean isText() {
        return getValue() != null && ((MimeType) getValue()).getType().equals(DEFAULT_CONTENT_TYPE.getType());
    }
}
