package org.teleal.cling.model.message.header;

import com.wireme.mediaserver.ContentTree;
import org.teleal.cling.model.types.UnsignedIntegerFourBytes;

public class EventSequenceHeader extends UpnpHeader<UnsignedIntegerFourBytes> {
    public EventSequenceHeader(long value) {
        setValue(new UnsignedIntegerFourBytes(value));
    }

    public void setString(String s) throws InvalidHeaderException {
        if (!ContentTree.ROOT_ID.equals(s)) {
            while (s.startsWith(ContentTree.ROOT_ID)) {
                s = s.substring(1);
            }
        }
        try {
            setValue(new UnsignedIntegerFourBytes(s));
        } catch (NumberFormatException ex) {
            throw new InvalidHeaderException("Invalid event sequence, " + ex.getMessage());
        }
    }

    public String getString() {
        return ((UnsignedIntegerFourBytes) getValue()).toString();
    }
}
