package org.teleal.cling.model.message.header;

import org.teleal.cling.model.Constants;
import org.teleal.cling.model.types.HostPort;

public class HostHeader extends UpnpHeader<HostPort> {
    String group = Constants.IPV4_UPNP_MULTICAST_GROUP;
    int port = Constants.UPNP_MULTICAST_PORT;

    public HostHeader() {
        setValue(new HostPort(this.group, this.port));
    }

    public HostHeader(int port) {
        setValue(new HostPort(this.group, port));
    }

    public HostHeader(String host, int port) {
        setValue(new HostPort(host, port));
    }

    public void setString(String s) throws InvalidHeaderException {
        if (s.contains(":")) {
            try {
                this.port = Integer.valueOf(s.substring(s.indexOf(":") + 1)).intValue();
                this.group = s.substring(0, s.indexOf(":"));
                setValue(new HostPort(this.group, this.port));
                return;
            } catch (NumberFormatException ex) {
                throw new InvalidHeaderException("Invalid HOST header value, can't parse port: " + s + " - " + ex.getMessage());
            }
        }
        this.group = s;
        setValue(new HostPort(this.group, this.port));
    }

    public String getString() {
        return ((HostPort) getValue()).toString();
    }
}
