package org.teleal.cling.model.message.header;

import org.teleal.common.util.HexBin;

public class InterfaceMacHeader extends UpnpHeader<byte[]> {
    public InterfaceMacHeader(byte[] value) {
        setValue(value);
    }

    public InterfaceMacHeader(String s) {
        setString(s);
    }

    public void setString(String s) throws InvalidHeaderException {
        byte[] bytes = HexBin.stringToBytes(s, ":");
        setValue(bytes);
        if (bytes.length != 6) {
            throw new InvalidHeaderException("Invalid MAC address: " + s);
        }
    }

    public String getString() {
        return HexBin.bytesToString((byte[]) getValue(), ":");
    }

    public String toString() {
        return "(" + getClass().getSimpleName() + ") '" + getString() + "'";
    }
}
