package org.teleal.cling.model.message.header;

import java.net.MalformedURLException;
import java.net.URL;

public class LocationHeader extends UpnpHeader<URL> {
    public LocationHeader(URL value) {
        setValue(value);
    }

    public LocationHeader(String s) {
        setString(s);
    }

    public void setString(String s) throws InvalidHeaderException {
        try {
            setValue(new URL(s));
        } catch (MalformedURLException ex) {
            throw new InvalidHeaderException("Invalid URI: " + ex.getMessage());
        }
    }

    public String getString() {
        return ((URL) getValue()).toString();
    }
}
