package org.teleal.cling.model.message.header;

public class MXHeader extends UpnpHeader<Integer> {
    public static final Integer DEFAULT_VALUE = Integer.valueOf(3);

    public MXHeader() {
        setValue(DEFAULT_VALUE);
    }

    public MXHeader(Integer delayInSeconds) {
        setValue(delayInSeconds);
    }

    public void setString(String s) throws InvalidHeaderException {
        try {
            Integer value = Integer.valueOf(Integer.parseInt(s));
            if (value.intValue() < 0 || value.intValue() > 120) {
                setValue(DEFAULT_VALUE);
            } else {
                setValue(value);
            }
        } catch (Exception e) {
            throw new InvalidHeaderException("Can't parse MX seconds integer from: " + s);
        }
    }

    public String getString() {
        return ((Integer) getValue()).toString();
    }
}
