package org.teleal.cling.model.message.header;

import org.teleal.cling.model.types.NotificationSubtype;

public class NTSHeader extends UpnpHeader<NotificationSubtype> {
    public NTSHeader(NotificationSubtype type) {
        setValue(type);
    }

    public void setString(String s) throws InvalidHeaderException {
        for (NotificationSubtype type : NotificationSubtype.values()) {
            if (s.equals(type.getHeaderString())) {
                setValue(type);
                break;
            }
        }
        if (getValue() == null) {
            throw new InvalidHeaderException("Invalid NTS header value: " + s);
        }
    }

    public String getString() {
        return ((NotificationSubtype) getValue()).getHeaderString();
    }
}
