package org.teleal.cling.model.message.header;

import java.net.URI;
import org.teleal.cling.model.types.ServiceType;

public class ServiceTypeHeader extends UpnpHeader<ServiceType> {
    public ServiceTypeHeader(URI uri) {
        setString(uri.toString());
    }

    public ServiceTypeHeader(ServiceType value) {
        setValue(value);
    }

    public void setString(String s) throws InvalidHeaderException {
        try {
            setValue(ServiceType.valueOf(s));
        } catch (RuntimeException ex) {
            throw new InvalidHeaderException("Invalid service type header value, " + ex.getMessage());
        }
    }

    public String getString() {
        return ((ServiceType) getValue()).toString();
    }
}
