package org.teleal.cling.model.message.header;

import java.net.URI;
import org.teleal.cling.model.types.SoapActionType;

public class SoapActionHeader extends UpnpHeader<SoapActionType> {
    public SoapActionHeader(URI uri) {
        setValue(SoapActionType.valueOf(uri.toString()));
    }

    public SoapActionHeader(SoapActionType value) {
        setValue(value);
    }

    public SoapActionHeader(String s) throws InvalidHeaderException {
        setString(s);
    }

    public void setString(String s) throws InvalidHeaderException {
        try {
            if (s.startsWith("\"") || !s.endsWith("\"")) {
                setValue(SoapActionType.valueOf(s.substring(1, s.length() - 1)));
                return;
            }
            throw new InvalidHeaderException("Invalid SOAP action header, must be enclosed in doublequotes:" + s);
        } catch (RuntimeException ex) {
            throw new InvalidHeaderException("Invalid SOAP action header value, " + ex.getMessage());
        }
    }

    public String getString() {
        return "\"" + ((SoapActionType) getValue()).toString() + "\"";
    }
}
