package org.teleal.cling.model.message.header;

public class SubscriptionIdHeader extends UpnpHeader<String> {
    public static final String PREFIX = "uuid:";

    public SubscriptionIdHeader(String value) {
        setValue(value);
    }

    public void setString(String s) throws InvalidHeaderException {
        if (s.startsWith("uuid:")) {
            setValue(s);
            return;
        }
        throw new InvalidHeaderException("Invalid subscription ID header value, must start with 'uuid:': " + s);
    }

    public String getString() {
        return (String) getValue();
    }
}
