package org.teleal.cling.model.message.header;

import org.teleal.cling.model.types.UDN;

public class UDNHeader extends UpnpHeader<UDN> {
    public UDNHeader(UDN udn) {
        setValue(udn);
    }

    public void setString(String s) throws InvalidHeaderException {
        if (!s.startsWith("uuid:")) {
            throw new InvalidHeaderException("Invalid UDA header value, must start with 'uuid:': " + s);
        } else if (s.contains("::urn")) {
            throw new InvalidHeaderException("Invalid UDA header value, must not contain '::urn': " + s);
        } else {
            setValue(new UDN(s.substring("uuid:".length())));
        }
    }

    public String getString() {
        return ((UDN) getValue()).toString();
    }
}
