package org.teleal.cling.model.message.header;

import org.teleal.cling.model.types.UDN;

public class USNRootDeviceHeader extends UpnpHeader<UDN> {
    public static final String ROOT_DEVICE_SUFFIX = "::upnp:rootdevice";

    public USNRootDeviceHeader(UDN udn) {
        setValue(udn);
    }

    public void setString(String s) throws InvalidHeaderException {
        if (s.startsWith("uuid:") && s.endsWith(ROOT_DEVICE_SUFFIX)) {
            setValue(new UDN(s.substring("uuid:".length(), s.length() - ROOT_DEVICE_SUFFIX.length())));
            return;
        }
        throw new InvalidHeaderException("Invalid root device USN header value, must start with 'uuid:' and end with '::upnp:rootdevice' but is '" + s + "'");
    }

    public String getString() {
        return ((UDN) getValue()).toString() + ROOT_DEVICE_SUFFIX;
    }
}
