package org.teleal.cling.model.meta;

import java.util.Collections;
import java.util.List;
import org.teleal.cling.model.ValidationError;
import org.teleal.cling.model.meta.ActionArgument.Direction;

public class QueryStateVariableAction<S extends Service> extends Action<S> {
    public static final String ACTION_NAME = "QueryStateVariable";
    public static final String VIRTUAL_STATEVARIABLE_INPUT = "VirtualQueryActionInput";
    public static final String VIRTUAL_STATEVARIABLE_OUTPUT = "VirtualQueryActionOutput";

    public QueryStateVariableAction() {
        this(null);
    }

    public QueryStateVariableAction(S service) {
        super(ACTION_NAME, new ActionArgument[]{new ActionArgument("varName", VIRTUAL_STATEVARIABLE_INPUT, Direction.IN), new ActionArgument("return", VIRTUAL_STATEVARIABLE_OUTPUT, Direction.OUT)});
        setService(service);
    }

    public String getName() {
        return ACTION_NAME;
    }

    public List<ValidationError> validate() {
        return Collections.EMPTY_LIST;
    }
}
