package org.teleal.cling.model.state;

import org.teleal.cling.model.Command;
import org.teleal.cling.model.ServiceManager;
import org.teleal.cling.model.meta.LocalService;
import org.teleal.cling.model.meta.StateVariable;

public abstract class StateVariableAccessor {
    public abstract Class<?> getReturnType();

    public abstract Object read(Object obj) throws Exception;

    public StateVariableValue read(final StateVariable<LocalService> stateVariable, final Object serviceImpl) throws Exception {
        AnonymousClass1AccessCommand cmd = new Command() {
            Object result;

            public void execute(ServiceManager serviceManager) throws Exception {
                this.result = StateVariableAccessor.this.read(serviceImpl);
                if (((LocalService) stateVariable.getService()).isStringConvertibleType(this.result)) {
                    this.result = this.result.toString();
                }
            }
        };
        ((LocalService) stateVariable.getService()).getManager().execute(cmd);
        return new StateVariableValue(stateVariable, cmd.result);
    }

    public String toString() {
        return "(" + getClass().getSimpleName() + ")";
    }
}
