package org.teleal.cling.model.types;

import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.common.util.Base64Coder;
import org.teleal.common.util.ByteArray;

public class Base64Datatype extends AbstractDatatype<Byte[]> {
    public Class<Byte[]> getValueType() {
        return Byte[].class;
    }

    public Byte[] valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            return ByteArray.toWrapper(Base64Coder.decode(s));
        } catch (Exception ex) {
            throw new InvalidValueException(ex.getMessage(), ex);
        }
    }

    public String getString(Byte[] value) throws InvalidValueException {
        if (value == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return new String(Base64Coder.encode(ByteArray.toPrimitive(value)));
        } catch (Exception ex) {
            throw new InvalidValueException(ex.getMessage(), ex);
        }
    }
}
