package org.teleal.cling.model.types;

import org.teleal.cling.model.message.header.EXTHeader;
import org.teleal.common.util.ByteArray;
import org.teleal.common.util.HexBin;

public class BinHexDatatype extends AbstractDatatype<Byte[]> {
    public Class<Byte[]> getValueType() {
        return Byte[].class;
    }

    public Byte[] valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            return ByteArray.toWrapper(HexBin.stringToBytes(s));
        } catch (Exception ex) {
            throw new InvalidValueException(ex.getMessage(), ex);
        }
    }

    public String getString(Byte[] value) throws InvalidValueException {
        if (value == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        try {
            return HexBin.bytesToString(ByteArray.toPrimitive(value));
        } catch (Exception ex) {
            throw new InvalidValueException(ex.getMessage(), ex);
        }
    }
}
