package org.teleal.cling.model.types;

import com.wireme.mediaserver.ContentTree;
import org.teleal.cling.model.message.header.EXTHeader;

public class BooleanDatatype extends AbstractDatatype<Boolean> {
    public boolean isHandlingJavaType(Class type) {
        return type == Boolean.TYPE || Boolean.class.isAssignableFrom(type);
    }

    public Boolean valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        if (s.equals(ContentTree.VIDEO_ID) || s.toUpperCase().equals("YES") || s.toUpperCase().equals("TRUE")) {
            return Boolean.valueOf(true);
        }
        if (s.equals(ContentTree.ROOT_ID) || s.toUpperCase().equals("NO") || s.toUpperCase().equals("FALSE")) {
            return Boolean.valueOf(false);
        }
        throw new InvalidValueException("Invalid boolean value string: " + s);
    }

    public String getString(Boolean value) throws InvalidValueException {
        if (value == null) {
            return EXTHeader.DEFAULT_VALUE;
        }
        return value.booleanValue() ? ContentTree.VIDEO_ID : ContentTree.ROOT_ID;
    }
}
