package org.teleal.cling.model.types;

import org.teleal.cling.model.message.header.EXTHeader;

public class DoubleDatatype extends AbstractDatatype<Double> {
    public boolean isHandlingJavaType(Class type) {
        return type == Double.TYPE || Double.class.isAssignableFrom(type);
    }

    public Double valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            return Double.valueOf(Double.parseDouble(s));
        } catch (NumberFormatException ex) {
            throw new InvalidValueException("Can't convert string to number: " + s, ex);
        }
    }
}
