package org.teleal.cling.model.types;

import org.teleal.cling.model.message.header.EXTHeader;

public class FloatDatatype extends AbstractDatatype<Float> {
    public boolean isHandlingJavaType(Class type) {
        return type == Float.TYPE || Float.class.isAssignableFrom(type);
    }

    public Float valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            return Float.valueOf(Float.parseFloat(s));
        } catch (NumberFormatException ex) {
            throw new InvalidValueException("Can't convert string to number: " + s, ex);
        }
    }
}
