package org.teleal.cling.model.types;

import org.teleal.cling.model.message.header.EXTHeader;

public class ShortDatatype extends AbstractDatatype<Short> {
    public boolean isHandlingJavaType(Class type) {
        return type == Short.TYPE || Short.class.isAssignableFrom(type);
    }

    public Short valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            Short value = Short.valueOf(Short.parseShort(s));
            if (isValid(value)) {
                return value;
            }
            throw new InvalidValueException("Not a valid short: " + s);
        } catch (NumberFormatException ex) {
            throw new InvalidValueException("Can't convert string to number: " + s, ex);
        }
    }
}
