package org.teleal.cling.model.types;

import java.net.URI;
import java.net.URISyntaxException;
import org.teleal.cling.model.message.header.EXTHeader;

public class URIDatatype extends AbstractDatatype<URI> {
    public URI valueOf(String s) throws InvalidValueException {
        if (s.equals(EXTHeader.DEFAULT_VALUE)) {
            return null;
        }
        try {
            return new URI(s);
        } catch (URISyntaxException ex) {
            throw new InvalidValueException(ex.getMessage(), ex);
        }
    }
}
