package org.teleal.cling.registry;

import org.teleal.cling.model.ExpirationDetails;

class RegistryItem<K, I> {
    private ExpirationDetails expirationDetails = new ExpirationDetails();
    private I item;
    private K key;

    RegistryItem(K key) {
        this.key = key;
    }

    RegistryItem(K key, I item, int maxAgeSeconds) {
        this.key = key;
        this.item = item;
        this.expirationDetails = new ExpirationDetails(maxAgeSeconds);
    }

    public K getKey() {
        return this.key;
    }

    public I getItem() {
        return this.item;
    }

    public ExpirationDetails getExpirationDetails() {
        return this.expirationDetails;
    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        return this.key.equals(((RegistryItem) o).key);
    }

    public int hashCode() {
        return this.key.hashCode();
    }

    public String toString() {
        return "(" + getClass().getSimpleName() + ") " + getExpirationDetails() + " KEY: " + getKey() + " ITEM: " + getItem();
    }
}
