package org.teleal.cling.support.avtransport.impl.state;

import java.net.URI;
import java.util.logging.Logger;
import org.teleal.cling.support.avtransport.lastchange.AVTransportVariable;
import org.teleal.cling.support.avtransport.lastchange.AVTransportVariable.CurrentTransportActions;
import org.teleal.cling.support.model.AVTransport;
import org.teleal.cling.support.model.TransportAction;
import org.teleal.cling.support.model.TransportInfo;
import org.teleal.cling.support.model.TransportState;

public abstract class PausedPlay<T extends AVTransport> extends AbstractState {
    private static final Logger log = Logger.getLogger(PausedPlay.class.getName());

    public abstract Class<? extends AbstractState> play(String str);

    public abstract Class<? extends AbstractState> setTransportURI(URI uri, String str);

    public abstract Class<? extends AbstractState> stop();

    public PausedPlay(T transport) {
        super(transport);
    }

    public void onEntry() {
        log.fine("Setting transport state to PAUSED_PLAYBACK");
        getTransport().setTransportInfo(new TransportInfo(TransportState.PAUSED_PLAYBACK, getTransport().getTransportInfo().getCurrentTransportStatus(), getTransport().getTransportInfo().getCurrentSpeed()));
        getTransport().getLastChange().setEventedValue(getTransport().getInstanceId(), new AVTransportVariable.TransportState(TransportState.PAUSED_PLAYBACK), new CurrentTransportActions(getCurrentTransportActions()));
    }

    public TransportAction[] getCurrentTransportActions() {
        return new TransportAction[]{TransportAction.Stop, TransportAction.Play};
    }
}
