package org.teleal.cling.support.connectionmanager.callback;

import org.teleal.cling.controlpoint.ActionCallback;
import org.teleal.cling.controlpoint.ControlPoint;
import org.teleal.cling.model.action.ActionArgumentValue;
import org.teleal.cling.model.action.ActionException;
import org.teleal.cling.model.action.ActionInvocation;
import org.teleal.cling.model.meta.Service;
import org.teleal.cling.model.types.ErrorCode;
import org.teleal.cling.support.model.ProtocolInfos;

public abstract class GetProtocolInfo extends ActionCallback {
    public abstract void received(ActionInvocation actionInvocation, ProtocolInfos protocolInfos, ProtocolInfos protocolInfos2);

    public GetProtocolInfo(Service service) {
        this(service, null);
    }

    protected GetProtocolInfo(Service service, ControlPoint controlPoint) {
        super(new ActionInvocation(service.getAction("GetProtocolInfo")), controlPoint);
    }

    public void success(ActionInvocation invocation) {
        try {
            ProtocolInfos protocolInfos;
            ProtocolInfos protocolInfos2;
            ActionArgumentValue sink = invocation.getOutput("Sink");
            ActionArgumentValue source = invocation.getOutput("Source");
            if (sink != null) {
                protocolInfos = new ProtocolInfos(sink.toString());
            } else {
                protocolInfos = null;
            }
            if (source != null) {
                protocolInfos2 = new ProtocolInfos(source.toString());
            } else {
                protocolInfos2 = null;
            }
            received(invocation, protocolInfos, protocolInfos2);
        } catch (Throwable ex) {
            invocation.setFailure(new ActionException(ErrorCode.ACTION_FAILED, "Can't parse ProtocolInfo response: " + ex, ex));
            failure(invocation, null);
        }
    }
}
