package org.teleal.cling.support.lastchange;

import java.util.Map.Entry;
import org.teleal.cling.model.types.Datatype;
import org.teleal.cling.model.types.InvalidValueException;
import org.teleal.cling.support.shared.AbstractMap.SimpleEntry;

public abstract class EventedValue<V> {
    protected final V value;

    protected abstract Datatype getDatatype();

    public EventedValue(V value) {
        this.value = value;
    }

    public EventedValue(Entry<String, String>[] attributes) {
        try {
            this.value = valueOf((Entry[]) attributes);
        } catch (InvalidValueException ex) {
            throw new RuntimeException(ex);
        }
    }

    public String getName() {
        return getClass().getSimpleName();
    }

    public V getValue() {
        return this.value;
    }

    public Entry<String, String>[] getAttributes() {
        return new Entry[]{new SimpleEntry("val", toString())};
    }

    protected V valueOf(Entry<String, String>[] attributes) throws InvalidValueException {
        V v = null;
        for (Entry<String, String> attribute : attributes) {
            if (((String) attribute.getKey()).equals("val")) {
                v = valueOf((String) attribute.getValue());
            }
        }
        return v;
    }

    protected V valueOf(String s) throws InvalidValueException {
        return getDatatype().valueOf(s);
    }

    public String toString() {
        return getDatatype().getString(getValue());
    }
}
