package org.teleal.cling.support.lastchange;

import java.util.Map.Entry;
import org.teleal.cling.model.types.Datatype;
import org.teleal.cling.model.types.InvalidValueException;

public abstract class EventedValueEnum<E extends Enum> extends EventedValue<E> {
    protected abstract E enumValueOf(String str);

    public EventedValueEnum(E e) {
        super((Object) e);
    }

    public EventedValueEnum(Entry<String, String>[] attributes) {
        super((Entry[]) attributes);
    }

    protected E valueOf(String s) throws InvalidValueException {
        return enumValueOf(s);
    }

    public String toString() {
        return ((Enum) getValue()).name();
    }

    protected Datatype getDatatype() {
        return null;
    }
}
