package org.teleal.cling.support.lastchange;

import java.util.Map.Entry;
import org.teleal.cling.model.ModelUtil;
import org.teleal.cling.model.types.Datatype;
import org.teleal.cling.model.types.InvalidValueException;

public abstract class EventedValueEnumArray<E extends Enum> extends EventedValue<E[]> {
    protected abstract E[] enumValueOf(String[] strArr);

    public EventedValueEnumArray(E[] e) {
        super((Object) e);
    }

    public EventedValueEnumArray(Entry<String, String>[] attributes) {
        super((Entry[]) attributes);
    }

    protected E[] valueOf(String s) throws InvalidValueException {
        return enumValueOf(ModelUtil.fromCommaSeparatedList(s));
    }

    public String toString() {
        return ModelUtil.toCommaSeparatedList((Object[]) getValue());
    }

    protected Datatype getDatatype() {
        return null;
    }
}
