package org.teleal.cling.support.lastchange;

import java.net.URI;
import java.util.Map.Entry;
import java.util.logging.Logger;
import org.teleal.cling.model.types.Datatype;
import org.teleal.cling.model.types.Datatype.Builtin;
import org.teleal.cling.model.types.InvalidValueException;
import org.teleal.common.util.Exceptions;

public class EventedValueURI extends EventedValue<URI> {
    private static final Logger log = Logger.getLogger(EventedValueURI.class.getName());

    public EventedValueURI(URI value) {
        super((Object) value);
    }

    public EventedValueURI(Entry<String, String>[] attributes) {
        super((Entry[]) attributes);
    }

    protected URI valueOf(String s) throws InvalidValueException {
        try {
            return (URI) super.valueOf(s);
        } catch (InvalidValueException ex) {
            log.info("Ignoring invalid URI in evented value '" + s + "': " + Exceptions.unwrap(ex));
            return null;
        }
    }

    protected Datatype getDatatype() {
        return Builtin.URI.getDatatype();
    }
}
