package org.teleal.cling.support.model.container;

import org.teleal.cling.support.model.DIDLObject.Class;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.STORAGE_USED;

public class StorageFolder extends Container {
    public static final Class CLASS = new Class("object.container.storageFolder");

    public StorageFolder() {
        setClazz(CLASS);
    }

    public StorageFolder(Container other) {
        super(other);
    }

    public StorageFolder(String id, Container parent, String title, String creator, Integer childCount, Long storageUsed) {
        this(id, parent.getId(), title, creator, childCount, storageUsed);
    }

    public StorageFolder(String id, String parentID, String title, String creator, Integer childCount, Long storageUsed) {
        super(id, parentID, title, creator, CLASS, childCount);
        if (storageUsed != null) {
            setStorageUsed(storageUsed);
        }
    }

    public Long getStorageUsed() {
        return (Long) getFirstPropertyValue(STORAGE_USED.class);
    }

    public StorageFolder setStorageUsed(Long l) {
        replaceFirstProperty(new STORAGE_USED(l));
        return this;
    }
}
