package org.teleal.cling.support.model.item;

import org.teleal.cling.support.model.DIDLObject.Class;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.CHANNEL_NR;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.RADIO_BAND;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.RADIO_CALL_SIGN;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.RADIO_STATION_ID;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.REGION;
import org.teleal.cling.support.model.Res;

public class AudioBroadcast extends AudioItem {
    public static final Class CLASS = new Class("object.item.audioItem.audioBroadcast");

    public AudioBroadcast() {
        setClazz(CLASS);
    }

    public AudioBroadcast(Item other) {
        super(other);
    }

    public AudioBroadcast(String id, String parentID, String title, String creator, Res... resource) {
        super(id, parentID, title, creator, resource);
        setClazz(CLASS);
    }

    public String getRegion() {
        return (String) getFirstPropertyValue(REGION.class);
    }

    public AudioBroadcast setRegion(String region) {
        replaceFirstProperty(new REGION(region));
        return this;
    }

    public String getRadioCallSign() {
        return (String) getFirstPropertyValue(RADIO_CALL_SIGN.class);
    }

    public AudioBroadcast setRadioCallSign(String radioCallSign) {
        replaceFirstProperty(new RADIO_CALL_SIGN(radioCallSign));
        return this;
    }

    public String getRadioStationID() {
        return (String) getFirstPropertyValue(RADIO_STATION_ID.class);
    }

    public AudioBroadcast setRadioStationID(String radioStationID) {
        replaceFirstProperty(new RADIO_STATION_ID(radioStationID));
        return this;
    }

    public String getRadioBand() {
        return (String) getFirstPropertyValue(RADIO_BAND.class);
    }

    public AudioBroadcast setRadioBand(String radioBand) {
        replaceFirstProperty(new RADIO_BAND(radioBand));
        return this;
    }

    public Integer getChannelNr() {
        return (Integer) getFirstPropertyValue(CHANNEL_NR.class);
    }

    public AudioBroadcast setChannelNr(Integer channelNr) {
        replaceFirstProperty(new CHANNEL_NR(channelNr));
        return this;
    }
}
