package org.teleal.cling.support.model.item;

import java.util.List;
import org.teleal.cling.support.model.DIDLObject.Class;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.CHANNEL_NAME;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.DVD_REGION_CODE;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.SCHEDULED_END_TIME;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.SCHEDULED_START_TIME;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.STORAGE_MEDIUM;
import org.teleal.cling.support.model.Res;
import org.teleal.cling.support.model.StorageMedium;
import org.teleal.cling.support.model.container.Container;

public class Movie extends VideoItem {
    public static final Class CLASS = new Class("object.item.videoItem.movie");

    public Movie() {
        setClazz(CLASS);
    }

    public Movie(Item other) {
        super(other);
    }

    public Movie(String id, Container parent, String title, String creator, Res... resource) {
        this(id, parent.getId(), title, creator, resource);
    }

    public Movie(String id, String parentID, String title, String creator, Res... resource) {
        super(id, parentID, title, creator, resource);
        setClazz(CLASS);
    }

    public StorageMedium getStorageMedium() {
        return (StorageMedium) getFirstPropertyValue(STORAGE_MEDIUM.class);
    }

    public Movie setStorageMedium(StorageMedium storageMedium) {
        replaceFirstProperty(new STORAGE_MEDIUM(storageMedium));
        return this;
    }

    public Integer getDVDRegionCode() {
        return (Integer) getFirstPropertyValue(DVD_REGION_CODE.class);
    }

    public Movie setDVDRegionCode(Integer DVDRegionCode) {
        replaceFirstProperty(new DVD_REGION_CODE(DVDRegionCode));
        return this;
    }

    public String getChannelName() {
        return (String) getFirstPropertyValue(CHANNEL_NAME.class);
    }

    public Movie setChannelName(String channelName) {
        replaceFirstProperty(new CHANNEL_NAME(channelName));
        return this;
    }

    public String getFirstScheduledStartTime() {
        return (String) getFirstPropertyValue(SCHEDULED_START_TIME.class);
    }

    public String[] getScheduledStartTimes() {
        List<String> list = getPropertyValues(SCHEDULED_START_TIME.class);
        return (String[]) list.toArray(new String[list.size()]);
    }

    public Movie setScheduledStartTimes(String[] strings) {
        removeProperties(SCHEDULED_START_TIME.class);
        for (String s : strings) {
            addProperty(new SCHEDULED_START_TIME(s));
        }
        return this;
    }

    public String getFirstScheduledEndTime() {
        return (String) getFirstPropertyValue(SCHEDULED_END_TIME.class);
    }

    public String[] getScheduledEndTimes() {
        List<String> list = getPropertyValues(SCHEDULED_END_TIME.class);
        return (String[]) list.toArray(new String[list.size()]);
    }

    public Movie setScheduledEndTimes(String[] strings) {
        removeProperties(SCHEDULED_END_TIME.class);
        for (String s : strings) {
            addProperty(new SCHEDULED_END_TIME(s));
        }
        return this;
    }
}
