package org.teleal.cling.support.model.item;

import org.teleal.cling.support.model.DIDLObject.Class;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.ALBUM;
import org.teleal.cling.support.model.Res;
import org.teleal.cling.support.model.container.Container;

public class Photo extends ImageItem {
    public static final Class CLASS = new Class("object.item.imageItem.photo");

    public Photo() {
        setClazz(CLASS);
    }

    public Photo(Item other) {
        super(other);
    }

    public Photo(String id, Container parent, String title, String creator, String album, Res... resource) {
        this(id, parent.getId(), title, creator, album, resource);
    }

    public Photo(String id, String parentID, String title, String creator, String album, Res... resource) {
        super(id, parentID, title, creator, resource);
        setClazz(CLASS);
        if (album != null) {
            setAlbum(album);
        }
    }

    public String getAlbum() {
        return (String) getFirstPropertyValue(ALBUM.class);
    }

    public Photo setAlbum(String album) {
        replaceFirstProperty(new ALBUM(album));
        return this;
    }
}
