package org.teleal.cling.support.model.item;

import java.net.URI;
import org.teleal.cling.support.model.DIDLObject.Class;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.CHANNEL_NR;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.ICON;
import org.teleal.cling.support.model.DIDLObject.Property.UPNP.REGION;
import org.teleal.cling.support.model.Res;
import org.teleal.cling.support.model.container.Container;

public class VideoBroadcast extends VideoItem {
    public static final Class CLASS = new Class("object.item.videoItem.videoBroadcast");

    public VideoBroadcast() {
        setClazz(CLASS);
    }

    public VideoBroadcast(Item other) {
        super(other);
    }

    public VideoBroadcast(String id, Container parent, String title, String creator, Res... resource) {
        this(id, parent.getId(), title, creator, resource);
    }

    public VideoBroadcast(String id, String parentID, String title, String creator, Res... resource) {
        super(id, parentID, title, creator, resource);
        setClazz(CLASS);
    }

    public URI getIcon() {
        return (URI) getFirstPropertyValue(ICON.class);
    }

    public VideoBroadcast setIcon(URI icon) {
        replaceFirstProperty(new ICON(icon));
        return this;
    }

    public String getRegion() {
        return (String) getFirstPropertyValue(REGION.class);
    }

    public VideoBroadcast setRegion(String region) {
        replaceFirstProperty(new REGION(region));
        return this;
    }

    public Integer getChannelNr() {
        return (Integer) getFirstPropertyValue(CHANNEL_NR.class);
    }

    public VideoBroadcast setChannelNr(Integer channelNr) {
        replaceFirstProperty(new CHANNEL_NR(channelNr));
        return this;
    }
}
