package org.teleal.cling.transport.impl.apache;

import org.apache.http.HttpRequest;
import org.apache.http.MethodNotSupportedException;
import org.apache.http.RequestLine;
import org.apache.http.impl.DefaultHttpRequestFactory;
import org.apache.http.message.BasicHttpEntityEnclosingRequest;
import org.apache.http.message.BasicHttpRequest;

public class UpnpHttpRequestFactory extends DefaultHttpRequestFactory {
    private static final String[] BASIC = new String[]{"SUBSCRIBE", "UNSUBSCRIBE"};
    private static final String[] WITH_ENTITY = new String[]{"NOTIFY"};

    private static boolean isOneOf(String[] methods, String method) {
        for (String equalsIgnoreCase : methods) {
            if (equalsIgnoreCase.equalsIgnoreCase(method)) {
                return true;
            }
        }
        return false;
    }

    public HttpRequest newHttpRequest(RequestLine requestline) throws MethodNotSupportedException {
        if (requestline != null) {
            return newHttpRequest(requestline.getMethod(), requestline.getUri());
        }
        throw new IllegalArgumentException("Request line may not be null");
    }

    public HttpRequest newHttpRequest(String method, String uri) throws MethodNotSupportedException {
        if (isOneOf(BASIC, method)) {
            return new BasicHttpRequest(method, uri);
        }
        if (isOneOf(WITH_ENTITY, method)) {
            return new BasicHttpEntityEnclosingRequest(method, uri);
        }
        return super.newHttpRequest(method, uri);
    }
}
