package org.teleal.common.swingfwk.logging;

import java.util.Arrays;
import java.util.logging.Handler;
import java.util.logging.LogRecord;

public abstract class LoggingHandler extends Handler {
    public int sourcePathElements = 3;

    protected abstract void log(LogMessage logMessage);

    public LoggingHandler(int sourcePathElements) {
        this.sourcePathElements = sourcePathElements;
    }

    public void publish(LogRecord logRecord) {
        log(new LogMessage(logRecord.getLevel(), getSource(logRecord), logRecord.getMessage()));
    }

    public void flush() {
    }

    public void close() throws SecurityException {
    }

    protected String getSource(LogRecord record) {
        StringBuilder sb = new StringBuilder(180);
        String[] split = record.getSourceClassName().split("\\.");
        if (split.length > this.sourcePathElements) {
            split = (String[]) Arrays.copyOfRange(split, split.length - this.sourcePathElements, split.length);
        }
        for (String s : split) {
            sb.append(s).append(".");
        }
        sb.append(record.getSourceMethodName());
        return sb.toString();
    }
}
