package org.teleal.common.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;

public class MD5Crypt {
    private static final String SALTCHARS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
    private static final String itoa64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

    private static final String to64(long v, int size) {
        StringBuffer result = new StringBuffer();
        while (true) {
            size--;
            if (size < 0) {
                return result.toString();
            }
            result.append(itoa64.charAt((int) (63 & v)));
            v >>>= 6;
        }
    }

    private static final void clearbits(byte[] bits) {
        for (int i = 0; i < bits.length; i++) {
            bits[i] = (byte) 0;
        }
    }

    private static final int bytes2u(byte inp) {
        return inp & 255;
    }

    public static final String crypt(String password) {
        StringBuffer salt = new StringBuffer();
        Random rnd = new Random();
        while (salt.length() < 8) {
            int index = (int) (rnd.nextFloat() * ((float) SALTCHARS.length()));
            salt.append(SALTCHARS.substring(index, index + 1));
        }
        return crypt(password, salt.toString(), "$1$");
    }

    public static final String crypt(String password, String salt) {
        return crypt(password, salt, "$1$");
    }

    public static final String crypt(String password, String salt, String magic) {
        try {
            int i;
            MessageDigest ctx = MessageDigest.getInstance("md5");
            MessageDigest ctx1 = MessageDigest.getInstance("md5");
            if (salt.startsWith(magic)) {
                salt = salt.substring(magic.length());
            }
            if (salt.indexOf(36) != -1) {
                salt = salt.substring(0, salt.indexOf(36));
            }
            if (salt.length() > 8) {
                salt = salt.substring(0, 8);
            }
            ctx.update(password.getBytes());
            ctx.update(magic.getBytes());
            ctx.update(salt.getBytes());
            ctx1.update(password.getBytes());
            ctx1.update(salt.getBytes());
            ctx1.update(password.getBytes());
            byte[] finalState = ctx1.digest();
            for (int pl = password.length(); pl > 0; pl -= 16) {
                int i2;
                if (pl > 16) {
                    i2 = 16;
                } else {
                    i2 = pl;
                }
                ctx.update(finalState, 0, i2);
            }
            clearbits(finalState);
            for (i = password.length(); i != 0; i >>>= 1) {
                if ((i & 1) != 0) {
                    ctx.update(finalState, 0, 1);
                } else {
                    ctx.update(password.getBytes(), 0, 1);
                }
            }
            finalState = ctx.digest();
            i = 0;
            while (i < 1000) {
                try {
                    ctx1 = MessageDigest.getInstance("md5");
                    if ((i & 1) != 0) {
                        ctx1.update(password.getBytes());
                    } else {
                        ctx1.update(finalState, 0, 16);
                    }
                    if (i % 3 != 0) {
                        ctx1.update(salt.getBytes());
                    }
                    if (i % 7 != 0) {
                        ctx1.update(password.getBytes());
                    }
                    if ((i & 1) != 0) {
                        ctx1.update(finalState, 0, 16);
                    } else {
                        ctx1.update(password.getBytes());
                    }
                    finalState = ctx1.digest();
                    i++;
                } catch (NoSuchAlgorithmException e) {
                    return null;
                }
            }
            StringBuffer result = new StringBuffer();
            result.append(magic);
            result.append(salt);
            result.append("$");
            result.append(to64((long) (((bytes2u(finalState[0]) << 16) | (bytes2u(finalState[6]) << 8)) | bytes2u(finalState[12])), 4));
            result.append(to64((long) (((bytes2u(finalState[1]) << 16) | (bytes2u(finalState[7]) << 8)) | bytes2u(finalState[13])), 4));
            result.append(to64((long) (((bytes2u(finalState[2]) << 16) | (bytes2u(finalState[8]) << 8)) | bytes2u(finalState[14])), 4));
            result.append(to64((long) (((bytes2u(finalState[3]) << 16) | (bytes2u(finalState[9]) << 8)) | bytes2u(finalState[15])), 4));
            result.append(to64((long) (((bytes2u(finalState[4]) << 16) | (bytes2u(finalState[10]) << 8)) | bytes2u(finalState[5])), 4));
            result.append(to64((long) bytes2u(finalState[11]), 2));
            clearbits(finalState);
            return result.toString();
        } catch (NoSuchAlgorithmException ex) {
            System.err.println(ex);
            return null;
        }
    }

    public static boolean isEqual(String cleanPassword, String cryptedPassword) {
        String[] split = cryptedPassword.split("\\$");
        if (split.length == 4 && crypt(cleanPassword, split[2], "$" + split[1] + "$").equals(cryptedPassword)) {
            return true;
        }
        return false;
    }
}
