package org.teleal.common.util;

import java.lang.management.ManagementFactory;
import java.util.Arrays;

public class Threads {
    public static ThreadGroup getRootThreadGroup() {
        ThreadGroup tg = Thread.currentThread().getThreadGroup();
        while (true) {
            ThreadGroup ptg = tg.getParent();
            if (ptg == null) {
                return tg;
            }
            tg = ptg;
        }
    }

    public static Thread[] getAllThreads() {
        int n;
        Thread[] threads;
        ThreadGroup root = getRootThreadGroup();
        int nAlloc = ManagementFactory.getThreadMXBean().getThreadCount();
        do {
            nAlloc *= 2;
            threads = new Thread[nAlloc];
            n = root.enumerate(threads, true);
        } while (n == nAlloc);
        return (Thread[]) Arrays.copyOf(threads, n);
    }

    public static Thread getThread(long id) {
        for (Thread thread : getAllThreads()) {
            if (thread.getId() == id) {
                return thread;
            }
        }
        return null;
    }
}
