package org.teleal.common.xhtml;

import javax.xml.xpath.XPath;
import org.teleal.common.xhtml.XHTML.ELEMENT;
import org.teleal.common.xml.DOMElement.ArrayBuilder;
import org.w3c.dom.Element;

public class Head extends XHTMLElement {
    public Head(XPath xpath, Element element) {
        super(xpath, element);
    }

    public XHTMLElement getHeadTitle() {
        return (XHTMLElement) this.CHILD_BUILDER.firstChildOrNull(ELEMENT.title.name());
    }

    public Link[] getLinks() {
        return (Link[]) new ArrayBuilder<Link>(this) {
            public Link build(Element element) {
                return new Link(Head.this.getXpath(), element);
            }

            public Link[] newChildrenArray(int length) {
                return new Link[length];
            }
        }.getChildElements(ELEMENT.link.name());
    }

    public Meta[] getMetas() {
        return (Meta[]) new ArrayBuilder<Meta>(this) {
            public Meta build(Element element) {
                return new Meta(Head.this.getXpath(), element);
            }

            public Meta[] newChildrenArray(int length) {
                return new Meta[length];
            }
        }.getChildElements(ELEMENT.meta.name());
    }

    public XHTMLElement[] getDocumentStyles() {
        return (XHTMLElement[]) this.CHILD_BUILDER.getChildElements(ELEMENT.style.name());
    }

    public XHTMLElement[] getScripts() {
        return (XHTMLElement[]) this.CHILD_BUILDER.getChildElements(ELEMENT.script.name());
    }
}
