package org.teleal.common.xhtml;

import javax.xml.xpath.XPath;
import org.teleal.common.xhtml.XHTML.ELEMENT;
import org.teleal.common.xml.DOMElement.Builder;
import org.w3c.dom.Element;

public class Root extends XHTMLElement {
    public Root(XPath xpath, Element element) {
        super(xpath, element);
    }

    public Head getHead() {
        return (Head) new Builder<Head>(this) {
            public Head build(Element element) {
                return new Head(Root.this.getXpath(), element);
            }
        }.firstChildOrNull(ELEMENT.head.name());
    }

    public Body getBody() {
        return (Body) new Builder<Body>(this) {
            public Body build(Element element) {
                return new Body(Root.this.getXpath(), element);
            }
        }.firstChildOrNull(ELEMENT.body.name());
    }
}
