package org.teleal.common.xml;

import java.util.HashMap;
import java.util.Iterator;
import javax.xml.namespace.NamespaceContext;
import org.teleal.cling.model.message.header.EXTHeader;

public abstract class NamespaceContextMap extends HashMap<String, String> implements NamespaceContext {
    protected abstract String getDefaultNamespaceURI();

    public String getNamespaceURI(String prefix) {
        if (prefix == null) {
            throw new IllegalArgumentException("No prefix provided!");
        } else if (prefix.equals(EXTHeader.DEFAULT_VALUE)) {
            return getDefaultNamespaceURI();
        } else {
            if (get(prefix) != null) {
                return (String) get(prefix);
            }
            return EXTHeader.DEFAULT_VALUE;
        }
    }

    public String getPrefix(String namespaceURI) {
        return null;
    }

    public Iterator getPrefixes(String s) {
        return null;
    }
}
